/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2007. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  CFG                             1
#define  CFG_keithley                    2       /* callback function: cfghw_changeport */
#define  CFG_lpt                         3
#define  CFG_te01                        4       /* callback function: cfghw_changeport */
#define  CFG_DECORATION                  5
#define  CFG_usete01                     6       /* callback function: cfghw_usete01 */
#define  CFG_usekeithley                 7       /* callback function: cfghw_usekeithley */
#define  CFG_DECORATION_2                8
#define  CFG_done                        9       /* callback function: cfghw_done */
#define  CFG_DECORATION_3                10
#define  CFG_DECORATION_4                11

#define  PANEL                           2       /* callback function: mf_panelCB */
#define  PANEL_ledkeithley               2
#define  PANEL_ledte01                   3
#define  PANEL_ledsystem                 4
#define  PANEL_text                      5
#define  PANEL_TEXTMSG                   6
#define  PANEL_DECORATION                7
#define  PANEL_DECORATION_2              8

#define  PANEL_2                         3
#define  PANEL_2_CHECKBOX_2              2
#define  PANEL_2_CHECKBOX                3
#define  PANEL_2_RADIOBUTTON             4

#define  PCFGPNL                         4
#define  PCFGPNL_more                    2       /* callback function: pcfgf_more */
#define  PCFGPNL_default                 3       /* callback function: pcfgf_default */
#define  PCFGPNL_passport                4       /* callback function: pcfgf_passport */
#define  PCFGPNL_tcfgdone                5       /* callback function: pcfgf_tcfgdone */
#define  PCFGPNL_list                    6

#define  PINFO                           5
#define  PINFO_done                      2       /* callback function: pinfo_done */
#define  PINFO_text                      3

#define  SPLUG                           6
#define  SPLUG_list                      2       /* callback function: selplug_func */
#define  SPLUG_cancel                    3       /* callback function: cancelplug_func */
#define  SPLUG_select                    4       /* callback function: selplug_func */
#define  SPLUG_module                    5
#define  SPLUG_TEXTMSG                   6

#define  WP                              7
#define  WP_text                         2


     /* Menu Bars, Menus, and Menu Items: */

#define  bar                             1
#define  bar_system                      2
#define  bar_system_connect              3       /* callback function: mb_connect */
#define  bar_system_more                 4
#define  bar_system_more_SUBMENU         5
#define  bar_system_more_system          6       /* callback function: mb_init_system */
#define  bar_system_more_SEPARATOR_4     7
#define  bar_system_more_te01            8       /* callback function: mb_init_te01 */
#define  bar_system_more_keithley        9       /* callback function: mb_init_keithley */
#define  bar_system_SEPARATOR_5          10
#define  bar_system_syscfg               11      /* callback function: mb_syscfg */
#define  bar_system_SEPARATOR            12
#define  bar_system_log                  13      /* callback function: mb_log */
#define  bar_system_reporter             14      /* callback function: mb_report */
#define  bar_system_SEPARATOR_15         15
#define  bar_system_exit                 16      /* callback function: mb_exit */
#define  bar_module                      17
#define  bar_module_unselect             18      /* callback function: mbmod_unselect */
#define  bar_module_SEPARATOR_3          19
#define  bar_module_burnmcu              20      /* callback function: mbmod_burnmcu_main */
#define  bar_module_more                 21
#define  bar_module_more_SUBMENU         22
#define  bar_module_more_loadadsp        23      /* callback function: mbmod_loadadsp_special */
#define  bar_module_more_burnmcu         24      /* callback function: mbmod_burnmcu_special */
#define  bar_module_more_burnmcu_fuses   25      /* callback function: mbmod_burnmcu_fuses */
#define  bar_module_SEPARATOR_2          26
#define  bar_module_calibrate            27      /* callback function: mbmod_calibrate */
#define  bar_module_verify               28      /* callback function: mbmod_verify */
#define  bar_module_SEPARATOR_8          29
#define  bar_module_module               30      /* callback function: mbmod_cfgmodule */
#define  bar_module_vdevice              31      /* callback function: mbmod_vdevice */
#define  bar_module_SEPARATOR_7          32
#define  bar_module_init                 33      /* callback function: mbmod_init */
#define  bar_module_run                  34      /* callback function: mbmod_run */
#define  bar_plugin                      35
#define  bar_plugin_configure            36      /* callback function: mbplug_cfg */
#define  bar_plugin_SEPARATOR_9          37
#define  bar_plugin_view                 38      /* callback function: mbplug_view */
#define  bar_tools                       39
#define  bar_tools_te01                  40      /* callback function: mbtool_te01 */
#define  bar_tools_te01ext               41      /* callback function: mbtool_cfgte01ext */
#define  bar_tools_keithley              42      /* callback function: mbtool_keithley */
#define  bar_tools_SEPARATOR_10          43
#define  bar_tools_open                  44      /* callback function: mbtool_openmodule */
#define  bar_tools_SEPARATOR_14          45
#define  bar_tools_record                46      /* callback function: mbtool_record */
#define  bar_service                     47
#define  bar_service_view                48      /* callback function: mbs_view */
#define  bar_set                         49
#define  bar_set_env                     50      /* callback function: mbset_environment */
#define  bar_set_test                    51      /* callback function: mbset_tcondition */
#define  bar_set_SEPARATOR_16            52
#define  bar_set_ports                   53      /* callback function: mbset_ports */
#define  bar_help                        54
#define  bar_help_contents               55      /* callback function: mbhelp_contents */
#define  bar_help_SEPARATOR_18           56
#define  bar_help_plugin                 57      /* callback function: mbhelp_plugin */
#define  bar_help_manual                 58      /* callback function: mbhelp_manual */
#define  bar_help_SEPARATOR_21           59
#define  bar_help_module                 60
#define  bar_help_module_SUBMENU         61
#define  bar_help_module_descr           62      /* callback function: mbhelp_module_hw */
#define  bar_help_module_scheme          63      /* callback function: mbhelp_module_scheme */
#define  bar_help_module_SEPARATOR_6     64
#define  bar_help_module_cables          65      /* callback function: mbhelp_cables */
#define  bar_help_te01ext                66
#define  bar_help_te01ext_SUBMENU        67
#define  bar_help_te01ext_descr          68      /* callback function: mbhelp_te01ext_hw */
#define  bar_help_te01ext_scheme         69      /* callback function: mbhelp_te01ext_scheme */
#define  bar_help_SEPARATOR_19           70
#define  bar_help_about                  71      /* callback function: mbhelp_about */

#define  barold                          2
#define  barold_system                   2
#define  barold_system_connect           3       /* callback function: mb_connect */
#define  barold_system_more              4
#define  barold_system_more_SUBMENU      5
#define  barold_system_more_system       6       /* callback function: mb_init_system */
#define  barold_system_more_SEPARATOR_4  7
#define  barold_system_more_te01         8       /* callback function: mb_init_te01 */
#define  barold_system_more_keithley     9       /* callback function: mb_init_keithley */
#define  barold_system_SEPARATOR_5       10
#define  barold_system_syscfg            11      /* callback function: mb_syscfg */
#define  barold_system_SEPARATOR         12
#define  barold_system_log               13      /* callback function: mb_log */
#define  barold_system_reporter          14      /* callback function: mb_report */
#define  barold_system_SEPARATOR_15      15
#define  barold_system_exit              16      /* callback function: mb_exit */
#define  barold_module                   17
#define  barold_module_unselect          18      /* callback function: mbmod_unselect */
#define  barold_module_SEPARATOR_3       19
#define  barold_module_burn              20      /* callback function: mbmod_burn_main */
#define  barold_module_more              21
#define  barold_module_more_SUBMENU      22
#define  barold_module_more_loadadsp     23      /* callback function: mbmod_loadadsp_special */
#define  barold_module_more_burn         24      /* callback function: mbmod_burn_special */
#define  barold_module_SEPARATOR_2       25
#define  barold_module_calibrate         26      /* callback function: mbmod_calibrate */
#define  barold_module_verify            27      /* callback function: mbmod_verify */
#define  barold_module_SEPARATOR_8       28
#define  barold_module_module            29      /* callback function: mbmod_cfgmodule */
#define  barold_module_vdevice           30      /* callback function: mbmod_vdevice */
#define  barold_module_SEPARATOR_7       31
#define  barold_module_init              32      /* callback function: mbmod_init */
#define  barold_module_run               33      /* callback function: mbmod_run */
#define  barold_plugin                   34
#define  barold_plugin_configure         35      /* callback function: mbplug_cfg */
#define  barold_plugin_SEPARATOR_9       36
#define  barold_plugin_view              37      /* callback function: mbplug_view */
#define  barold_tools                    38
#define  barold_tools_te01               39      /* callback function: mbtool_te01 */
#define  barold_tools_te01ext            40      /* callback function: mbtool_cfgte01ext */
#define  barold_tools_keithley           41      /* callback function: mbtool_keithley */
#define  barold_tools_SEPARATOR_10       42
#define  barold_tools_open               43      /* callback function: mbtool_openmodule */
#define  barold_tools_SEPARATOR_14       44
#define  barold_tools_record             45      /* callback function: mbtool_record */
#define  barold_service                  46
#define  barold_service_osc              47      /* callback function: mbs_osc */
#define  barold_service_spectrum         48      /* callback function: mbs_spectrum */
#define  barold_service_voltmeter        49      /* callback function: mbs_voltmeter */
#define  barold_service_histogram        50      /* callback function: mbs_histogram */
#define  barold_service_timechart        51      /* callback function: mbs_timechart */
#define  barold_service_SEPARATOR_11     52
#define  barold_service_afr              53      /* callback function: mbs_afr */
#define  barold_service_SEPARATOR_12     54
#define  barold_service_dac              55      /* callback function: mbs_dac */
#define  barold_service_dio              56      /* callback function: mbs_dio */
#define  barold_service_SEPARATOR_13     57
#define  barold_service_view             58      /* callback function: mbs_view */
#define  barold_set                      59
#define  barold_set_env                  60      /* callback function: mbset_environment */
#define  barold_set_test                 61      /* callback function: mbset_tcondition */
#define  barold_set_SEPARATOR_16         62
#define  barold_set_ports                63      /* callback function: mbset_ports */
#define  barold_help                     64
#define  barold_help_contents            65      /* callback function: mbhelp_contents */
#define  barold_help_SEPARATOR_18        66
#define  barold_help_plugin              67      /* callback function: mbhelp_plugin */
#define  barold_help_manual              68      /* callback function: mbhelp_manual */
#define  barold_help_SEPARATOR_21        69
#define  barold_help_module              70
#define  barold_help_module_SUBMENU      71
#define  barold_help_module_descr        72      /* callback function: mbhelp_module_hw */
#define  barold_help_module_scheme       73      /* callback function: mbhelp_module_scheme */
#define  barold_help_module_SEPARATOR_6  74
#define  barold_help_module_cables       75      /* callback function: mbhelp_cables */
#define  barold_help_te01ext             76
#define  barold_help_te01ext_SUBMENU     77
#define  barold_help_te01ext_descr       78      /* callback function: mbhelp_te01ext_hw */
#define  barold_help_te01ext_scheme      79      /* callback function: mbhelp_te01ext_scheme */
#define  barold_help_SEPARATOR_19        80
#define  barold_help_about               81      /* callback function: mbhelp_about */


     /* Callback Prototypes: */ 

int  CVICALLBACK cancelplug_func(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cfghw_changeport(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cfghw_done(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cfghw_usekeithley(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cfghw_usete01(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
void CVICALLBACK mb_connect(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mb_exit(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mb_init_keithley(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mb_init_system(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mb_init_te01(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mb_log(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mb_report(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mb_syscfg(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbhelp_about(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbhelp_cables(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbhelp_contents(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbhelp_manual(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbhelp_module_hw(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbhelp_module_scheme(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbhelp_plugin(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbhelp_te01ext_hw(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbhelp_te01ext_scheme(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbmod_burn_main(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbmod_burn_special(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbmod_burnmcu_fuses(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbmod_burnmcu_main(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbmod_burnmcu_special(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbmod_calibrate(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbmod_cfgmodule(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbmod_init(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbmod_loadadsp_special(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbmod_run(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbmod_unselect(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbmod_vdevice(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbmod_verify(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbplug_cfg(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbplug_view(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbs_afr(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbs_dac(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbs_dio(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbs_histogram(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbs_osc(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbs_spectrum(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbs_timechart(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbs_view(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbs_voltmeter(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbset_environment(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbset_ports(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbset_tcondition(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbtool_cfgte01ext(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbtool_keithley(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbtool_openmodule(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbtool_record(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mbtool_te01(int menubar, int menuItem, void *callbackData, int panel);
int  CVICALLBACK mf_panelCB(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK pcfgf_default(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK pcfgf_more(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK pcfgf_passport(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK pcfgf_tcfgdone(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK pinfo_done(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK selplug_func(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
