#include "te01uir.h"
#include <userint.h>
#include "te01api.h"
#include <analysis.h>
#include <ansi_c.h>
//
TE01 *module;
//

static int TE01GetConfigurationEx(TE01 *X) {  // !!! ??? tmp
 int r= 0;
 BYTE aregs[15], j;
 
 for(j= 0; j<15; j++)  aregs[j]= X->aregs[j];
 
 r= TE01GetConfiguration(X);
 
 for(j= 0; j<15; j++)  X->aregs[j]= aregs[j];
 
 return r;
};

int pnl1=0, pnl2=0, pnl3=0, pnl4=0, pnl5=0, pnl6=0, pnl7=0, pnl9=0;
int RunFlag=0, StopFlag=0, OmmetrFlag=0, UGraphFlag=0, IGraphFlag=0;
int fformat=0, uformat=2, iformat=2, sel=0;
//
int signal_src_dst=2, signal_type=1;
WORD  min=0, max=0xFFFF, ram_start=0, ram_size=20000;
DWORD rom_start=0; 
//
char stt[300], fname[300];

//
 DWORD U[1024], I[1024];
 WORD  i_cnt_full, u_cnt_full;
 DWORD u_cnt, i_cnt, u_gcnt, i_gcnt;
 BYTE param[20]={0};
//FILE *frep=NULL;
int CVICALLBACK object(int, int, int, void*, int, int);
void InitP5(void);
void InitP6(void);
//************************************************************* 
//
//************************************************************* 
void InfoMessage(char *p, int flg)                                     
{                                                                      
 int n;                                                                
 GetNumListItems(pnl1, P1_MESSAGE_LIST, &n);                            
 if(n>1000) { DeleteListItem (pnl1, P1_MESSAGE_LIST, 0, n-999); n=999; } 
 if(flg && n) ReplaceListItem(pnl1, P1_MESSAGE_LIST, n-1, p, 0);        
         else InsertListItem(pnl1, P1_MESSAGE_LIST, n++, p, 0);         
 SetCtrlIndex(pnl1, P1_MESSAGE_LIST, n-1);   
 SetCtrlVal(pnl1, P1_REQ_TOTAL, module->ReqTotal);
 SetCtrlVal(pnl1, P1_REQ_BAD, module->ReqBad);
 SetCtrlVal(pnl1, P1_REQ_BAD_U, module->ReqBadU);
 SetCtrlVal(pnl1, P1_REQ_BAD_I, module->ReqBadI);
 SetCtrlVal(pnl1, P1_REQ_BAD_E, module->ReqBadE);
 if(module->state&IMODULE_OVERLOAD) 
 	SetCtrlAttribute(pnl1, P1_IMODULE_OVERLOAD, ATTR_TEXT_COLOR , 0xFF0000);
 ProcessSystemEvents();
}                                                                      
//************************************************************* 
// 
//************************************************************* 
int CONTROL[10]={P1_CANVAS, P1_MESSAGE_LIST, P1_DECORATION, P1_REQ_TOTAL, P1_REQ_BAD, P1_REQ_BAD_U, P1_REQ_BAD_I, P1_REQ_BAD_E, P1_COMN, P1_OPEN};
int CFLAGS[4]={P1_UCORRECTION, P1_ICORRECTION, P1_SCORRECTION, P1_FCORRECTION};
int   em_igroup[ 4]={P1_RADIO_IN1 , P1_RADIO_IN2 , P1_RADIO_IN3 , P1_RADIO_IN4 };
int   em_ogroup[ 4]={P1_RADIO_OUT1, P1_RADIO_OUT2, P1_RADIO_OUT3, P1_RADIO_OUT4};
int uadc_igroup[14]={P1_RADIO_U01, P1_RADIO_U02, P1_RADIO_U03, P1_RADIO_U04, P1_RADIO_U05,
                     P1_RADIO_U06, P1_RADIO_U07, P1_RADIO_U08, P1_RADIO_U09, P1_RADIO_U10,
                     P1_RADIO_U11, P1_RADIO_U12, P1_RADIO_U13, P1_RADIO_U14};
int iadc_igroup[ 4]={P1_RADIO_I00, P1_RADIO_I01, P1_RADIO_I02, P1_RADIO_I03};
//
int get_group_select(int panel, int *p, int n)
{
 int i, j;
 for(i=0; i<n; i++) {
	GetCtrlVal(panel, p[i], &j);
    if(j) break;
 }
 return i;
}
void set_group_select_index(int panel, int index, int *p, int n)
{
 int i;
 for(i=0; i<n; i++) 
	SetCtrlVal(panel, p[i], i==index);
}
int set_group_select_controlid(int panel, int controlid, int *p, int n)
{
 int i, k=0;
 for(i=0; i<n; i++) {
	SetCtrlVal(panel, p[i], p[i]==controlid);
    if(p[i]==controlid) k=i;
 }	
 return k;
}
Point XY[]={
//  ->  (U)
{ 160, 220}, { 172, 220}, { 172, 145}, { 190, 145},
//  ->  (U)
{ 160, 220}, { 172, 220}, { 172, 160}, { 190, 160},
//  ->  (U)
{ 160, 270}, { 178, 270}, { 178, 114}, { 190, 114},
//  ->  (2U)
{ 160, 270}, { 178, 270}, { 178, 128}, { 190, 128},
//  -> 
{ 160, 220}, { 172, 220}, { 172,   5}, { 433,   5}, { 433,  75}, { 450,  75},
//  ->  (+Us)
{ 160, 270}, { 178, 270}, { 178, 311}, { 433, 311}, { 433,  88}, { 450,  88},
//  ->  (-Us)												   
{ 160, 270}, { 178, 270}, { 178, 311}, { 433, 311}, { 433, 100}, { 450, 100},
//  I- (25 ) ->   
{ 450, 111}, { 433, 111}, { 433, 178}, { 634, 178}, { 634, 210},
//  I- (2.5 ) ->   
{ 450, 123}, { 433, 123}, { 433, 178}, { 634, 178}, { 634, 210},
//  I-  () ->   
{ 450, 134}, { 433, 134}, { 433, 178}, { 634, 178}, { 634, 210},
//  I- (0 ) ->   
{ 450, 148}, { 433, 148}, { 433, 178}, { 634, 178}, { 634, 210},
// -> 
{ 410, 113}, { 433, 113}, { 433, 159}, { 450, 159},
// -> 
{ 410, 128}, { 433, 128}, { 433, 159}, { 450, 159},
// -> 
{ 410, 144}, { 433, 144}, { 433, 159}, { 450, 159},
// -> 
{ 410, 161}, { 433, 161}, { 433, 159}, { 450, 159},
// -> 
{ 410, 200}, { 427, 200}, { 427, 232}, { 450, 232},
//  -> 
{ 160, 270}, { 178, 270}, { 178, 311}, { 433, 311}, { 433, 272}, { 450, 272}
};
//************************************************************* 
// 
//************************************************************* 
void Draw(Point *p, int n)
{
 while(n>1) {
	Point p1=p[0], p2=p[1];
	if(p1.y==p2.y) p2.x+=(p2.x>p1.x) ? -1 : 1;
	else if(p1.x==p2.x) p2.y+=(p2.y>p1.y) ? -1 : 1;
	CanvasDrawLine(pnl1, P1_CANVAS, p1, p2);
	n--;
	p++;
 }	
}
// ************************************************************* 
// 
// ************************************************************* 
void form_config()											  //
{															  //
 int i, j, k, l;											  //
 double d, e, f;			     				 			  //
    // fdac													  //
	GetCtrlVal(pnl1, P1_FDAC_RANGE   , &i);	                  // fdac_range
	GetCtrlVal(pnl1, P1_FDAC_BANDPASS, &j);                   // fdac_filter
	GetCtrlVal(pnl1, P1_FDAC_MIN, (void*)&d);	              // fdac_min
	GetCtrlVal(pnl1, P1_FDAC_MAX, (void*)&e);	              // fdac_max
	GetCtrlVal(pnl1, P1_SIGNAL_FREQ, &f);				      // signal_freq 
	GetCtrlVal(pnl1, P1_RAM_FREQ, &k);					      // ram_freq
 	l=f*ram_size/RAM_FREQ[k];								  // ram_step 
 	//														  //
	if(fformat==2) TE01SetFDACConfiguration(module, ram_size, l, k, i, j, d, e, FORMAT_VALUE);
			  else TE01SetFDACConfiguration(module, ram_size, l, k, i, j, (double)(*(WORD*)&d), (double)(*(WORD*)&e), FORMAT_CODE);
	// sdac													  //
	GetCtrlVal(pnl1, P1_SDAC_RANGE, &i);	                  // sdac_range
	GetCtrlVal(pnl1, P1_SDAC_VAL  , &d);					  // sdac_val
	TE01SetSDACConfiguration(module, i, d, FORMAT_VALUE);    // 
	// uadc													  //
	i=get_group_select(pnl1, uadc_igroup, 14);                // uadc_switch
	GetCtrlVal(pnl1, P1_UADC_RANGE , &j);	                  // uadc_range
	GetCtrlVal(pnl1, P1_UADC_FILTER, &d);               	  // uadc_filter
	TE01SetUADCConfiguration(module, i, j, ADC_FILTER_CONST/d);
	// iadc													  //
	i=get_group_select(pnl1, iadc_igroup, 4);                 // iadc_switch
	GetCtrlVal(pnl1, P1_IADC_RANGE , &j);	                  // iadc_range
	GetCtrlVal(pnl1, P1_IADC_FILTER, &d);               	  // uadc_filter
	TE01SetIADCConfiguration(module, i, j, ADC_FILTER_CONST/d);
	// emodule												  //
	if(module->bid==1) {										  //
		if(module->mid<4) param[0]=get_group_select(pnl1, em_igroup, 4);		 
		else {												  //
			int i, j;										  //
			GetCtrlVal(pnl1, P1_RELAY1, &i);				  //
			GetCtrlVal(pnl1, P1_RELAY2, &j);				  //
			param[0]=(i ? 1 : 0)|(j ? 2 : 0);				  //
		}													  //
		param[1]=get_group_select(pnl1, em_ogroup, 4);		  //
		GetCtrlVal(pnl1, P1_CHANNEL, param+2);				  //
// @BKL		TE01SetAModuleConfiguration(module, param); 		  //

//		if(!module->object) {								  //
//			GetCtrlVal(pnl1, P1_OBJECT_MIN, module->u_min);	  //	
//			GetCtrlVal(pnl1, P1_OBJECT_MAX, module->u_max);   //		
//		}													  //
	}														  //
}															  //
// ************************************************************* 
// 
// ************************************************************* 
void RedrawCanvas()
{
 int i, j;
 SetCtrlAttribute(pnl1, P1_CANVAS, ATTR_OVERLAPPED_POLICY, VAL_DEFER_DRAWING);
 SetCtrlAttribute(pnl1, P1_CANVAS, ATTR_PEN_MODE, VAL_COPY_MODE);
 SetCtrlAttribute(pnl1, P1_CANVAS, ATTR_PEN_STYLE, VAL_SOLID);
 SetCtrlAttribute (pnl1, P1_CANVAS, ATTR_PEN_WIDTH, 5);
 SetCtrlAttribute(pnl1, P1_CANVAS, ATTR_PEN_COLOR, 0x0000ff);
 CanvasClear(pnl1, P1_CANVAS, VAL_ENTIRE_OBJECT);
 // ****
 form_config();
 //    
 if(module->bid==1) {
	if(module->mid==1) {
		if(param[0]==2) Draw(XY, 4);   else if(param[0]==3) Draw(XY+4, 4);
		if(param[0]==0) Draw(XY+8, 4); else if(param[0]==1) Draw(XY+12, 4);
	} else  Draw(XY+8, 4);	
 }
 //   
 if(module->uadc_switch==2) Draw(&XY[16], 6);
 else if(module->uadc_switch==3) Draw(XY+22, 6);
 else if(module->uadc_switch==4) Draw(XY+28, 6);
 else if(module->uadc_switch==5) Draw(XY+34, 5);
 else if(module->uadc_switch==6) Draw(XY+39, 5);
 else if(module->uadc_switch==7) Draw(XY+44, 5);
 else if(module->uadc_switch==8) Draw(XY+49, 5);
 else if(module->uadc_switch==9 && module->bid) Draw(XY+54+4*param[1], 4);
 //   
 if(module->iadc_switch==1 && module->bid) Draw(XY+70, 4);
 else if(module->iadc_switch==3) Draw(XY+74, 6);
 //
 CanvasUpdate(pnl1, P1_CANVAS, VAL_ENTIRE_OBJECT);	
 //
}
// ************************************************************* 
// 
// ************************************************************* 
void show_config()											  //
{															  //
 int i, j, k, m, n;											  //
 char str[10];												  //
 double d, e;												  //
	// ram													  //
	TE01GetFDACConfiguration(module, &i, &j, &k,  &m, &n,  &d, &e, fformat==2 ? FORMAT_VALUE : FORMAT_CODE);
	if(fformat==2) {										  //
		SetCtrlAttribute(pnl1, P1_FDAC_MIN, ATTR_LABEL_TEXT, ".,");
		SetCtrlAttribute(pnl1, P1_FDAC_MAX, ATTR_LABEL_TEXT, ".,");
		SetCtrlAttribute(pnl1, P1_FDAC_MIN, ATTR_DATA_TYPE, VAL_DOUBLE);
		SetCtrlAttribute(pnl1, P1_FDAC_MAX, ATTR_DATA_TYPE, VAL_DOUBLE);
		SetCtrlAttribute(pnl1, P1_FDAC_MIN, ATTR_PRECISION, 2);
		SetCtrlAttribute(pnl1, P1_FDAC_MAX, ATTR_PRECISION, 2);
		SetCtrlVal(pnl1, P1_FDAC_MIN, d);					  //
		SetCtrlVal(pnl1, P1_FDAC_MAX, e);					  //
		//													  //
		SetCtrlAttribute(pnl1, P1_FDAC_MIN_2, ATTR_LABEL_TEXT, ".,");
		SetCtrlAttribute(pnl1, P1_FDAC_MAX_2, ATTR_LABEL_TEXT, ".,");
		SetCtrlAttribute(pnl1, P1_FDAC_MIN_2, ATTR_DATA_TYPE, VAL_DOUBLE);
		SetCtrlAttribute(pnl1, P1_FDAC_MAX_2, ATTR_DATA_TYPE, VAL_DOUBLE);
		SetCtrlAttribute(pnl1, P1_FDAC_MIN_2, ATTR_PRECISION, 2);
		SetCtrlAttribute(pnl1, P1_FDAC_MAX_2, ATTR_PRECISION, 2);
		SetCtrlVal(pnl1, P1_FDAC_MIN_2, m&1 ? d : d/2);
		SetCtrlVal(pnl1, P1_FDAC_MAX_2, m&1 ? e : e/2);
	} else {  												  //
		SetCtrlAttribute(pnl1, P1_FDAC_MIN, ATTR_LABEL_TEXT, ".,");
		SetCtrlAttribute(pnl1, P1_FDAC_MAX, ATTR_LABEL_TEXT, ".,");
		SetCtrlAttribute(pnl1, P1_FDAC_MIN, ATTR_DATA_TYPE, VAL_UNSIGNED_SHORT_INTEGER);
		SetCtrlAttribute(pnl1, P1_FDAC_MAX, ATTR_DATA_TYPE, VAL_UNSIGNED_SHORT_INTEGER);
		SetCtrlAttribute(pnl1, P1_FDAC_MIN, ATTR_FORMAT, fformat ? VAL_DECIMAL_FORMAT : VAL_HEX_FORMAT);
		SetCtrlAttribute(pnl1, P1_FDAC_MAX, ATTR_FORMAT, fformat ? VAL_DECIMAL_FORMAT : VAL_HEX_FORMAT);
		SetCtrlVal(pnl1, P1_FDAC_MIN, (WORD)d); 			  //
		SetCtrlVal(pnl1, P1_FDAC_MAX, (WORD)e); 			  //
		//													  //
		SetCtrlAttribute(pnl1, P1_FDAC_MIN_2, ATTR_LABEL_TEXT, ".,");
		SetCtrlAttribute(pnl1, P1_FDAC_MAX_2, ATTR_LABEL_TEXT, ".,");
		SetCtrlAttribute(pnl1, P1_FDAC_MIN_2, ATTR_DATA_TYPE, VAL_UNSIGNED_SHORT_INTEGER);
		SetCtrlAttribute(pnl1, P1_FDAC_MAX_2, ATTR_DATA_TYPE, VAL_UNSIGNED_SHORT_INTEGER);
		SetCtrlAttribute(pnl1, P1_FDAC_MIN_2, ATTR_FORMAT, fformat ? VAL_DECIMAL_FORMAT : VAL_HEX_FORMAT);
		SetCtrlAttribute(pnl1, P1_FDAC_MAX_2, ATTR_FORMAT, fformat ? VAL_DECIMAL_FORMAT : VAL_HEX_FORMAT);
		SetCtrlVal(pnl1, P1_FDAC_MIN_2, (WORD)d); 			  //
		SetCtrlVal(pnl1, P1_FDAC_MAX_2, (WORD)e); 			  //
	}														  //
	SetCtrlVal(pnl1, P1_RAM_FREQ, k);						  // ram_freq
	SetCtrlVal(pnl1, P1_RAM_SAMPLES, (double)i/j);  		  // ram_samples
	SetCtrlVal(pnl1, P1_SIGNAL_FREQ, RAM_FREQ[k]*j/i);		  // signal_freq
	SetCtrlAttribute(pnl1, P1_SIGNAL_FREQ, ATTR_MAX_VALUE, RAM_FREQ[k]);
	SetCtrlAttribute(pnl1, P1_SIGNAL_FREQ, ATTR_INCR_VALUE, (double)RAM_FREQ[k]/i);
    // fdac
	SetCtrlVal(pnl1, P1_FDAC_RANGE   , m);	                  // fdac_range
	SetCtrlVal(pnl1, P1_FDAC_BANDPASS, n);                    // fdac_filter
	// sdac													  //
	TE01GetSDACConfiguration(module, &i, &d, FORMAT_VALUE);	  //
	SetCtrlVal(pnl1, P1_SDAC_RANGE, i);	                      // sdac_range
	SetCtrlAttribute(pnl1, P1_SDAC_VAL, ATTR_DIMMED, i==3);   //
	if(module->sdac_range!=3) {								  //
		SetCtrlAttribute(pnl1, P1_SDAC_VAL, ATTR_MAX_VALUE, +SDAC_RANGE[i]);
		SetCtrlAttribute(pnl1, P1_SDAC_VAL, ATTR_MIN_VALUE, -SDAC_RANGE[i]);
		SetCtrlAttribute(pnl1, P1_SDAC_VAL, ATTR_INCR_VALUE, 2*SDAC_RANGE[i]/0xFFFF);
		SetCtrlVal(pnl1, P1_SDAC_VAL, d);                     // sdac_val 
	}														  //
	// uadc													  //
	TE01GetUADCConfiguration(module, &i, &j, &k);			  //
	set_group_select_index(pnl1, i, uadc_igroup, 14);		  // uadc_switch
	SetCtrlVal(pnl1, P1_UADC_RANGE, j);	                      // uadc_range
	SetCtrlVal(pnl1, P1_UADC_FILTER, ADC_FILTER_CONST/k);     // uadc_filter          	   
	// iadc													  //
	TE01GetIADCConfiguration(module, &i, &j, &k);			  //
	set_group_select_index(pnl1, i, iadc_igroup, 4);		  // iadc_switch
	SetCtrlVal(pnl1, P1_IADC_RANGE, j);	                      // iadc_range
	SetCtrlVal(pnl1, P1_IADC_FILTER, ADC_FILTER_CONST/k);     // iadc_filter	          	   
	// emodule
	if(module->bid) sprintf(stt, "  BID=%i, MID=%i", module->bid, module->mid);
	          else sprintf(stt, "  "); 
	SetCtrlVal(pnl1, P1_BID_MID, stt); 
	//
	if(module->bid==1) {
		int i;
		GetCtrlAttribute(pnl1, P1_CANVAS, ATTR_ZPLANE_POSITION, &i);
		SetCtrlAttribute(pnl1, P1_MDECORATION, ATTR_ZPLANE_POSITION, i-1);
     	TE01GetAModuleConfiguration(module, param);
		//
		SetCtrlAttribute(pnl1, P1_CHANNEL, ATTR_VISIBLE, module->mid>1);
		if(module->mid>1) {
			DeleteListItem (pnl1, P1_CHANNEL, 0, -1);
			InsertListItem (pnl1, P1_CHANNEL, 0, " ", 0);
			InsertListItem (pnl1, P1_CHANNEL, 1, module->mid==2 ? "  1,  2" : " 1", 1);
			InsertListItem (pnl1, P1_CHANNEL, 2, module->mid==2 ? "  3,  4" : " 2", 2);
			InsertListItem (pnl1, P1_CHANNEL, 3, module->mid==2 ? "  5,  6" : " 3", 3);
			InsertListItem (pnl1, P1_CHANNEL, 4, module->mid==2 ? "  7,  8" : " 4", 4);
			InsertListItem (pnl1, P1_CHANNEL, 5, module->mid==2 ? "  9, 10" : " 5", 5);
			InsertListItem (pnl1, P1_CHANNEL, 6, module->mid==2 ? " 11, 12" : " 6", 6);
			InsertListItem (pnl1, P1_CHANNEL, 7, module->mid==2 ? " 13, 14" : " 7", 7);
			InsertListItem (pnl1, P1_CHANNEL, 8, module->mid==2 ? " 15, 16" : " 8", 8);
			SetCtrlVal(pnl1, P1_CHANNEL, param[2]);
		}
		//
//		DeleteListItem (pnl1, P1_OBJECT, 0, -1); 
//		for(i=j=0; i<NOBJECTS; i++) 
//			if(OBJECTS[i].bid==module->bid && OBJECTS[i].mid==module->mid)  
//				InsertListItem(pnl1, P1_OBJECT, j, OBJECTS[i].str, OBJECTS[i].object);
//		InsertListItem(pnl1, P1_OBJECT, j, "", 0);
//		SetCtrlVal(pnl1, P1_OBJECT, module->object);
//		object(pnl1, P1_OBJECT, EVENT_COMMIT, NULL, 0, 0);
		//
		SetCtrlAttribute(pnl1, P1_RADIO_IN2, ATTR_VISIBLE, module->mid==1);
		SetCtrlAttribute(pnl1, P1_RADIO_IN3, ATTR_VISIBLE, module->mid==1);
		SetCtrlAttribute(pnl1, P1_RADIO_IN4, ATTR_VISIBLE, module->mid==1);
		set_group_select_index(pnl1, module->mid==1 ? param[0] : 0, em_igroup, 4); 
		//
		SetCtrlAttribute(pnl1, P1_RELAY1, ATTR_VISIBLE, module->mid==4);
		SetCtrlAttribute(pnl1, P1_RELAY2, ATTR_VISIBLE, module->mid==4);
		SetCtrlVal(pnl1, P1_RELAY1, param[0]&1 ? 1 : 0);
		SetCtrlVal(pnl1, P1_RELAY2, param[0]&2 ? 1 : 0);
		//
		SetCtrlAttribute(pnl1, P1_RADIO_OUT2, ATTR_VISIBLE, module->mid==1);
		SetCtrlAttribute(pnl1, P1_RADIO_OUT3, ATTR_VISIBLE, module->mid==1);
		set_group_select_index(pnl1, param[1], em_ogroup, 4);
		//
		sprintf(stt, "%.221s", module->amodule_eeprom.comment);
		ResetTextBox(pnl1, P1_TEXTBOX, stt);
	} else SetCtrlAttribute(pnl1, P1_MDECORATION, ATTR_ZPLANE_POSITION, 0);
	for(i=0; i<4; i++) SetCtrlVal(pnl1, CFLAGS[i], (module->cflags>>i)&1);
	//
    TE01GetUModuleSerialNumber(module, str);
    sprintf(stt, "  U- (s\\n : %s)", str);
	SetCtrlVal(pnl1, P1_USERIAL, stt);
	TE01GetIModuleSerialNumber(module, str);
    sprintf(stt, "  I- (s\\n : %s)", str);
	SetCtrlVal(pnl1, P1_ISERIAL, stt);
	//
    GetCtrlAttribute(pnl1, P1_DECORATION_6, ATTR_FRAME_COLOR, &i);
    SetCtrlAttribute(pnl1, P1_UMODULE_OVERLOAD, ATTR_TEXT_COLOR, i); 
    GetCtrlAttribute(pnl1, P1_DECORATION_7, ATTR_FRAME_COLOR, &i);
    SetCtrlAttribute(pnl1, P1_IMODULE_OVERLOAD, ATTR_TEXT_COLOR, i); 
	//
	RedrawCanvas();
}
//************************************************************* 
//
//************************************************************* 
void set_signal_config()
{
 if(pnl4) {
	SetCtrlVal(pnl4, P4_SRC_DST, signal_src_dst);
	SetCtrlVal(pnl4, P4_SIGNAL , signal_type);
	SetCtrlVal(pnl4, P4_SIGNAL_MAX, max);
	SetCtrlVal(pnl4, P4_SIGNAL_MIN, min);
	SetCtrlVal(pnl4, P4_RAM_START , ram_start);
	SetCtrlVal(pnl4, P4_ROM_START , rom_start);
	SetCtrlVal(pnl4, P4_SIZE      , ram_size);
	SetCtrlAttribute(pnl4, P4_SIGNAL    , ATTR_DIMMED, signal_src_dst>1);	
	SetCtrlAttribute(pnl4, P4_SIGNAL_MIN, ATTR_DIMMED, signal_src_dst>1 || !signal_type);	
	SetCtrlAttribute(pnl4, P4_SIGNAL_MAX, ATTR_DIMMED, signal_src_dst>1);	
	SetCtrlAttribute(pnl4, P4_SIGNAL_MAX, ATTR_LABEL_TEXT, signal_type ? "" : "");
	SetCtrlAttribute(pnl4, P4_RAM_START , ATTR_DIMMED, signal_src_dst==1);	
	SetCtrlAttribute(pnl4, P4_ROM_START , ATTR_DIMMED, signal_src_dst==0);	
 }
}
void get_signal_config()
{
 if(pnl4) {
	GetCtrlVal(pnl4, P4_SRC_DST, &signal_src_dst);
	GetCtrlVal(pnl4, P4_SIGNAL , &signal_type);
	GetCtrlVal(pnl4, P4_SIGNAL_MAX, &max);					   
	GetCtrlVal(pnl4, P4_SIGNAL_MIN, &min);
	GetCtrlVal(pnl4, P4_RAM_START , &ram_start);
	GetCtrlVal(pnl4, P4_ROM_START , &rom_start);
	GetCtrlVal(pnl4, P4_SIZE      , &ram_size);   		    
 }	
}
//************************************************************* 
//                       
//************************************************************* 
void te01main(void *handle) {
 int i;
 
 module= (TE01 *)handle;
 if((pnl1=LoadPanel (0, "te01\\te01uir.uir", P1))>0) { 
	for(i=0; i<10; i++) SetCtrlAttribute(pnl1, CONTROL[i], ATTR_ZPLANE_POSITION, 0);
	CanvasClear(pnl1, P1_CANVAS, VAL_ENTIRE_OBJECT);
	//
	
    SetCtrlAttribute(pnl1, P1_CANVAS, ATTR_ZPLANE_POSITION, 400);
	DisplayPanel(pnl1);
	
    get_config(-1, -1, EVENT_COMMIT, NULL, 0, 0);
    set_config(-1, -1, EVENT_COMMIT, NULL, 0, 0);
	// show_config();	
	

 	
 }	
}
//************************************************************* 
//			           
//************************************************************* 
int CVICALLBACK p1_close(int panel, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_CLOSE :
			// QuitUserInterface(0);
			DiscardPanel(pnl1); 
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
void InitP2(void) 
{
 int w, h;
	GetPanelAttribute(pnl2, ATTR_WIDTH, &w);
	GetPanelAttribute(pnl2, ATTR_HEIGHT, &h);
	if(w>95) w-=95;
	if(UGraphFlag && IGraphFlag) h/=2;
	//			
	SetCtrlVal(pnl2, P2_UTYPE, UGraphFlag); 
	SetCtrlAttribute(pnl2, P2_USTRIP, ATTR_VISIBLE, UGraphFlag==1);
	SetCtrlAttribute(pnl2, P2_USTRIP, ATTR_TOP, 0);
	SetCtrlAttribute(pnl2, P2_USTRIP, ATTR_WIDTH, w);
	SetCtrlAttribute(pnl2, P2_USTRIP, ATTR_HEIGHT, h);
	SetCtrlAttribute(pnl2, P2_UGRAPH, ATTR_VISIBLE, UGraphFlag==2);
	SetCtrlAttribute(pnl2, P2_UGRAPH, ATTR_TOP, 0);
	SetCtrlAttribute(pnl2, P2_UGRAPH, ATTR_WIDTH, w);
	SetCtrlAttribute(pnl2, P2_UGRAPH, ATTR_HEIGHT, h);
	SetCtrlAttribute(pnl2, P2_UTYPE, ATTR_VISIBLE, UGraphFlag!=0);
	SetCtrlAttribute(pnl2, P2_UTYPE, ATTR_TOP, 20);
	SetCtrlAttribute(pnl2, P2_UTYPE, ATTR_LEFT, w);
	SetCtrlAttribute(pnl2, P2_USCALE, ATTR_VISIBLE, UGraphFlag!=0);
	SetCtrlAttribute(pnl2, P2_USCALE, ATTR_TOP, 55); 
	SetCtrlAttribute(pnl2, P2_USCALE, ATTR_LEFT, w+7);
	//
	SetCtrlVal(pnl2, P2_ITYPE, IGraphFlag); 
	SetCtrlAttribute(pnl2, P2_ISTRIP, ATTR_VISIBLE, IGraphFlag==1);
	SetCtrlAttribute(pnl2, P2_ISTRIP, ATTR_TOP, UGraphFlag ? h : 0);
	SetCtrlAttribute(pnl2, P2_ISTRIP, ATTR_WIDTH, w);
	SetCtrlAttribute(pnl2, P2_ISTRIP, ATTR_HEIGHT, h);
	SetCtrlAttribute(pnl2, P2_IGRAPH, ATTR_VISIBLE, IGraphFlag==2);
	SetCtrlAttribute(pnl2, P2_IGRAPH, ATTR_TOP, UGraphFlag ? h : 0);
	SetCtrlAttribute(pnl2, P2_IGRAPH, ATTR_WIDTH, w);
	SetCtrlAttribute(pnl2, P2_IGRAPH, ATTR_HEIGHT, h);
	SetCtrlAttribute(pnl2, P2_ITYPE, ATTR_TOP, 20+(UGraphFlag ? h : 0));
	SetCtrlAttribute(pnl2, P2_ITYPE, ATTR_LEFT, w);
	SetCtrlAttribute(pnl2, P2_ITYPE, ATTR_VISIBLE, IGraphFlag!=0);
	SetCtrlAttribute(pnl2, P2_ISCALE, ATTR_VISIBLE, IGraphFlag!=0);
	SetCtrlAttribute(pnl2, P2_ISCALE, ATTR_TOP, 55+(UGraphFlag ? h : 0)); 
	SetCtrlAttribute(pnl2, P2_ISCALE, ATTR_LEFT, w+7);
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK panel_load(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
 int i, j;
	switch (event) {
		case EVENT_COMMIT :      
			switch(control) { 
				case P1_SIGNAL :
					if((pnl4=LoadPanel(0, "te01\\te01uir.uir", P4))>0) { 
						set_signal_config();
						InstallPopup(pnl4);
					} else InfoMessage("\033fgff0000>>    \" \"", 0);
				break;
				case P1_TEST :
					if((pnl5=LoadPanel(0, "te01\\te01uir.uir", P5))>0) {
						InitP5();
						InstallPopup(pnl5);
					} else InfoMessage("\033fgff0000>>    \"\"", 0);
				break;
				case P1_CALIBRATION :
					if((pnl6=LoadPanel(0, "te01\\te01uir.uir", P6))>0) {
						InitP6();
						InstallPopup(pnl6);
					} else InfoMessage("\033fgff0000>>    \"\"", 0);
				break;
				case P1_UGRAPH :
				case P1_IGRAPH :
					GetCtrlVal(pnl1, P1_UGRAPH, &i);	
					GetCtrlVal(pnl1, P1_IGRAPH, &j);	
					if(i || j) 
						if(pnl2>0 || (pnl2=LoadPanel(0, "te01\\te01uir.uir", P2))>0) {
							if(i) { if(!UGraphFlag) UGraphFlag=1; }
							else UGraphFlag=0;
							if(j) { if(!IGraphFlag) IGraphFlag=1; }
							else IGraphFlag=0; 
							InitP2(); 
							DisplayPanel(pnl2);
						} else InfoMessage("\033fgff0000>>   ", 0);
					else {
						DiscardPanel(pnl2);
						UGraphFlag=IGraphFlag=0;
						pnl2=0;
					}	
				break;
			}	
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK panel_close(int panel, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_CLOSE :
			if(RunFlag) StopFlag=1;
			else {
				if(panel==pnl4) get_signal_config();
				DiscardPanel(panel);
				if(pnl2==panel) {
					SetCtrlVal(pnl1, P1_UGRAPH, UGraphFlag=0);
					SetCtrlVal(pnl1, P1_IGRAPH, IGraphFlag=0);
					pnl2=0;
				} else if(pnl3==panel) pnl3=0;
				else if(pnl4==panel) pnl4=0;
				else if(pnl5==panel) pnl5=0;
				else if(pnl7==panel) pnl7=0;
			}	
		break;
		case EVENT_PANEL_SIZE :
			if(panel==pnl2) InitP2();
		break;
		case EVENT_LOST_FOCUS:
			if(panel==pnl9) { 
				DiscardPanel(pnl9);
				pnl9=0;
			}	
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK panel_cancel(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT:
			panel_close(panel, EVENT_CLOSE, callbackData, eventData1, eventData2);
		break;
	}
 return 0;
}
//************************************************************* 
// 		       / 
//************************************************************* 
int CVICALLBACK open_interface(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
  return 0;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK src_dst(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT:										   
			GetCtrlVal(pnl4, P4_SRC_DST, &signal_src_dst);
			GetCtrlVal(pnl4, P4_SIGNAL , &signal_type);
			//
			SetCtrlAttribute(pnl4, P4_SIGNAL    , ATTR_DIMMED, signal_src_dst>1);	
			SetCtrlAttribute(pnl4, P4_SIGNAL_MIN, ATTR_DIMMED, signal_src_dst>1 || !signal_type);	
			SetCtrlAttribute(pnl4, P4_SIGNAL_MAX, ATTR_DIMMED, signal_src_dst>1);	
			SetCtrlAttribute(pnl4, P4_SIGNAL_MAX, ATTR_LABEL_TEXT, signal_type ? "" : "");
			SetCtrlAttribute(pnl4, P4_RAM_START , ATTR_DIMMED, signal_src_dst==1 || signal_src_dst==5);	
			SetCtrlAttribute(pnl4, P4_ROM_START , ATTR_DIMMED, signal_src_dst==0 || signal_src_dst==4);	
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int progress(char *str)
{
 char tmp[256];
 sprintf(tmp, "\033fg0000ff>> %s", str);
 InfoMessage(tmp, 1);
 return StopFlag;
}
//************************************************************* 
// 
//************************************************************* 
int tx_signal()
{
 int k;
 WORD *buf;
	RunFlag=1;
	StopFlag=0;
	
 if((buf=malloc(ram_size*sizeof(WORD)))==NULL) InfoMessage("\033fgff0000>>   ", 0);
 else {
	switch(signal_src_dst) {
		case 0 :
		case 1 :
			switch(signal_type) {
				case 0 : //**** 
					for(k=0; k<ram_size; k++) buf[k]=max;
				break;
				case 1 : //****  
					for(k=0; k<ram_size; k++)
						buf[k]=sin(k*2*3.141592/ram_size)*(max-min)/2+(max+min)/2+0.5;
				break;
				case 2 : //**** 
					for(k=0; k<ram_size; k++) buf[k]=(k<(ram_size/2)) ? min : max;
				break;
			}
			if(signal_src_dst==0) {
				InfoMessage("\033fg0000ff>>     .", 0);
				InfoMessage("", 0);
				if(TE01WriteMemoryRandom(module, ram_start, ram_size, buf, progress)) 
					sprintf(stt, "\033fgff0000>> %s", TE01GetAPIMessage());
				else sprintf(stt, "\033fg0000ff>> %s", TE01GetAPIMessage());	
				InfoMessage(stt, 1);
			} else {
				InfoMessage("\033fg0000ff>>     .  ", 0);
				InfoMessage("", 0);
				if(TE01WriteMemoryRandom(module, rom_start|0x100000, ram_size, buf, progress))
				  	 sprintf(stt, "\033fgff0000>> %s", TE01GetAPIMessage()); 
				else sprintf(stt, "\033fg0000ff>> %s", TE01GetAPIMessage());  
				InfoMessage(stt, 1);
			}
		break;
		case 2 :
			InfoMessage("\033fg0000ff>>        ", 0);				
			if(TE01LoadRAMFromEEPROM(module, rom_start, ram_start, ram_size)) 
				InfoMessage("\033fgff0000>>         ", 1);								
			else InfoMessage("\033fg0000ff>>        ", 1);				
		break;
		case 3 :
			InfoMessage("\033fg0000ff>>        ", 0);				
			if(TE01SaveRAMToEEPROM(module, ram_start, rom_start, ram_size)) 
				InfoMessage("\033fgff0000>>         ", 1);								
			else InfoMessage("\033fg0000ff>>        ", 1);				
		break;
		case 4 :
			InfoMessage("\033fg0000ff>>     .", 0);
			InfoMessage("", 0);
			if(TE01ReadMemoryRandom(module, ram_start, ram_size, buf, progress)) 
				sprintf(stt, "\033fgff0000>> %s", TE01GetAPIMessage());
			else if(pnl7>0 || (pnl7=LoadPanel(0, "te01\\te01uir.uir", P7))>0) {
				DisplayPanel(pnl7);	
				SetPanelAttribute(pnl7, ATTR_TITLE, "  ");
				PlotWaveform(pnl7, P7_GRAPH, buf, ram_size, VAL_UNSIGNED_SHORT_INTEGER, 1.0, 0.0, 0.0, 1.0, VAL_THIN_LINE, VAL_EMPTY_SQUARE, VAL_SOLID, 1, 0x0000FF);
				sprintf(stt, "\033fg0000ff>> %s", TE01GetAPIMessage());	
			} else sprintf(stt, "\033fgff0000>>   .");	
			InfoMessage(stt, 1);
		break;
		case 5 :
			InfoMessage("\033fg0000ff>>     .", 0);
			InfoMessage("", 0);
			if(TE01ReadMemoryRandom(module, rom_start|0x100000, ram_size, buf, progress)) 
				sprintf(stt, "\033fgff0000>> %s", TE01GetAPIMessage());
			else if(pnl7>0 || (pnl7=LoadPanel(0, "te01\\te01uir.uir", P7))>0) {
				DisplayPanel(pnl7);	
				SetPanelAttribute(pnl7, ATTR_TITLE, "  ");
				PlotWaveform(pnl7, P7_GRAPH, buf, ram_size, VAL_UNSIGNED_SHORT_INTEGER, 1.0, 0.0, 0.0, 1.0, VAL_THIN_LINE, VAL_EMPTY_SQUARE, VAL_SOLID, 1, 0x0000FF);
				sprintf(stt, "\033fg0000ff>> %s", TE01GetAPIMessage());	
			} else sprintf(stt, "\033fgff0000>>   .");	
			InfoMessage(stt, 1);
		break;
	
	}
	free(buf); 
 }
 RunFlag=0;
 return 0;
}
//
int CVICALLBACK trsm_signal(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
 int i, j, k;
 WORD  *buf;
	switch (event) {
		case EVENT_COMMIT:
			if(!RunFlag) {
				get_signal_config();
				tx_signal();
				if(!StopFlag) {
				    DiscardPanel(pnl4);
					pnl4=0;
				}	
			} else StopFlag=1;	
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK signal_freq(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{															 //
 int i, j;													 //
 double f, s;							    				 //
	switch (event) {										 //
		case EVENT_VAL_CHANGED:								     //
		    GetCtrlVal(pnl1, P1_RAM_FREQ, &i);               // ram_freq
			GetCtrlVal(pnl1, P1_SIGNAL_FREQ, &f);			 // signal_freq
			s=RAM_FREQ[i]/ram_size;							 // signal_freq_step
			f=f>RAM_FREQ[i] ? RAM_FREQ[i] :  ((int)(f/s+0.5))*s;  //
			SetCtrlAttribute(pnl1, P1_SIGNAL_FREQ, ATTR_MAX_VALUE, RAM_FREQ[i]);
			SetCtrlAttribute(pnl1, P1_SIGNAL_FREQ, ATTR_INCR_VALUE, s);
			SetCtrlVal(pnl1, P1_SIGNAL_FREQ, f);			 //
			SetCtrlVal(pnl1, P1_RAM_SAMPLES, RAM_FREQ[i]/f); //
/*			
			GetCtrlVal(pnl1, P1_SIGNAL_FREQ, &f);			 // signal_freq
		 	if(control==P1_SIGNAL_FREQ) {					 //
			 	int k;										 //
			 	double d;									 //
			 	i=0;										 //
			 	j=f*ram_size/RAM_FREQ[0];					 //
		 		d=abs(f-RAM_FREQ[0]*j/ram_size);             //
			 	for(k=1; k<4; k++)	{	 		     		 //
			 		int l=f*ram_size/RAM_FREQ[k];       	 // step
		 			double e=abs(f-RAM_FREQ[k]*l/ram_size);  //
		 			if(l<ram_size && d>l) { i=k; j=l; }      // ram_freq, ram_step
				}											 //
			} 												 //
		    SetCtrlVal(pnl1, P1_RAM_FREQ, i);                // ram_freq
			SetCtrlVal(pnl1, P1_RAM_SAMPLES, (double)ram_size/j);// ram_samples
			SetCtrlVal(pnl1, P1_SIGNAL_FREQ, RAM_FREQ[i]*j/ram_size);
			SetCtrlAttribute(pnl1, P1_SIGNAL_FREQ, ATTR_INCR_VALUE, (double)RAM_FREQ[i]/ram_size);
*/
		break;												 //
	}														 //
 return 0;													 //
}															 //
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK sdac_range_changed(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{															 //
 int i;														 //
 double d;													 //
	switch (event) {										 //
		case EVENT_COMMIT:									 //
			TE01GetSDACConfiguration(module, &i, &d, FORMAT_VALUE);
			GetCtrlVal(pnl1, P1_SDAC_RANGE, &i);             // sdac_range   
			TE01SetSDACConfiguration(module, i, d, FORMAT_VALUE);
			SetCtrlAttribute(pnl1, P1_SDAC_VAL, ATTR_MAX_VALUE , +SDAC_RANGE[i]);
			SetCtrlAttribute(pnl1, P1_SDAC_VAL, ATTR_MIN_VALUE , -SDAC_RANGE[i]);
			SetCtrlAttribute(pnl1, P1_SDAC_VAL, ATTR_DIMMED    , i==3);
		break;												 //
	}														 //
 return 0;													 //
}															 //
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK set_config(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
 long i, j, t0;	
 //int s1, s2, s3;
 
	switch(event) {
		case EVENT_COMMIT:
			t0=GetTickCount();
			GetCtrlVal(pnl1, P1_CHECKBOX, &i);
			if(i) tx_signal();
			//
			form_config();
									  /*
			GetCtrlVal(panel, P1_s1, &s1);
			GetCtrlVal(panel, P1_s2, &s2);
			GetCtrlVal(panel, P1_s3, &s3);
			s1= s1 | (s2<<2) | (s3<<4);
			
			memset(module->aregs, 0x0, 15);
			module->aregs[0]= 32;
			module->aregs[1]= s1;		*/
			
			if(TE01SetConfiguration(module, FORCE_UPDATE_RAM|FORCE_UPDATE_FDAC|FORCE_UPDATE_SDAC|
			                                 FORCE_UPDATE_UMODULE|FORCE_UPDATE_IMODULE|FORCE_UPDATE_AMODULE)) { /*|FORCE_UPDATE_AMODULE) @BKL*/
				InfoMessage("\033fgff0000>>     (SET_CONFIG)", 0);				
		   }
			else {
				sprintf(stt, ">> %i", GetTickCount()-t0);
				InfoMessage(stt, 0);
				
				u_cnt=i_cnt=0;
			   	InfoMessage("\033fg0000ff>>   ", 0);				
				//
			    sprintf(stt, "\033fg0000ff>> %.4X", (int)module->state);
			    InfoMessage(stt, 0);
			}
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK get_config(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch(event) {
		case EVENT_COMMIT :
			if(TE01GetConfigurationEx(module)) InfoMessage("\033fgff0000>>     (GET_CONFIG)", 0);				
			else {
				show_config();
				InfoMessage("\033fg0000ff>>   ", 0);				
			}	
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int UScale=1000, IScale=1000, Umx=0x800000, Imx=0x800000;
double UM=1.0, IM=1.0;
//
int CVICALLBACK scale_change(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
 int i;
	switch (event) {
		case EVENT_VAL_CHANGED:
			GetCtrlVal(pnl2, control, &i);
			if(control==P2_USCALE) {
				UScale=i;
		 		SetAxisScalingMode(pnl2, P2_USTRIP, VAL_LEFT_YAXIS, VAL_MANUAL, Umx-UScale, Umx+UScale); 
			} else {
				IScale=i;
		 		SetAxisScalingMode(pnl2, P2_ISTRIP, VAL_LEFT_YAXIS, VAL_MANUAL, Imx-IScale, Imx+IScale); 
			}
		break;
	}
 return 0;
}
// ************************************************************* 
// 
// ************************************************************* 
int CVICALLBACK uitype(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event){
		case EVENT_COMMIT:
			if(control==P2_UTYPE) GetCtrlVal(pnl2, P2_UTYPE, &UGraphFlag);
			                 else GetCtrlVal(pnl2, P2_ITYPE, &IGraphFlag);
			InitP2();
		break;
	}
 return 0;
}
// ************************************************************* 
// 
// ************************************************************* 
int CVICALLBACK graph(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_LEFT_CLICK:
			if(control==P2_UGRAPH) Umx=0; else Imx=0;
		break;
	}
	return 0;
}
// ************************************************************* 
// 
// ************************************************************* 
void UShow()
{
 int i, im;
 double x, mx, dx, dd;
 // U-module
 im=u_cnt>u_cnt_full ? u_cnt_full : u_cnt;
 for(mx=0, i=0; i<im; i++) mx+=U[i];
 for(mx/=im, dx=0, i=0; i<im; i++) dx+=(dd=mx-U[i], dd*dd); 
 dx=sqrt(dx/im);
 //
 x=U[(u_cnt-1)%u_cnt_full];
 if(uformat==2) SetCtrlVal(pnl1, P1_U_X, (module->uadc_switch==1 ? module->Kd : 1)*(2*UADC_RANGE_FULL[module->uadc_range]*x/0xFFFFFF-UADC_RANGE_FULL[module->uadc_range]));
           else SetCtrlVal(pnl1, P1_U_X, (DWORD)x);		 
 SetCtrlVal(pnl1, P1_U_MX, uformat==2 ? (module->uadc_switch==1 ? module->Kd : 1)*(2*UADC_RANGE_FULL[module->uadc_range]*mx/0xFFFFFF-UADC_RANGE_FULL[module->uadc_range]) : mx);
 SetCtrlVal(pnl1, P1_U_DX, uformat==2 ? (module->uadc_switch==1 ? module->Kd : 1)*(2*UADC_RANGE_FULL[module->uadc_range]*dx/0xFFFFFF) : dx);
 SetCtrlAttribute(pnl1, P1_U_COUNTER, ATTR_LABEL_COLOR, u_cnt>u_cnt_full ? 0x00FF00 : 0x0000FF); 
 //
 x=UADC_RANGE_FULL[module->uadc_range]/0x800000*x-UADC_RANGE_FULL[module->uadc_range];
 GetCtrlAttribute(pnl1, P1_DECORATION_6, ATTR_FRAME_COLOR, &i);
 SetCtrlAttribute(pnl1, P1_UMODULE_OVERLOAD, ATTR_TEXT_COLOR , 
     x<=-UADC_RANGE[module->uadc_range] || x>=UADC_RANGE[module->uadc_range] ? 0xFF0000 : i); 
 //
 if(UGraphFlag==1) {
	if(abs(Umx-mx)>UScale) {
		Umx=mx;
 		SetAxisScalingMode(pnl2, P2_USTRIP, VAL_LEFT_YAXIS, VAL_MANUAL, Umx-UScale, Umx+UScale); 
 	}
 	PlotStripChartPoint(pnl2, P2_USTRIP, mx);
 } else if(UGraphFlag==2 && !(u_cnt%20)) {
 	WORD m, *hist;
	double mm;
	if(abs(Umx-mx)>UScale) Umx=mx;
 	if((hist=malloc((2*UScale+1)*sizeof(WORD)))==NULL) return;
	memset(hist, 0, (2*UScale+1)*sizeof(WORD));
    for(i=0; i<im; i++) if((int)(U[i]-Umx)>=-UScale && (int)(U[i]-Umx)<=UScale) hist[(int)(U[i]-Umx+UScale)]++;
	for(m=0, i=0; i<(2*UScale+1); i++) if(hist[i]>m) m=hist[i];
	mm=(double)m/im;
	if((UM-mm)<0 || (UM-mm)>0.1) UM=mm>0.9 ? 1.0 : ((int)((mm+0.1)*10))/10.0;
/* 	for(i=0; i<im; i++) dd[i]=U[i];
 	for(i=0; i<101; i++) ax[i]=Umx+i-50;
 	Histogram (dd, im, Umx-50, Umx+50, hist, ax, );
*/						   
	DeleteGraphPlot(pnl2, P2_UGRAPH, -1, VAL_DELAYED_DRAW);
	SetAxisScalingMode(pnl2, P2_UGRAPH, VAL_LEFT_YAXIS, VAL_MANUAL, 0.0, UM);
	PlotWaveform(pnl2, P2_UGRAPH, hist, 2*UScale+1, VAL_SHORT_INTEGER, 1.0/im, 0.0,
				 Umx-UScale, 1, VAL_VERTICAL_BAR, VAL_SOLID_SQUARE,
				 VAL_SOLID, 1, VAL_BLUE);
	RefreshGraph(pnl2, P2_UGRAPH);
	free(hist);
 }
}
// ************************************************************* 
// 
// ************************************************************* 
void IShow()
{
 int i, im;
 double x, mx, dx, dd;
 // I-module
 im=i_cnt>i_cnt_full ? i_cnt_full : i_cnt;
 for(mx=0, i=0; i<im; i++) mx+=I[i];
 for(mx/=im, dx=0, i=0; i<im; i++) dx+=(dd=mx-I[i], dd*dd); 
 dx=sqrt(dx/(im+1));
 //
 x=I[(i_cnt-1)%i_cnt_full];
 if(iformat==2) SetCtrlVal(pnl1, P1_I_X, IADC_RANGE_FULL[module->iadc_range]/0x800000*x-IADC_RANGE_FULL[module->iadc_range]);
           else SetCtrlVal(pnl1, P1_I_X, (DWORD)x);		 
 SetCtrlVal(pnl1, P1_I_MX, iformat==2 ? IADC_RANGE_FULL[module->iadc_range]/0x800000*mx-IADC_RANGE_FULL[module->iadc_range] : mx);
 SetCtrlVal(pnl1, P1_I_DX, iformat==2 ? IADC_RANGE_FULL[module->iadc_range]/0x800000*dx : dx);
 SetCtrlAttribute(pnl1, P1_I_COUNTER, ATTR_LABEL_COLOR, i_cnt>i_cnt_full ? 0x00FF00 : 0x0000FF); 
 //
 x=IADC_RANGE_FULL[module->iadc_range]/0x800000*x-IADC_RANGE_FULL[module->iadc_range];
 GetCtrlAttribute(pnl1, P1_DECORATION_7, ATTR_FRAME_COLOR, &i);
 SetCtrlAttribute(pnl1, P1_IMODULE_OVERLOAD, ATTR_TEXT_COLOR , 
     x<=-IADC_RANGE[module->iadc_range] || x>=IADC_RANGE[module->iadc_range] ? 0xFF0000 : i);
 //
 if(IGraphFlag==1) {
	if(abs(Imx-mx)>IScale) {
		Imx=mx;
 		SetAxisScalingMode(pnl2, P2_ISTRIP, VAL_LEFT_YAXIS, VAL_MANUAL, Imx-IScale, Imx+IScale); 
 	}
 	PlotStripChartPoint(pnl2, P2_ISTRIP, mx);
 } else if(IGraphFlag==2 && !(i_cnt%20)) {
 	WORD m, *hist;
	double mm;
	if(abs(Imx-mx)>IScale) Imx=mx;
 	if((hist=malloc((2*IScale+1)*sizeof(WORD)))==NULL) return;
	memset(hist, 0, (2*IScale+1)*sizeof(WORD));
    for(i=0; i<im; i++) if((int)(I[i]-Imx)>=-IScale && (int)(I[i]-Imx)<=IScale) hist[(int)(I[i]-Imx+IScale)]++;
	for(m=0, i=0; i<(2*IScale+1); i++) if(hist[i]>m) m=hist[i];
	mm=(double)m/im;
	if((IM-mm)<0 || (IM-mm)>0.1) IM=mm>0.9 ? 1.0 : ((int)((mm+0.1)*10))/10.0;
	DeleteGraphPlot(pnl2, P2_IGRAPH, -1, VAL_DELAYED_DRAW);
	SetAxisScalingMode(pnl2, P2_IGRAPH, VAL_LEFT_YAXIS, VAL_MANUAL, 0.0, IM);
	PlotWaveform(pnl2, P2_IGRAPH, hist, 2*IScale+1, VAL_SHORT_INTEGER, 1.0/im, 0.0,
				 Imx-IScale, 1, VAL_VERTICAL_BAR, VAL_SOLID_SQUARE,
				 VAL_SOLID, 1, VAL_BLUE);
	RefreshGraph(pnl2, P2_IGRAPH);
	free(hist);
 }
}
// ************************************************************* 
// 
// ************************************************************* 
int CVICALLBACK u_counter(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT:
			GetCtrlVal(pnl1, P1_U_COUNTER, &u_cnt_full);		   
			SetCtrlAttribute(pnl1, P1_U_X , ATTR_DIMMED, u_cnt_full ? 0 : 1);
			SetCtrlAttribute(pnl1, P1_U_MX, ATTR_DIMMED, u_cnt_full ? 0 : 1);
			SetCtrlAttribute(pnl1, P1_U_DX, ATTR_DIMMED, u_cnt_full ? 0 : 1);
			u_cnt=0;
			//
	    	SetCtrlAttribute(pnl1, P1_TIMER, ATTR_ENABLED, u_cnt_full || i_cnt_full ? 1 : 0);
            SetCtrlAttribute(pnl1, P1_U_COUNTER, ATTR_LABEL_COLOR, u_cnt>u_cnt_full ? 0x00FF00 : 0x0000FF); 
		break;
	}
 return 0;
}
// ************************************************************* 
// 
// ************************************************************* 
int CVICALLBACK i_counter(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT:
			GetCtrlVal(pnl1, P1_I_COUNTER, &i_cnt_full);		   
			SetCtrlAttribute(pnl1, P1_I_X , ATTR_DIMMED, i_cnt_full ? 0 : 1);
			SetCtrlAttribute(pnl1, P1_I_MX, ATTR_DIMMED, i_cnt_full ? 0 : 1);
			SetCtrlAttribute(pnl1, P1_I_DX, ATTR_DIMMED, i_cnt_full ? 0 : 1);
			i_cnt=0;
			//
	    	SetCtrlAttribute(pnl1, P1_TIMER, ATTR_ENABLED, u_cnt_full || i_cnt_full ? 1 : 0);
			SetCtrlAttribute(pnl1, P1_I_COUNTER, ATTR_LABEL_COLOR, i_cnt>i_cnt_full ? 0x00FF00 : 0x0000FF); 
		break;
	}
 return 0;
}
// ************************************************************* 
// 
// ************************************************************* 
int CVICALLBACK timer(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
 DWORD dw[4];
 int i;
	switch (event) {
		case EVENT_TIMER_TICK :
			if(module->Handle!=INVALID_HANDLE_VALUE && !RunFlag) {
				RunFlag=1;
				if(TE01GetData(module, dw)) InfoMessage("\033fgff0000>>   (GET_DATA)", 0);
				else if(module->state&(IMODULE_OVERLOAD|AMODULE_CHANGED|MMODULE_RESET)) {
					if(module->state&AMODULE_CHANGED) InfoMessage("\033fg0000ff>>    ", 0);
					else if(module->state&IMODULE_OVERLOAD) InfoMessage("\033fgff0000>>    ", 0);
					else if(module->state&MMODULE_RESET) InfoMessage("\033fgff0000>>    ", 0);
					SetCtrlVal(pnl1, P1_U_COUNTER, 0);		   
					SetCtrlVal(pnl1, P1_I_COUNTER, 0);		   
					u_counter(panel, control, EVENT_COMMIT, NULL, 0, 0);
					i_counter(panel, control, EVENT_COMMIT, NULL, 0, 0);
					if(TE01GetConfigurationEx(module) || TE01ReadMModuleEEPROM(module) ||
					   TE01ReadUModuleEEPROM(module) || TE01ReadIModuleEEPROM(module) ||
					   TE01ReadAModuleEEPROM(module)) InfoMessage("\033fgff0000>>     (GET_CONFIG/GET_EEPROM)", 0);
					else InfoMessage("\033fg0000ff>>   ", 0);				
					show_config();
				} else {	
					if(module->state&(UMODULE_ERROR|IMODULE_ERROR|AMODULE_ERROR)) {
						sprintf(stt, "\033fgff0000>> %s", TE01GetAPIMessage());
						InfoMessage(stt, 0);
					} else if(u_gcnt!=dw[0] || i_gcnt!=dw[2]) {
						if(OmmetrFlag) SetCtrlVal(pnl1,  P1_OMMETR, 
						   (module->uadc_switch==1 ? module->Kd : 1)*
						   (UADC_RANGE_FULL[module->uadc_range]/0x800000*dw[1]-UADC_RANGE_FULL[module->uadc_range])/
						   (IADC_RANGE_FULL[module->iadc_range]/0x800000*dw[3]-IADC_RANGE_FULL[module->iadc_range]));
						sprintf(stt, "\033fg0000ff>> %.10X -> %.8X || %.10X -> %.8X", dw[0], dw[1], dw[2], dw[3]);
						InfoMessage(stt, 0);
					}	
					if(!(module->state&UMODULE_ERROR) && u_cnt_full && u_gcnt!=dw[0]) {
						DWORD ww=dw[1]; 
						if(module->cflags&UADC_DATA_CORRECTION) ww=ww*module->Ku[module->uadc_range]+module->Bu[module->uadc_range];
						U[u_cnt++%u_cnt_full]=ww;
						UShow();
						u_gcnt=dw[0];
					}
					if(!(module->state&IMODULE_ERROR) && i_cnt_full && i_gcnt!=dw[2]) {
						DWORD ww=dw[3]; 									 
						if(module->cflags&IADC_DATA_CORRECTION) ww=ww*module->Ki[module->iadc_range]+module->Bi[module->iadc_range];
						I[i_cnt++%i_cnt_full]=ww;
						IShow();
						i_gcnt=dw[2];
					}
/*				
				} else {
					SetCtrlVal(pnl1, P1_REQ_TOTAL, module->ReqTotal);
 					SetCtrlVal(pnl1, P1_REQ_BAD, module->ReqBad);
 					SetCtrlVal(pnl1, P1_REQ_BAD_U, module->ReqBadU);
 					SetCtrlVal(pnl1, P1_REQ_BAD_I, module->ReqBadI);
 					SetCtrlVal(pnl1, P1_REQ_BAD_E, module->ReqBadE);
				}
*/
				}
				RunFlag=0;
			}
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK em_in_switch(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT:
			set_group_select_controlid(pnl1, control, em_igroup, 4);			        
			RedrawCanvas();
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK em_out_switch(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT:
			set_group_select_controlid(pnl1, control, em_ogroup, 4);			        
			RedrawCanvas();
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK uadc_switch(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
 int i;
	switch (event) {
		case EVENT_COMMIT:
			i=set_group_select_controlid(pnl1, control, uadc_igroup, 14);			
			if(i==11)  SetCtrlVal(pnl1, P1_UADC_RANGE, 0);
			RedrawCanvas();
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK iadc_switch(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT:
			set_group_select_controlid(pnl1, control, iadc_igroup, 4);			
			RedrawCanvas();
		break;
	}
	return 0;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK use_correction(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
 int i, j;
	switch (event) {
		case EVENT_COMMIT:
			for(i=0; i<4; i++) {
				GetCtrlVal(pnl1, CFLAGS[i], &j);
				if(j) module->cflags|= (1<<i);
				else module->cflags&=~(1<<i);
				if(i==2) sdac_val(pnl1, P1_SDAC_VAL, EVENT_VAL_CHANGED, NULL, 0, 0);
				if(i==3);
				
			}	
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK sdac_val(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{															 //
 int i;														 //
 double d;													 //
	switch (event) {										 //
		case EVENT_VAL_CHANGED:								 //
			GetCtrlVal(pnl1, P1_SDAC_RANGE, &i);	         // sdac_range
			GetCtrlVal(pnl1, P1_SDAC_VAL  , &d);			 // sdac_val
			TE01SetSDACConfiguration(module, i, d, FORMAT_VALUE); 
			TE01GetSDACConfiguration(module,&i,&d, FORMAT_VALUE); 
			SetCtrlVal(pnl1, P1_SDAC_RANGE, i);	             // sdac_range
			SetCtrlVal(pnl1, P1_SDAC_VAL  , d);		    	 // sdac_val
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK ommetr(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT :
			GetCtrlVal(pnl1, P1_OMMETR_USE, &OmmetrFlag);
			SetCtrlAttribute(pnl1, P1_OMMETR, ATTR_DIMMED, !OmmetrFlag);
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK uadc_range_change(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
 int i;
	switch (event) {
		case EVENT_COMMIT:
			GetCtrlVal(pnl1, P1_UADC_RANGE, &i);
			if(i && module->uadc_switch==11) set_group_select_index(pnl1, 0, uadc_igroup, 14);				
		break;
	}
	return 0;										  
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK fdac_value_change(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
 int i;
 double min, max;
 switch (event) {
	case EVENT_COMMIT:
		if(control==P1_FDAC_MIN || control==P1_FDAC_MAX) {
			int i, j, k, m, n;
			TE01GetFDACConfiguration(module, &i, &j, &k, &m, &n, &min, &max, FORMAT_VALUE);
			GetCtrlVal(pnl1, P1_FDAC_MIN, (void*)&min);	     // fdac_min
			GetCtrlVal(pnl1, P1_FDAC_MAX, (void*)&max);	     // fdac_max
 			//												 //
			if(fformat==2) {
				TE01SetFDACConfiguration(module, i, j, k, m, n, min, max, FORMAT_VALUE);
				TE01GetFDACConfiguration(module,&i,&j,&k,&m,&n,&min,&max, FORMAT_VALUE);
				SetCtrlVal(pnl1, P1_FDAC_MIN, min);
				SetCtrlVal(pnl1, P1_FDAC_MAX, max);
				SetCtrlVal(pnl1, P1_FDAC_MIN_2, m&1 ? min : min/2);
				SetCtrlVal(pnl1, P1_FDAC_MAX_2, m&1 ? max : max/2);
			} else {         
				TE01SetFDACConfiguration(module, i, j, k, m, n, (double)(*(WORD*)&min), (double)(*(WORD*)&max), FORMAT_CODE);
				TE01GetFDACConfiguration(module,&i,&j,&k,&m,&n,&min,&max, FORMAT_CODE);
				SetCtrlVal(pnl1, P1_FDAC_MIN, (WORD)min);
				SetCtrlVal(pnl1, P1_FDAC_MAX, (WORD)max);
				SetCtrlVal(pnl1, P1_FDAC_MIN_2, (WORD)min);
				SetCtrlVal(pnl1, P1_FDAC_MAX_2, (WORD)max);
			}
		} 
	break;
	case EVENT_RIGHT_CLICK:
    	if(!pnl9) pnl9=LoadPanel(pnl1, "te01\\te01uir.uir", P9);
		SetPanelAttribute(pnl9, ATTR_TOP,  eventData1);
		SetPanelAttribute(pnl9, ATTR_LEFT, eventData2);
		switch(control) {
			case P1_U_X : case P1_U_MX : case P1_U_DX :
				i=uformat;
				sel=1;
			break;
			case P1_I_X : case P1_I_MX : case P1_I_DX :
				i=iformat;
				sel=2;
			break;
			case P1_FDAC_MIN :   case P1_FDAC_MAX :
			case P1_FDAC_MIN_2 : case P1_FDAC_MAX_2 :
				i=fformat;
				sel=3;
			break;
		}
		SetCtrlVal(pnl9, P9_FORMAT, i);
		DisplayPanel(pnl9);
	break;
 }
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK format_change(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
 int i;
 double d, f;
	switch (event) {
		case EVENT_COMMIT:
			GetCtrlVal(pnl9, P9_FORMAT, &i);
			DiscardPanel(pnl9);
			pnl9=0;
			switch(sel) {
				case 1 : 
					uformat=i;
					SetCtrlAttribute(pnl1, P1_U_X, ATTR_LABEL_TEXT, uformat==2 ? "X (mV)": "X (Code)"); 
					SetCtrlAttribute(pnl1, P1_U_MX, ATTR_LABEL_TEXT, uformat==2 ? "MX (mV)": "MX (Code)"); 
					SetCtrlAttribute(pnl1, P1_U_DX, ATTR_LABEL_TEXT, uformat==2 ? "DX (mV)": "DX (Code)"); 
					SetCtrlAttribute(pnl1, P1_U_X, ATTR_DATA_TYPE, uformat==2 ? VAL_DOUBLE : VAL_UNSIGNED_INTEGER); 
					if(uformat==2) SetCtrlAttribute(pnl1, P1_U_X , ATTR_PRECISION, 6);
					else SetCtrlAttribute(pnl1, P1_U_X, ATTR_FORMAT, uformat ? VAL_DECIMAL_FORMAT : VAL_HEX_FORMAT); 
					SetCtrlAttribute(pnl1, P1_U_MX, ATTR_PRECISION, uformat==2 ? 6 : 2);
					SetCtrlAttribute(pnl1, P1_U_DX, ATTR_PRECISION, uformat==2 ? 8 : 2);
				break;
				case 2 :
					iformat=i;
					SetCtrlAttribute(pnl1, P1_I_X, ATTR_LABEL_TEXT, iformat==2 ? "X (mA)": "X (Code)"); 
					SetCtrlAttribute(pnl1, P1_I_MX, ATTR_LABEL_TEXT, iformat==2 ? "MX (mA)": "MX (Code)"); 
					SetCtrlAttribute(pnl1, P1_I_DX, ATTR_LABEL_TEXT, iformat==2 ? "DX (mA)": "DX (Code)"); 
					SetCtrlAttribute(pnl1, P1_I_X, ATTR_DATA_TYPE, iformat==2 ? VAL_DOUBLE : VAL_UNSIGNED_INTEGER); 
					if(iformat==2) SetCtrlAttribute(pnl1, P1_I_X , ATTR_PRECISION, 6);
					else SetCtrlAttribute(pnl1, P1_I_X, ATTR_FORMAT, iformat ? VAL_DECIMAL_FORMAT : VAL_HEX_FORMAT); 
					SetCtrlAttribute(pnl1, P1_I_MX, ATTR_PRECISION, iformat==2 ? 6 : 2);
					SetCtrlAttribute(pnl1, P1_I_DX, ATTR_PRECISION, iformat==2 ? 8 : 2);
				break;
				case 3 :
					fformat=i;
					show_config();
				break;
			}
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK fdac_range_changed(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{															 //
 double min, max;											 //
 int i, j, k, m, n;											 //
	switch (event) {										 //
		case EVENT_COMMIT:									 //
			TE01GetFDACConfiguration(module, &i, &j, &k, &m, &n, &min, &max, FORMAT_CODE);
			GetCtrlVal(pnl1, P1_FDAC_RANGE, &m);    		 //
			GetCtrlVal(pnl1, P1_FDAC_MIN, (void*)&min);	     // fdac_min
			GetCtrlVal(pnl1, P1_FDAC_MAX, (void*)&max);    	 // fdac_max
			if(fformat==2) TE01SetFDACConfiguration(module, i, j, k, m, n, min, max, FORMAT_VALUE);
				 	  else TE01SetFDACConfiguration(module, i, j, k, m, n, *(WORD*)&min, *(WORD*)&max, FORMAT_CODE); 
			show_config();									 //
		break;												 //
	}														 //
 return 0;													 //
}															 //


int CVICALLBACK qwer (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
				TE01WriteCoeffToEEPROM(module);
				InfoMessage(TE01GetAPIMessage(), 0);
			break;
		}
	return 0;
}

int CVICALLBACK qwer1 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
				TE01ReadCoeffFromEEPROM(module);
				InfoMessage(TE01GetAPIMessage(), 0);
			break;
		}
	return 0;
}
