/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2007. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  PANEL                           1       /* callback function: msgpnl_cbf */
#define  PANEL_log                       2       /* callback function: rf_log */
#define  PANEL_summary                   3       /* callback function: rf_summary */
#define  PANEL_save                      4       /* callback function: rf_save */
#define  PANEL_report                    5       /* callback function: rf_report */
#define  PANEL_passport                  6       /* callback function: rf_passport */
#define  PANEL_close                     7       /* callback function: rf_close */
#define  PANEL_DECORATION_2              8
#define  PANEL_DECORATION_3              9
#define  PANEL_decor                     10
#define  PANEL_DECORATION                11
#define  PANEL_spec                      12
#define  PANEL_text                      13


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK msgpnl_cbf(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK rf_close(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK rf_log(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK rf_passport(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK rf_report(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK rf_save(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK rf_summary(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
