/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2005. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  PANEL                           1
#define  PANEL_list                      2       /* callback function: mf_list */
#define  PANEL_text                      3
#define  PANEL_graf                      4
#define  PANEL_close                     5       /* callback function: mf_close */
#define  PANEL_hdev                      6
#define  PANEL_dev                       7
#define  PANEL_modeValue                 8
#define  PANEL_mean                      9
#define  PANEL_hmax                      10
#define  PANEL_max                       11
#define  PANEL_hmin                      12
#define  PANEL_hw                        13
#define  PANEL_w                         14
#define  PANEL_min                       15
#define  PANEL_intervals                 16
#define  PANEL_help                      17      /* callback function: mf_help */
#define  PANEL_DECORATION                18
#define  PANEL_info                      19
#define  PANEL_isinfo                    20
#define  PANEL_color                     21
#define  PANEL_led                       22
#define  PANEL_reset                     23      /* callback function: mf_reset */
#define  PANEL_DECORATION_2              24
#define  PANEL_use                       25
#define  PANEL_TEXTMSG                   26
#define  PANEL_DECORATION_3              27


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK mf_close(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_help(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_list(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_reset(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
