/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2007. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  PANEL                           1       /* callback function: PANEL_CALLBACK */
#define  PANEL_value                     2
#define  PANEL_code                      3
#define  PANEL_decor                     4
#define  PANEL_descr                     5
#define  PANEL_help                      6       /* callback function: mf_help */
#define  PANEL_close                     7       /* callback function: mf_close */
#define  PANEL_unit                      8
#define  PANEL_DECORATION_3              9
#define  PANEL_DECORATION_2              10
#define  PANEL_DECORATION                11
#define  PANEL_list                      12      /* callback function: mf_list */
#define  PANEL_n                         13
#define  PANEL_nreal                     14
#define  PANEL_point                     15
#define  PANEL_TEXTMSG                   16
#define  PANEL_TEXTMSG_2                 17
#define  PANEL_TEXTMSG_3                 18
#define  PANEL_TEXTMSG_5                 19
#define  PANEL_led                       20
#define  PANEL_TEXTMSG_4                 21
#define  PANEL_precision                 22      /* callback function: mf_precision */


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK mf_close(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_help(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_list(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_precision(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PANEL_CALLBACK(int panel, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
