/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2005. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  PANEL                           1
#define  PANEL_HELP                      2       /* callback function: Help */
#define  PANEL_GRAPH2                    3
#define  PANEL_QUIT                      4       /* callback function: Quit */
#define  PANEL_WINDOW                    5
#define  PANEL_SCALING                   6
#define  PANEL_f                         7
#define  PANEL_PEAK_FREQ                 8
#define  PANEL_DISPLAY                   9
#define  PANEL_pwr                       10
#define  PANEL_POWER_PEAK                11
#define  PANEL_SIGNAL                    12
#define  PANEL_GRAPH1                    13
#define  PANEL_w                         14
#define  PANEL_snr                       15
#define  PANEL_max                       16
#define  PANEL_phase                     17
#define  PANEL_ampl                      18
#define  PANEL_base                      19
#define  PANEL_span                      20
#define  PANEL_a5                        21
#define  PANEL_a4                        22
#define  PANEL_a3                        23
#define  PANEL_a2                        24
#define  PANEL_thdnoise                  25
#define  PANEL_thd                       26
#define  PANEL_f5                        27
#define  PANEL_f4                        28
#define  PANEL_f3                        29
#define  PANEL_f2                        30
#define  PANEL_f1                        31
#define  PANEL_a1                        32
#define  PANEL_DECORATION                33
#define  PANEL_samplerate                34
#define  PANEL_fundf                     35
#define  PANEL_DECORATION_2              36
#define  PANEL_points                    37
#define  PANEL_dc                        38
#define  PANEL_NOISE_LEVEL               39
#define  PANEL_DECORATION_4              40
#define  PANEL_DECORATION_5              41
#define  PANEL_UNIT                      42
#define  PANEL_tgarm                     43
#define  PANEL_garm                      44
#define  PANEL_bit                       45
#define  PANEL_TEXTMSG_2                 46
#define  PANEL_text                      47
#define  PANEL_i1                        48
#define  PANEL_UNIT_2                    49
#define  PANEL_qq1                       50
#define  PANEL_qq                        51
#define  PANEL_gg                        52
#define  PANEL_ww                        53
#define  PANEL_TEXTMSG_4                 54
#define  PANEL_TEXTMSG_7                 55
#define  PANEL_TEXTMSG                   56
#define  PANEL_TEXTMSG_3                 57
#define  PANEL_TIMER                     58      /* callback function: TimerFunction */
#define  PANEL_DECORATION_6              59
#define  PANEL_DECORATION_7              60
#define  PANEL_DECORATION_3              61
#define  PANEL_DECORATION_8              62


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK Help(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Quit(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK TimerFunction(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
