/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2007. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  PANEL                           1
#define  PANEL_close                     2       /* callback function: mf_close */
#define  PANEL_help                      3       /* callback function: mf_help */
#define  PANEL_led                       4
#define  PANEL_fftgraf                   5       /* callback function: mf_fftgraf */
#define  PANEL_graf                      6       /* callback function: mf_graf */
#define  PANEL_ch_16                     7       /* callback function: mf_channel */
#define  PANEL_ch_15                     8       /* callback function: mf_channel */
#define  PANEL_ch_14                     9       /* callback function: mf_channel */
#define  PANEL_ch_13                     10      /* callback function: mf_channel */
#define  PANEL_ch_12                     11      /* callback function: mf_channel */
#define  PANEL_ch_11                     12      /* callback function: mf_channel */
#define  PANEL_ch_10                     13      /* callback function: mf_channel */
#define  PANEL_ch_9                      14      /* callback function: mf_channel */
#define  PANEL_ch_8                      15      /* callback function: mf_channel */
#define  PANEL_ch_7                      16      /* callback function: mf_channel */
#define  PANEL_ch_6                      17      /* callback function: mf_channel */
#define  PANEL_ch_5                      18      /* callback function: mf_channel */
#define  PANEL_ch_4                      19      /* callback function: mf_channel */
#define  PANEL_ch_3                      20      /* callback function: mf_channel */
#define  PANEL_ch_2                      21      /* callback function: mf_channel */
#define  PANEL_ch_1                      22      /* callback function: mf_channel */
#define  PANEL_p_16                      23      /* callback function: mf_physch */
#define  PANEL_p_15                      24      /* callback function: mf_physch */
#define  PANEL_p_14                      25      /* callback function: mf_physch */
#define  PANEL_p_13                      26      /* callback function: mf_physch */
#define  PANEL_p_12                      27      /* callback function: mf_physch */
#define  PANEL_p_11                      28      /* callback function: mf_physch */
#define  PANEL_p_10                      29      /* callback function: mf_physch */
#define  PANEL_p_9                       30      /* callback function: mf_physch */
#define  PANEL_p_8                       31      /* callback function: mf_physch */
#define  PANEL_p_7                       32      /* callback function: mf_physch */
#define  PANEL_p_6                       33      /* callback function: mf_physch */
#define  PANEL_p_5                       34      /* callback function: mf_physch */
#define  PANEL_p_4                       35      /* callback function: mf_physch */
#define  PANEL_p_3                       36      /* callback function: mf_physch */
#define  PANEL_p_2                       37      /* callback function: mf_physch */
#define  PANEL_s_16                      38      /* callback function: mf_scale */
#define  PANEL_s_15                      39      /* callback function: mf_scale */
#define  PANEL_s_14                      40      /* callback function: mf_scale */
#define  PANEL_s_13                      41      /* callback function: mf_scale */
#define  PANEL_s_12                      42      /* callback function: mf_scale */
#define  PANEL_s_11                      43      /* callback function: mf_scale */
#define  PANEL_s_10                      44      /* callback function: mf_scale */
#define  PANEL_s_9                       45      /* callback function: mf_scale */
#define  PANEL_s_8                       46      /* callback function: mf_scale */
#define  PANEL_s_7                       47      /* callback function: mf_scale */
#define  PANEL_s_6                       48      /* callback function: mf_scale */
#define  PANEL_s_5                       49      /* callback function: mf_scale */
#define  PANEL_s_4                       50      /* callback function: mf_scale */
#define  PANEL_s_3                       51      /* callback function: mf_scale */
#define  PANEL_s_2                       52      /* callback function: mf_scale */
#define  PANEL_s_1                       53      /* callback function: mf_scale */
#define  PANEL_p_1                       54      /* callback function: mf_physch */
#define  PANEL_t_16                      55
#define  PANEL_t_15                      56
#define  PANEL_t_14                      57
#define  PANEL_t_13                      58
#define  PANEL_t_12                      59
#define  PANEL_t_11                      60
#define  PANEL_t_10                      61
#define  PANEL_t_9                       62
#define  PANEL_t_8                       63
#define  PANEL_t_7                       64
#define  PANEL_t_6                       65
#define  PANEL_t_5                       66
#define  PANEL_t_4                       67
#define  PANEL_t_3                       68
#define  PANEL_t_2                       69
#define  PANEL_t_1                       70
#define  PANEL_c_16                      71      /* callback function: mf_color */
#define  PANEL_c_15                      72      /* callback function: mf_color */
#define  PANEL_c_14                      73      /* callback function: mf_color */
#define  PANEL_c_13                      74      /* callback function: mf_color */
#define  PANEL_c_12                      75      /* callback function: mf_color */
#define  PANEL_c_11                      76      /* callback function: mf_color */
#define  PANEL_c_10                      77      /* callback function: mf_color */
#define  PANEL_c_9                       78      /* callback function: mf_color */
#define  PANEL_c_8                       79      /* callback function: mf_color */
#define  PANEL_c_7                       80      /* callback function: mf_color */
#define  PANEL_c_6                       81      /* callback function: mf_color */
#define  PANEL_c_5                       82      /* callback function: mf_color */
#define  PANEL_c_4                       83      /* callback function: mf_color */
#define  PANEL_c_3                       84      /* callback function: mf_color */
#define  PANEL_c_2                       85      /* callback function: mf_color */
#define  PANEL_c_1                       86      /* callback function: mf_color */
#define  PANEL_value_3                   87
#define  PANEL_fftf                      88      /* callback function: mf_fftcursor */
#define  PANEL_synctime                  89      /* callback function: mf_syncparams */
#define  PANEL_snr                       90
#define  PANEL_base                      91
#define  PANEL_fftdb                     92      /* callback function: mf_fftcursor */
#define  PANEL_synclevel                 93      /* callback function: mf_syncparams */
#define  PANEL_f                         94      /* callback function: mf_f */
#define  PANEL_time                      95      /* callback function: mf_time */
#define  PANEL_shiftchan                 96      /* callback function: mf_shiftchannel */
#define  PANEL_nfft                      97
#define  PANEL_win                       98
#define  PANEL_syncchan                  99      /* callback function: mf_syncchan */
#define  PANEL_sync                      100     /* callback function: mf_sync */
#define  PANEL_rise                      101     /* callback function: mf_rise */
#define  PANEL_Mid_fourier               102     /* callback function: mid_fourier */
#define  PANEL_dc                        103     /* callback function: mf_dc */
#define  PANEL_fft                       104     /* callback function: mf_fft */
#define  PANEL_run                       105     /* callback function: mf_run */
#define  PANEL_u                         106
#define  PANEL_fabst                     107
#define  PANEL_fabs                      108
#define  PANEL_DECORATION_11             109
#define  PANEL_df                        110
#define  PANEL_DECORATION_12             111
#define  PANEL_TEXTMSG_10                112
#define  PANEL_DECORATION_2              113
#define  PANEL_DECORATION_5              114
#define  PANEL_print                     115     /* callback function: FnPanelPrint */
#define  PANEL_rstsync                   116     /* callback function: mf_rstsync */
#define  PANEL_rst_2                     117     /* callback function: mf_rstchannel */
#define  PANEL_fright                    118     /* callback function: mff_fright */
#define  PANEL_fleft                     119     /* callback function: mff_fleft */
#define  PANEL_frst                      120     /* callback function: mff_fzero */
#define  PANEL_rst                       121     /* callback function: mf_rst */
#define  PANEL_COMMANDBUTTON             122
#define  PANEL_STRING                    123
#define  PANEL_shift                     124     /* callback function: mf_shift */
#define  PANEL_scale_sync                125
#define  PANEL_scale_shift               126
#define  PANEL_warn                      127
#define  PANEL_nfftreal                  128
#define  PANEL_peak                      129
#define  PANEL_t                         130
#define  PANEL_TEXTMSG                   131
#define  PANEL_dec1                      132
#define  PANEL_DECORATION                133
#define  PANEL_DECORATION_6              134


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK FnPanelPrint(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_channel(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_close(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_color(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_dc(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_f(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_fft(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_fftcursor(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_fftgraf(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_graf(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_help(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_physch(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_rise(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_rst(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_rstchannel(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_rstsync(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_run(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_scale(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_shift(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_shiftchannel(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_sync(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_syncchan(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_syncparams(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_time(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mff_fleft(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mff_fright(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mff_fzero(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mid_fourier(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
