#ifndef _UTF_TFUNCDEF__H
#define _UTF_TFUNCDEF__H

#include "uts\\common\\include\\commondef.h"

#pragma pack(1)
typedef struct {
   int  portTE;    // TE-01
   int  portK;     // Keythley
   int  portLPT;   //  
} tHW;
#pragma pack()

typedef int (*tCbfPtr)(unsigned int id, char *msg);

#pragma pack(1)
typedef struct {
  char       dllpath[FNAMELEN+1];
  tCbfPtr    cbf;  // callback function
  tHW        hw;   // hw profile
  char       mdescr[COMMENTLEN+1];
  void      *te01;
  void      *tcontext;
} TCONTEXT;

typedef int (*tfptr)(TCONTEXT *tc);

// -------------------------------------------------------------
typedef struct {
  int manual;
  int passport;
  int use;
} tfuncSet;
//   
#define TFTYPE_AUTO         0
#define TFTYPE_MANUAL       1
// 
#define TFPASSPORT          1
//       
#define TFUSE               1              


// 
typedef struct 
{
  char    *name;
  char    *version;
  char    *descr;
  tfuncSet set;
   
  tfptr    run; 
} TFuncDefine;


// -------------------------------------------------------------
#pragma pack()

#endif
