#ifndef _UTSPFUNC__H
#define _UTSPFUNC__H

#include "uts\\systems\\common\\include\\tfuncdef.h"
#include "uts\\systems\\common\\include\\plugindef.h"

extern int utspInitModule(TCONTEXT *tc, void *);
extern int utspReadData(TCONTEXT *tc, void *);
extern int utspWriteData(TCONTEXT *tc, void *);
extern int utspWriteFile(TCONTEXT *tc, void *);
extern int utspCalibrModule(TCONTEXT *tc);
extern int utspVerifyModule(TCONTEXT *tc);
extern int utspConfigTest(TCONTEXT *tc, void *);
extern int utspVirtualDevice(TCONTEXT *tc, void *);
extern int utspConfigDevice(TCONTEXT *tc, void *);
extern int utspConfigTe01Ext(TCONTEXT *tc, void *);
extern int utspGetDescrADC(TCONTEXT *tc, pluginADC *D, int channel);
extern int utspGetDescrDAC(TCONTEXT *tc, pluginDAC *D, int channel);
extern int utspGetDescrDIO(TCONTEXT *tc, pluginDIO *D, int channel);
extern int utspGetDIO(TCONTEXT *tc, void *);
extern int utspPutDIO(TCONTEXT *tc, void *);
extern int utspWriteMCUFlash(TCONTEXT *tc, void *);
extern int utspReadMCUFlash(TCONTEXT *tc, void *);
extern int utspWriteMCUFuses(TCONTEXT *tc, void *);
extern int utspReadMCUFuses(TCONTEXT *tc, void *);
extern int utspLoadADSP(TCONTEXT *tc, void *);
extern int utspGetModuleInfo(TCONTEXT *tc, void *);
extern int utspStart(TCONTEXT *tc, void *);
extern int utspStop(TCONTEXT *tc, void *);

#endif
