/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2005. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  AF_PANEL                        1
#define  AF_PANEL_AFC_GRAPH              2
#define  AF_PANEL_QUIT_BUTTON            3       /* callback function: quit_vdevice */
#define  AF_PANEL_STOP_BUTTON            4       /* callback function: stop_amp_freq */
#define  AF_PANEL_START_BUTTON           5       /* callback function: start_amp_freq */
#define  AF_PANEL_MAX_FREQ               6
#define  AF_PANEL_POINTS                 7
#define  AF_PANEL_MESSAGES               8
#define  AF_PANEL_FILENAME               9


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK quit_vdevice(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK start_amp_freq(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK stop_amp_freq(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
