/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2005. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  CLB                             1
#define  CLB_clbclose                    2       /* callback function: clbf_close */
#define  CLB_stage1                      3       /* callback function: clbf_stage1 */
#define  CLB_stage2                      4       /* callback function: clbf_stage2 */
#define  CLB_mode                        5       /* callback function: clbf_mode */
#define  CLB_DECORATION                  6
#define  CLB_d_8                         7
#define  CLB_d_7                         8
#define  CLB_d_6                         9
#define  CLB_d_5                         10
#define  CLB_d_4                         11
#define  CLB_d_3                         12
#define  CLB_d_2                         13
#define  CLB_d_1                         14
#define  CLB_TEXTMSG_2                   15
#define  CLB_c_8                         16      /* callback function: clbf_channel */
#define  CLB_c_7                         17      /* callback function: clbf_channel */
#define  CLB_c_6                         18      /* callback function: clbf_channel */
#define  CLB_c_5                         19      /* callback function: clbf_channel */
#define  CLB_c_4                         20      /* callback function: clbf_channel */
#define  CLB_c_3                         21      /* callback function: clbf_channel */
#define  CLB_c_2                         22      /* callback function: clbf_channel */
#define  CLB_c_1                         23      /* callback function: clbf_channel */
#define  CLB_l_8                         24
#define  CLB_l_7                         25
#define  CLB_l_6                         26
#define  CLB_l_5                         27
#define  CLB_l_4                         28
#define  CLB_l_3                         29
#define  CLB_l_2                         30
#define  CLB_l_1                         31
#define  CLB_DECORATION_2                32
#define  CLB_list                        33      /* callback function: clbf_list */
#define  CLB_DECORATION_3                34
#define  CLB_TEXTMSG_3                   35
#define  CLB_TEXTMSG_4                   36
#define  CLB_DECORATION_4                37
#define  CLB_TEXTMSG_5                   38
#define  CLB_text                        39
#define  CLB_toggle                      40      /* callback function: clbf_toggle */
#define  CLB_led                         41

#define  PANEL                           2
#define  PANEL_s_8                       2
#define  PANEL_s_7                       3
#define  PANEL_s_6                       4
#define  PANEL_s_5                       5
#define  PANEL_cfgdone                   6       /* callback function: mf_apply */
#define  PANEL_firselect                 7       /* callback function: mf_firselect */
#define  PANEL_iirselect                 8       /* callback function: mf_iirselect */
#define  PANEL_s_4                       9
#define  PANEL_s_3                       10
#define  PANEL_s_2                       11
#define  PANEL_s_1                       12
#define  PANEL_mode                      13      /* callback function: mf_mode */
#define  PANEL_clb                       14
#define  PANEL_c_8                       15      /* callback function: mf_chan */
#define  PANEL_to                        16
#define  PANEL_time                      17
#define  PANEL_c_7                       18      /* callback function: mf_chan */
#define  PANEL_c_6                       19      /* callback function: mf_chan */
#define  PANEL_c_5                       20      /* callback function: mf_chan */
#define  PANEL_c_4                       21      /* callback function: mf_chan */
#define  PANEL_c_3                       22      /* callback function: mf_chan */
#define  PANEL_c_2                       23      /* callback function: mf_chan */
#define  PANEL_c_1                       24      /* callback function: mf_chan */
#define  PANEL_delay                     25      /* callback function: mf_freq */
#define  PANEL_fdiv                      26      /* callback function: mf_freq */
#define  PANEL_fs                        27
#define  PANEL_fsFlt                     28
#define  PANEL_fs0                       29
#define  PANEL_fir                       30      /* callback function: mf_freq */
#define  PANEL_iir                       31
#define  PANEL_fast                      32      /* callback function: mf_freq */
#define  PANEL_skip                      33      /* callback function: mf_freq */
#define  PANEL_ppoint                    34      /* callback function: mf_point */
#define  PANEL_point                     35      /* callback function: mf_point */
#define  PANEL_ac                        36      /* callback function: mf_ac */
#define  PANEL_chop                      37      /* callback function: mf_freq */
#define  PANEL_ref                       38
#define  PANEL_DECORATION                39
#define  PANEL_DECORATION_2              40
#define  PANEL_DECORATION_3              41
#define  PANEL_DECORATION_4              42
#define  PANEL_firname                   43
#define  PANEL_iirname                   44
#define  PANEL_taps                      45
#define  PANEL_decimation                46
#define  PANEL_DECORATION_6              47
#define  PANEL_decor                     48
#define  PANEL_TEXTMSG                   49
#define  PANEL_TEXTMSG_2                 50
#define  PANEL_TEXTMSG_3                 51
#define  PANEL_TEXTMSG_4                 52

#define  WP                              3
#define  WP_TEXTMSG                      2


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK clbf_channel(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK clbf_close(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK clbf_list(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK clbf_mode(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK clbf_stage1(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK clbf_stage2(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK clbf_toggle(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_ac(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_apply(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_chan(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_firselect(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_freq(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_iirselect(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_mode(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_point(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
