static double h2k_find_snr(int NAver, double *dB, int N, double f, double fs, double Base) {
	double snr= 0.0;
	int    ind, j;
	int    indmax, indmin;
	int    ind1, ind2, x;
	double xmax, xmin;
	double signal= 0.0, noise= 0.0;

	if(!NAver) NAver= 1; // !!! tmp

	MaxMin1D (dB, N, &xmax, &indmax, &xmin, &indmin);
	SetCtrlVal(FFTPnl, FP(SnrFMax), fs*indmax/N/2.0);  // !!! tmp
	SetCtrlVal(FFTPnl, FP(dBXX), dB[indmax]);
	GetCtrlVal(FFTPnl, FP(AutoPik), &x);
	if(x) SetCtrlVal(FFTPnl, FP(SnrF), fs*indmax/N/2.0);

	ind= (int)(f*2.0*N/fs+0.5);
	if(ind>=N) return snr;

	ind1= (int)(((double)ind)*(1.0-0.2)+0.5);		 // +/- 50% ?
	ind2= (int)(((double)ind)*(1.0+0.2)+0.5);		 // +/- 50% ?

	//  ind1=ind-6;  // 6 is enough ?
	//  ind2=ind+6;
  if(ind1==ind2) ind2++;

  if(ind1<0) ind1= 0;
  if(ind2>N) ind2= N;

	// SetCtrlVal(FFTPnl, FP(n1), ind1);
	// SetCtrlVal(FFTPnl, FP(n2), ind2);

	for(j=ind1; j<ind2; j++) signal+= pow(Base*pow(10.0, dB[j]/NAver/20.0), 2.0);  // !!! tmp

	for(j=7; j<ind1; j++)    // !!! 7
		noise+= pow(Base*pow(10.0, dB[j]/NAver/20.0), 2.0);  // !!! tmp, 7 - tmp !!!
	for(j=ind2; j<N; j++)
		noise+= pow(Base*pow(10.0, dB[j]/NAver/20.0), 2.0);  // !!! tmp

	// snr= dB[ind]/NAver;
	snr= 10.0*log10(signal/noise); // + 3.0;  // ?????????????????????????????
	return snr;
}
