#ifndef LTR27_LOCAL_DEFS__H
#define LTR27_LOCAL_DEFS__H
//-----------------------------------------------------------------------------
#include "uts\\systems\\common\\include\\tfuncdef.h"
#include "uts\\systems\\common\\include\\plugindef.h"
#include "uts\\systems\\common\\include\\utspfunc.h"
#include "uts\\services\\common\\include\\servicedef.h"
#include "uts\\systems\\ltr\\common\\include\\ltrspecific.h"
#include "ltr\\include\\ltr27api.h"
//-----------------------------------------------------------------------------
#define MAXNPOINTS    100000
#define TE01EXTNAME   "TE-01-EXT"             // 9 char maximum
#define INIFNAME      "ltr27ini.ini"
//-----------------------------------------------------------------------------
#pragma pack(1)
typedef struct 							 //
{									     //
 BOOL UseCalibration;					 //    .
 BYTE FreqDivisor;						 //   
 WORD AcqDataSize;						 //    ( )
 WORD ProcDataSize;						 //   
 //										 //
 struct {								 //
	int onoff;							 //  /
 } LogChan[2*LTR27_MEZZANINE_NUMBER];			 //   
} IniSet_LTR27;							 //
#pragma pack()
//-----------------------------------------------------------------------------
extern TLTR27 module;
extern IniSet_LTR27 IniSet;
//-----------------------------------------------------------------------------
void openThisPlugin(void);
void closeThisPlugin(void);
int   openModule(TCONTEXT *tc);
int  closeModule(void);
int configModule(void);
void readINI(char *inidir);
void writeINI(void);
int utspWriteMCUFlash(TCONTEXT *tc, void *p);
#endif


