#ifndef LTR34_LOCAL_DEFS__H
#define LTR34_LOCAL_DEFS__H
//-----------------------------------------------------------------------------
#include "uts\\systems\\common\\include\\tfuncdef.h"
#include "uts\\systems\\common\\include\\plugindef.h"
#include "uts\\systems\\common\\include\\utspfunc.h"
#include "uts\\services\\common\\include\\servicedef.h"
#include "uts\\systems\\ltr\\common\\include\\ltrspecific.h"
#include "ltrspecificMy.h" 
#include "ltr\\include\\ltr34api.h"
#include "uts\\instruments\\te01\\te01api.h"    
//-----------------------------------------------------------------------------
#define MAXNPOINTS    100000
#define TE01EXTNAME   "TE-01-EXT"             // 9 char maximum
#define INIFNAME      "ltr34ini.ini"
//-----------------------------------------------------------------------------
#pragma pack(1)
typedef struct 							 //
{
 BYTE ChannelQnt;
 BOOL UseCalibration;					 //    .    
 BOOL ChannelGroup;
 BYTE RingMode;
 BOOL AckMode;
 BYTE FreqDivisor;
 double FreqDAC;
 
 
 struct 
 {								 //
   bool off;							 //  /
   int Type;
   short int Max;
   short int Min;
   double GEN_Freq;
 } ChannelGen[LTR34_DAC_NUMBER_MAX*17];			 //   
 
 
 TLTR34 ModulesConfiguration[17];

} IniSet_LTR34;							 //
#pragma pack()
//-----------------------------------------------------------------------------
extern IniSet_LTR34 IniSet;
//-----------------------------------------------------------------------------
void openThisPlugin(void);
void closeThisPlugin(void);
int   openModule(TCONTEXT *tc);
int  closeModule(void);
//void readINI(char *inidir);
//void writeINI(void);
#endif


