/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2007. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  PANEL_Conf                      1       /* callback function: CloseAll */
#define  PANEL_Conf_Exit_BTN             2       /* callback function: Exit_CLB */
#define  PANEL_Conf_DECORATION_4         3
#define  PANEL_Conf_StartMark_mode       4
#define  PANEL_Conf_Lines_TXT_4          5
#define  PANEL_Conf_DECORATION_3         6
#define  PANEL_Conf_SecondMark_mode      7
#define  PANEL_Conf_Lines_TXT_3          8
#define  PANEL_Conf_Work_BTN             9       /* callback function: Work_CLB */

#define  PANEL_Work                      2       /* callback function: Close */
#define  PANEL_Work_ExitWork_BTN         2       /* callback function: ExitWork_CLB */
#define  PANEL_Work_L1                   3
#define  PANEL_Work_WriteWord_BTN        4       /* callback function: WriteWord_CLB */
#define  PANEL_Work_DEC                  5
#define  PANEL_Work_HEX                  6
#define  PANEL_Work_MakeStartMark_BTN    7       /* callback function: MakeStartMark_CLB */
#define  PANEL_Work_SecondMarksStop_BTN  8       /* callback function: SecondMarksStop_CLB */
#define  PANEL_Work_SecondMarksGo_BTN    9       /* callback function: SecondMarksGo_CLB */
#define  PANEL_Work_DECORATION           10
#define  PANEL_Work_DECORATION_2         11
#define  PANEL_Work_Serial_STR           12
#define  PANEL_Work_Slot_NUM             13
#define  PANEL_Work_Status_TXT           14


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK Close(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK CloseAll(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Exit_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ExitWork_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK MakeStartMark_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SecondMarksGo_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SecondMarksStop_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Work_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK WriteWord_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
