#include <windows.h>
#include <ansi_c.h>
#include <userint.h>
#include "pluginuir.h"  
#include "localdefs.h"

#include <analysis.h>
#include <utility.h>

#include <windows.h>
#include <ansi_c.h>
#include <userint.h>
#include "uts\\instruments\\te01\\te01api.h"
#include "pluginuir.h"
#include "UTS\\systems\\common\\include\\tfuncdef.h"
#include "localdefs.h"
#include "UTS\\systems\\common\\include\\plugindef.h"
#include "UTS\\systems\\ltr\\common\\include\\ltrspecific.h"
#include "C:\\prj\\UTS\\services\\common\\include\\servicedef.h"

#include "ltr\\include\\ltr42api.h" 
#include <analysis.h>

static int Strange_Counter=0;
static DWORD Strange_Sample=0;
LPCSTR error_string; 

static int PH_Work;
static int PH_RS485;  
static int PH_Conf;  
static int  SecondMarksFlag=0;    

static int Pnl= -1;
//static int TePnl= -1;
#define P(x)  PANEL_##x
#define TOTAL_IO_LINES 16


extern TLTR42 hltr42;
  
  
int StopArrayFlag=0;  

  
TLTR Channel;

static TE01 *theTE01;
static char thePATH[FNAMELEN+1];


 int LinesIDs[32];
 int decs[4];
 int HEX[4];
 int Ports[4];
  
int PointsQnt;

HANDLE ReadThread;

int StreamRead_Flag=0;
int StopStreamRead_Flag=0;
int QuitLockFlag=0;

static TCONTEXT theTCONTEXT;    

// -------------------------------------------------------------
static void calcFS(double *fsBase, double *fs);

//#define THE8CHANTIME 1.0/50e3  // !!! tmp
#define MAX_LINE 32
//#define QFreq 4.9152e6

static const int physChannels[MAX_LINE]= {1,3,5,7,2,4,6,8};
//extern TLTR42 hltr42; 

//***********************************************************************************************************

int utspGetDIODescr(TCONTEXT *tc, pluginDIO *D, int line);



void closeUIR(void) {
  if(Pnl!= -1)   { DiscardPanel(Pnl);   Pnl= -1;   };
  //if(TePnl!= -1) { DiscardPanel(TePnl); TePnl= -1; };  
};

//**********************************************************************************************************

int utspConfigTest(TCONTEXT *tc, void *p) {  return 0; };
int utspVirtualDevice(TCONTEXT *tc, void *p) { return 0; };


#pragma pack(1)

typedef struct
 {
  double StreamReadFreq;
  int SecMark_EnaDis;   //  
  int Start_Mark_Ena; //  ""
  int SecMark_Mode;
  int StartMark_Mode;  
 } IniSet_42;
  
  
#pragma pack()

//static IniSet_XXX IniSet;
static IniSet_42 IniSet;

static char theDIR[FNAMELEN+1], theMDESCR[COMMENTLEN+1];  

//*************************************************************************************

static void writeINI(void) {                           
  FILE *f;                                             
  char fname[FNAMELEN+1];                              
  sprintf(fname, "%s\\%s", theDIR, theMDESCR);         
  if((f= fopen(fname, "wb")) == NULL) return;          
  fwrite (&IniSet, sizeof(IniSet_42), 1, f);           
  fclose(f);                                           
};                                                     
                                                       
//*************************************************************************************************************

 
 
static void fillINI(void) 
{  //   UIR- 
 int j;


  

 memset(&IniSet, 0x0, sizeof(IniSet_42));
 

IniSet.StreamReadFreq=10000;

IniSet.SecMark_EnaDis=0; 
IniSet.Start_Mark_Ena=0;
IniSet.SecMark_Mode=0;

};

//#define INIFNAME "inifile.ini"

//*************************************************************************************************

static void readINI(char *xdir, char *mdescr) {
  FILE *f;
  char fname[FNAMELEN+1];
  strcpy(theDIR, xdir);
  strcpy(theMDESCR, mdescr);  
  fillINI();
  sprintf(fname, "%s\\%s", theDIR, theMDESCR);
  if((f= fopen(fname, "rb")) == NULL) return;
  fread (&IniSet, sizeof(IniSet_42), 1, f);
  fclose(f);
};

//*****************************************************************************************************

// -------------------------------------------------------------------------------------
static void showINI(void) {
 int  j;


SetCtrlVal (Pnl, PANEL_Conf_SecondMark_mode , IniSet.SecMark_Mode);  
SetCtrlVal (Pnl, PANEL_Conf_StartMark_mode , IniSet.StartMark_Mode); 

};  

static int numOfVChan(void);

static void copyIni2Ltr42Struc(TLTR42 *hltr42)
{
 int j, k;
 
 
 hltr42->Marks.SecondMark_Mode=IniSet.SecMark_Mode;
 hltr42->Marks.StartMark_Mode=IniSet.StartMark_Mode;   
 
 
};

// -------------------------------------------------------------------------------------

//static TCONTEXT theTCONTEXT;

//************************************************************************************************************

int utspConfigDevice(TCONTEXT *tc, void *q) {
  char ppath[FNAMELEN+1];
  
  memcpy(&theTCONTEXT, tc, sizeof(TCONTEXT));
  
  readINI(tc->dllpath, tc->mdescr);
  sprintf(ppath, "%s\\%s", tc->dllpath, "pluginuir.uir");
 strcpy(thePATH, ppath);
  
  Pnl= LoadPanelEx (0, ppath, PANEL_Conf, __CVIUserHInst); // ppath - , ,   uir!!! 
 
  
  showINI();  
  

  
  InstallPopup(Pnl);

  return 0;
};

// ------------------------------------------------
static int numOfVChan(void) {
 int n= 0, j;

 return n;
};

static int getCtrlVals(void) {
int j;

			 
			 GetCtrlVal (Pnl, PANEL_Conf_SecondMark_mode , &IniSet.SecMark_Mode); 
			 GetCtrlVal (Pnl, PANEL_Conf_StartMark_mode , &IniSet.StartMark_Mode); 
			 
			 
 			return 0;
};

int CVICALLBACK mf_apply (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int j;

	switch (event) {
		case EVENT_COMMIT:
		
		
		
		    getCtrlVals();
		
 			
		    writeINI(); 
		    DiscardPanel(Pnl);
		    Pnl= -1;		    
		break;
	}
	return 0;
};

// ***********************************************************************
static HANDLE hThread;
static int (*dataUpdateCBF)(int nchan, serviceStrucData X[], char *info)= NULL;
static UINT32 rd_buf[1];
//static double rd_buf_double[MAXNPOINTS * MAX_Channel];
//static double rd_buf_double_u[MAXNPOINTS * MAX_Channel];
static double ibuf[MAX_LINE];
//static double dbuf[MAX_Channel][MAXNPOINTS];
static serviceStrucData serviceDATA[MAX_LINE];

static int runFlag;

//**************************************************************************

int calcTimeOutMs(void);



static void DataRecorder(void *par) 
{

#ifdef ABC 
 int cnt, i, j, r, p;
 int n=/*32*/TOTAL_IO_LINES;
 char tmp[512];
 int q=1, dval, nline, tx;
 int tmp_err;
 double line_val[32][1];
 double *tmp_Ptr;
 int SecMark_Flag=0;
 
 

 
 DWORD tmp_src[5];
 WORD port_data_inp, port_data_out;
 DWORD port_data_inp_sm[1];
 int err;
 LPCSTR error_string;
 
 
 while(runFlag) { 
 
  
 SecMark_Flag=0; 

 

   for(j= 0; j< n; j++) 
     {
       serviceDATA[j].point= 1;
       serviceDATA[j].iarray= NULL; 
       serviceDATA[j].darray= NULL; 
       //serviceDATA[j].fs= 0;
     };

 
  //serviceDATA[0].fs=hltr42.Marks.SecondMarks_Qnt;  
  
 
 
   
  /* for(j= 0; j< n; j++)
     {
       
       line_val[j][0]=(double) ((port_data_inp>>j)&(0x00000001));
       serviceDATA[j].point=  1;
       serviceDATA[j].iarray=line_val[j];
     };
		   */

__skip_processing:

   
   dataUpdateCBF(n, serviceDATA, NULL);
   
   //  ,       
   
   port_data_out=0;
   
   for(j= 0; j< n; j++)
     {
       
       serviceDATA[j].point=  1;
       port_data_out|=((DWORD) *(serviceDATA[j].iarray))<<j;
       
     };
  
  //if(!SecMark_Flag) 
  //err=LTR42_WritePort(&hltr42, port_data_out);  

   Sleep(0);
   
   
   
   
   
 };
__end_acq:

 Sleep(500);
 ExitThread(0);
 
 #endif  

 
};

extern int testPlolog(TCONTEXT *tc);
extern void closeModule(void);

int configHW(TCONTEXT *tc, TLTR42 *hltr42)
{
 int j, k;
 LPCSTR error_string;
 
 
 readINI(tc->dllpath, tc->mdescr);
 copyIni2Ltr42Struc(hltr42);
 
 hltr42->AckEna=1;//   
 
 if( (j=LTR42_Config(hltr42)) ) 
 {
 
 
 error_string=LTR42_GetErrorString(j); 
 
 if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, (char*)error_string); 
  return j;
  
  }
  
  
  
 if(IniSet.SecMark_EnaDis)
  if( (j=LTR42_StartSecondMark(hltr42)) ) 
   {
 
 
 error_string=LTR42_GetErrorString(j); 
 
 if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, (char*)error_string); 
  return j;
  }
  
  
 
 return 0;
};


int utspStart(TCONTEXT *tc, void *p) {
  DWORD TmpDWord;
  plugStartStruc *X;

  X= (plugStartStruc *)p;
  if(testPlolog(tc)) return 1;  // !!! ??? tmp
  
  

  if(configHW(tc, &hltr42)) 
  {
     closeModule();
     return 1;
  };  

  dataUpdateCBF= X->coreCBF; // (dataUpdateCBF_FPtr)p;


  runFlag= 1;
  hThread= CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)DataRecorder, 
                        NULL, CREATE_SUSPENDED, (LPDWORD)&TmpDWord);

  ResumeThread(hThread);        // start thread here
  

  
  return 0;
};


int utspStop(TCONTEXT *tc, void *p) {
  int j;
  int c;

  runFlag= 0;
  WaitForMultipleObjects(1, &hThread, TRUE, INFINITE);
  CloseHandle(hThread);
  

  closeModule();   // !!!          - 
   //   openmodule    
  return 0;
};


// *******************************************************************************

// -------------------------------------------------------------
static int showWPanel(int ppnl, char *msg)
{
  
 /* int p= LoadPanelEx(ppnl, thePATH, WP, __CVIUserHInst);  
  if(msg!= NULL) {  
    // ... 
  };
  InstallPopup(p); 
  return p;  */
  
  return 0;
};
// -------------------------------------------------------------
static void hideWPanel(int p) {
 DiscardPanel(p);
};
// -------------------------------------------------------------
int utspConfigTe01Ext(TCONTEXT *tc, void *p) {
  return 0;
};



// -------------------------------------------------------------

// -------------------------------------------------------------
static void makeLineDescr(int ind, int type, char X[COMMENTLEN+1]) {
 
char line_type[10];    
    
  if(type==1)
    strcpy(line_type, "input");
  if(type==2)
    strcpy(line_type, "output"); 
    
    
    sprintf(X, "Line %d:%7s",ind+1,line_type);  
};
// -------------------------------------------------------------
 int utspGetDescrDIO(TCONTEXT *tc, pluginDIO *D, int line) { 
 int    ind= -1, q= 0, j;
 double fb;
 if(!line) readINI(tc->dllpath, tc->mdescr);
 
 memset(D, 0x0, sizeof(pluginDIO));
  
 for(j= 0; j< 16; j++) //   
  {
    if(j<8)
     {
      if(j==line)
       {
        ind= j;
        D->type=1; // ..   
        break; 
       };
        q++;
     };
     
     
    if((j>=8)&&(j<16))
     {
      if(j==line)
       {
        ind= j;
        D->type=1; // ..      
        break; 
       };
        q++;
     };
 };
 D->tnline=16;
 
 if(ind == -1) return 1;
 
 D->line=line;
 
 makeLineDescr(ind, D->type, D->comment);
 
 //strcpy(D->unit, "");    
 			  

 return 0;
};


int CVICALLBACK mf_mode (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int j, flag= 0;
	switch (event) {
		case EVENT_COMMIT:

			break;
	}
	return 0;
}

int CVICALLBACK mf_chan (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int j, onoff;
	switch (event) {
		case EVENT_COMMIT:

			break;
	}
	return 0;
}



// ****************************************************************************
int utspVerifyModule(TCONTEXT *tc) {
 //jumpToCalibrPanel(tc);
 return 0;
};

// ************************************************************************
static int clbPnl= -1;
//static int calibrStartData(TCONTEXT *tc, void *p);
static int calibrStopData(TCONTEXT *tc, void *p);




int CVICALLBACK ExitWork_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 int err=0;
	switch (event)
		{
		case EVENT_COMMIT:
		
if(SecondMarksFlag)
  {
	err=LTR42_StopSecondMark(&hltr42); 
	
	if(err)
	{
     error_string=LTR42_GetErrorString(err); 
     if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
     ResetTextBox (PH_Work, PANEL_Work_Status_TXT, TimeStr());
     InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">      "); 
     
    }	
   else
   {
   ResetTextBox (PH_Work, PANEL_Work_Status_TXT, TimeStr());
   InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">    "); 
    SecondMarksFlag=0; 
   } 
   SecondMarksFlag;
		 
  }   //  if(SecondMarksFlag) 
							 
							 
  DiscardPanel(PH_Work);	
		
		
			break;
		}
	return 0;
}


int CVICALLBACK Work_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{

char s[32][15];
 

 char tmp_str[30];
 char pn[2];
 //char s2[20]="PANEL_Work_";
 int top, left, height, width;
 int d=25;

 int m;
 int h=0;
 
 int i;
 WORD tmp;
 
 
 pluginDIO DIO_Descr[32];

	switch (event)
		{
		case EVENT_COMMIT:
		
	 getCtrlVals();
     writeINI(); 
     
     for(i=0;i<32;i++)
    utspGetDescrDIO(&theTCONTEXT, DIO_Descr+i, i);
     
		
	PH_Work = LoadPanelEx(0, "pluginuir.uir", PANEL_Work, __CVIUserHInst);
	
	SetCtrlAttribute (PH_Work, PANEL_Work_WriteWord_BTN, ATTR_DIMMED, 1);
	
	GetCtrlBoundingRect (PH_Work, PANEL_Work_L1, &top, &left, &height, &width); 
	
	
	for(i=0;i<16;i++) 
	{
	
	if((i>=0)&&(i<8))
	 m=0;
	 
	if((i>=8)&&(i<16))
	 m=120;
	
	
	if(h==8)
	 h=0;
	
	strcpy(s[i],"OUT"/*"IO"*/);
	sprintf(tmp_str, "%d",16-i);   
	strncat(s[i],tmp_str,3);
	
	LinesIDs[15-i]=DuplicateCtrl (PH_Work, PANEL_Work_L1, PH_Work, s[i]/*char duplicateLabel[]*/, top+h*d, left+m);
	SetCtrlAttribute (PH_Work, LinesIDs[15-i], ATTR_VISIBLE, 1);
	

	 SetCtrlAttribute (PH_Work, LinesIDs[15-i], ATTR_CTRL_MODE,  VAL_NORMAL);
	 SetCtrlAttribute (PH_Work, LinesIDs[15-i], ATTR_OFF_COLOR , VAL_DK_YELLOW);
	 SetCtrlAttribute (PH_Work, LinesIDs[15-i], ATTR_ON_COLOR , VAL_YELLOW); 
	  
	 h++;
	
	  } 
	  
	//needOpen=1;	
		
   if(testPlolog(&theTCONTEXT)) 
     return 1;  
  
  
  /* tmp=0xFF;
   LTR42_WritePort(&hltr42, tmp);   */
  
   SetCtrlVal (PH_Work, PANEL_Work_Serial_STR, hltr42.ModuleInfo.Serial);
   SetCtrlVal (PH_Work, PANEL_Work_Slot_NUM, hltr42.Channel.cc);   
  
  
   if(configHW(&theTCONTEXT, &hltr42)) 
   {
     closeModule();
     return 1;
   }; 
   
   SetCtrlAttribute (PH_Work, PANEL_Work_WriteWord_BTN, ATTR_DIMMED, 0);
 
   
   SetCtrlAttribute (PH_Work, PANEL_Work_Status_TXT, ATTR_WRAP_MODE, VAL_LINE_WRAP); 
   
   ResetTextBox(PH_Work, PANEL_Work_Status_TXT, TimeStr());
   InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT,-1, ">     ");  
    
   InstallPopup(PH_Work); 	 		
		
//testPlolog  
	break;
		}
	return 0;
}


int CVICALLBACK ReadWord_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
#ifdef ABC
  int err;
  WORD LineVal;
  int i;
  
  WORD ReceivedWord;
  

	switch (event)
		{
		case EVENT_COMMIT:
		
		

			break;
		}
		
#endif		
	return 0;
}

int CVICALLBACK WriteWord_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{

  int LineVal;
  int i;
  int err=0;
  int tick1, tick2;
  double tick;
  LARGE_INTEGER Freq, Start, Fin;
  double R_Time[1000];
  
  WORD WordToWrite=0;
  WORD WriteArray[1000];

	switch (event)
		{
		case EVENT_COMMIT:
		
		//      
		
		for(i=0;i<16;i++)
		 {
		   GetCtrlVal (PH_Work, LinesIDs[i], &LineVal);
		   
		   //WordToWrite<<=1;
		   WordToWrite|=(LineVal<<i);
		   
		  } 
	 
		  
		 SetCtrlVal (PH_Work, PANEL_Work_HEX, WordToWrite);  
		 
		 err=LTR42_WritePort(&hltr42,WordToWrite); 
		 
		 ;
		  //tick1=GetTickCount();
		  
		  
		// memset(WriteArray,0,1000*sizeof(WORD));
		 
		// WriteArray[999]=0x1;
		 
	//	 err=LTR42_WriteArray(&hltr42, WriteArray, 1000);   
		 
		
		  
		 /* 
		 QueryPerformanceFrequency(&Freq);
 
		 for(i=0;i<1000;i++)
		 {
		 QueryPerformanceCounter(&Start);
		  err=LTR42_WritePort(&hltr42, WordToWrite);
		 QueryPerformanceCounter(&Fin);  
		 
		 
		 
		 R_Time[i] = ((Fin.QuadPart - Start.QuadPart)*1.0)/(Freq.QuadPart*1.0); 
			R_Time[i]*=1000.0;

		  }*/
		 
		 //tick2=GetTickCount(); 
		 
		 //tick=(tick2-tick1)/1000.0;  
		 ;
		 
		 
		 
		 if(err)
		{
		   error_string=LTR42_GetErrorString(err); 
           if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
          ResetTextBox(PH_Work, PANEL_Work_Status_TXT, TimeStr());
          InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">       /!");        
           
           return 1;
         }
        else
        {			
          ResetTextBox(PH_Work, PANEL_Work_Status_TXT, TimeStr());
          InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT,-1, ">     /  ");      
        }   
		   
			break;
		}
	return 0;
}

int CVICALLBACK SecondMarksGo_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
    int err=0;
    
	switch (event)
		{
		case EVENT_COMMIT:
		
 err=LTR42_StartSecondMark(&hltr42);  
 
 if(err)
 {
  error_string=LTR42_GetErrorString(err); 
  if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string);
   ResetTextBox (PH_Work, PANEL_Work_Status_TXT, TimeStr());
   InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">      "); 
  
  return 1;
 }
 else
 {
   SecondMarksFlag=1;
   ResetTextBox (PH_Work, PANEL_Work_Status_TXT, TimeStr());
   InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">    "); 
 } 
 
		   

			break;
		}
	return 0;
}

int CVICALLBACK SecondMarksStop_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 int err=0;
 
	switch (event)
		{
		case EVENT_COMMIT:
		
	err=LTR42_StopSecondMark(&hltr42); 
	
	if(err)
	{
     error_string=LTR42_GetErrorString(err); 
     if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
     ResetTextBox (PH_Work, PANEL_Work_Status_TXT, TimeStr());
     InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">      "); 
     
    return 1;
    }	
   else
   {
   ResetTextBox (PH_Work, PANEL_Work_Status_TXT, TimeStr());
   InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">    "); 
    SecondMarksFlag=0; 
   } 
         
	
		

			break;
		}
	return 0;
}

int CVICALLBACK MakeStartMark_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 int err=0;
	switch (event)
		{
		case EVENT_COMMIT:
		
	err=LTR42_MakeStartMark(&hltr42);  
	
	if(err)
		{
		   error_string=LTR42_GetErrorString(err); 
           if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
            InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">     !");  
           return 1;
         }
   else
   {
   ResetTextBox (PH_Work, PANEL_Work_Status_TXT, TimeStr());
   InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">   "); 
   } 
         
	
	

			break;
		}
	return 0;
}



int CVICALLBACK StartMarksReset_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 int err=0;    
	switch (event)
		{
		case EVENT_COMMIT:
		
		if(err)
		{
		   error_string=LTR42_GetErrorString(err); 
           if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
           return 1;
         }	 
         

			break;
		}
	return 0;
}

int CVICALLBACK SecondMarksReset_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 int err=0;
 
	switch (event)
		{
		case EVENT_COMMIT:
		
		
	
	if(err)
		{
		   error_string=LTR42_GetErrorString(err); 
           if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
           return 1;
         }	 
         
			break;
		}
	return 0;
}


int CVICALLBACK OutSize_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 int New_Size;
     
 
	switch (event)
		{
		case EVENT_VAL_CHANGED :
		

			break;
		}
	return 0;
}

int CVICALLBACK InSize_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  int New_Size; 
  
  
	switch (event)
		{
		case EVENT_VAL_CHANGED :
		

			break;
		}
	return 0;
}


int CVICALLBACK Exit_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 int err=0;
	switch (event)
		{
		case EVENT_COMMIT:
		
	     closeModule();	
	     
	     getCtrlVals();  
		 writeINI(); 
		    DiscardPanel(Pnl);
		    Pnl= -1;
		 
		 

			break;
		}
	return 0;
}



int CVICALLBACK Close (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
		
		 DiscardPanel(PH_Work);	  

			break;
		}
	return 0;
}

int CVICALLBACK CloseAll (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
		
		  closeModule();	
	     
	     getCtrlVals();  
		 writeINI(); 
		    DiscardPanel(Pnl);
		    Pnl= -1;
		 
	

			break;
		}
	return 0;
}

