.MODULE/ABS=0/SEG=INT_PM_USER                 main_program;

#include "const.h"
#include "var.h"


#define TT NOP;NOP;NOP;NOP;NOP;NOP;NOP;NOP;NOP;NOP;NOP;NOP;NOP; NOP; NOP; NOP; NOP; NOP; NOP; NOP
#define PM_SIZE  4096


{ reset }
StartLab:
        JUMP Start; nop; nop; nop;
{ IRQ2 }
        JUMP IRQ2_Handler; NOP; NOP; NOP;
        RTI; NOP; NOP; NOP;
        RTI; NOP; NOP; NOP;
  
{ SPORT0 Transmit }
        RTI; NOP;NOP;NOP;
   
{ SPORT0 receive }    
        JUMP Sport0Receive_IRQ; NOP; NOP; NOP; 
        RTI;NOP;NOP;NOP;
        RTI;NOP;NOP;NOP;
{SPORT1 Transmit}
        JUMP Sport1Transmit_IRQ; NOP; NOP; NOP;
        JUMP Sport1Receive_IRQ; NOP; NOP; NOP;
{TIMERinter:}
        RTI;NOP;NOP;NOP;

 {PowerDown:
        RTI;NOP;NOP;NOP; }

{ *********************************************************************** }
{ * After Reset we appear to be here                                                                                                                                            * }
{ *********************************************************************** }
Start:
        DIS SEC_REG;          { disabled secondary registers      }
        DIS TIMER;
        DMOVLAY=0;            { no overlays}


        AR=B#01110111;           { PF types (input/output) }
        DM(Prog_Flag_Type)=AR;
        AR=B#00000000;
        DM(Prog_Flag_Data)=AR;   { PF init. values } 

                        
        AR=B#00100000;           { Any codec isn't selected }
   
        DM(Prog_Flag_Data)=AR;
        NOP; NOP; 

        AR=0;
        DM(Prog_Flag_Data)=AR;
        
        IMASK=0x0;

{**********************    *******************}
AR=1;
DM(SW_MajorVersion)=AR;

AR=2;
DM(SW_MinorVersion)=AR;

AR=2006;
DM(SW_Date_Year)=AR;

AR=10;
DM(SW_Date_Month)=AR;

AR=05;
DM(SW_Date_Day)=AR;




{*******************************************************************************}




{**********************  SPORT0  ***********************}

        AR=B#0011101000001000;       { Configuring of SPORT 0}
        DM(Sport0_Ctrl_Reg) = AR;
        AR=0;
        DM(Sport0_Autobuf_Ctrl)=AR;   {Autobuferezation disabled }

{***********************  SPORT1 ************************}


        AR=B#0111111111000111;       { SLEN=7 (8-bit word }
        DM(Sport1_Ctrl_Reg) = AR;    { SClk-internal; RFS, TFS-each word, int., alt, neg }

        AR=0;
        DM(Sport1_Autobuf_Ctrl)=AR;   {Autobuferezation disabled }

        AR={26}9;                         {SCLKDIV=26, 24.576/(26+1)=0.91 MHz }
        DM(Sport1_Sclkdiv)=AR;            {SCLKDIV=9, 24.576/(9+1)=2,46 MHz }



        AR=30;
        DM(Sport1_Rfsdiv)=AR;        { 31 SCLK between RFS }

        IFC=0xFF;                    { Clear interrupts }

        

        AR=0;
        DM(Rx0Ready)=AR;

        DM(CommandRcvFlag)=AR;      { init. values for flags, counters, command }
        DM(TrFlag)=AR;
        DM(Command)=AR;

        DM(BytesRcvCounter)=AR;
        DM(BytesTrCounter)=AR;

        DM(Sport1TxFlag)=AR;
        DM(Sport1RxFlag)=AR;


        ENA M_MODE;   {   MR }

 { ***************************************************************************************** }
 { I0-     FIR-;                                            }
 { I3-     IIR-                                            }
 { I4-      IIR-                                    }
 { I5-      FIR-                                    }

 {                                     }                                           

        I0=^Samples_For_Filter_0;
        L0=0;
        M0=1;

        I3=^DelayLine_0;
        L3=0;
        M3=1;

        I4=^IIR_Coeffs;
        L4=5;
        M4=1;

        I5=^FIR_Coeffs;
        L5=230;
        M5=1;

        SE=0;

         
        RESET FL0;       {    AD7730 }
        RESET FL1;       {      }
        
        NOP; NOP; NOP; NOP; NOP; NOP; NOP; NOP; NOP; NOP; NOP; NOP; 
        
        SET FL0;
                 
{ ****************************   ************************************* }

        ICNTL=B#01111; {  !!!!!    !   }
                       {     !                                 }

                       {    }

        IMASK=B#0000100110; { SPORT0-R, SPORT1-R/T  are evalaible }
        IFC=0xFF;   
{ ********************************************************************** }


        AR=B#0001010000000000;             {  SPORT0.     }
        DM(Sys_Ctrl_Reg)=AR;               {  c - }

        {   }                       
         
Start_Loop:

 AX0=DM(Prog_Flag_Data);
 AY0=B#0000000010000000;
 AR=AX0 AND AY0; 

 NONE=PASS AR;
 IF NE JUMP Start_Loop;

 IMASK=B#1000100110; { SPORT0-R, SPORT1-R/T, IRQ2  are evalaible }

 Start_Loop_2:
 AX1=DM(Command);
 AY1=30;
 AR=AX1 XOR AY1;
 IF NE JUMP  Start_Loop_2;


 I4=^Commands_Buf;
 M4=0;
 L4=%Commands_Buf;
 DM(Cur_Command_Buf_Addr)=I4;
 DM(Cur_Command_Loop_Addr)=I4;



 I4=^Commands_Buf;   
 M4=1;
 L4=%Commands_Buf;   


 CNTR=%Commands_Buf;
 DO Init_Commands_Buf UNTIL CE;

 PX=0; AX0=0x0;
 PM(I4,M4)=AX0;
 

 Init_Commands_Buf: NOP;


 AR=0;
 DM(Command)=AR; 


  AR=30;
  DM(CommandHByteTr)=AR;

  AR=0;
  DM(CommandMByteTr)=AR;
  DM(CommandLByteTr)=AR;
  CALL MakeCommand;  




TT;TT;TT;TT;TT;TT;TT;TT;TT;TT;


{       } 
 Call Flash_DIS_Word;   

 
{ ******************   *************************** }

MainLoop:


 IMASK=B#1000000110; {      SPORT0 }

 I4=DM(Cur_Command_Loop_Addr); {    }
 M4=0;
 L4=%Commands_Buf;


 AR=PM(I4,M4);
 AX0=PX;
 AY0=0x1F; {           }
 AR=AX0 AND AY0;
 DM(CmdTmp)=AR;{PX;}

 IMASK=B#1000100110; {     SPORT0} 


 AR=DM(CmdTmp);
 

 NONE=PASS AR;
 IF EQ JUMP MainLoop;

 AR=AR-1;
 NONE=PASS AR;
 IF EQ JUMP Reset_AD7730_Command;   {   }                              {1}

 AR=AR-1;
 NONE=PASS AR;            
 IF EQ JUMP Select_Codec_Command; {  ,   AR (0-3) }          {2}


 AR=AR-1;
 NONE=PASS AR;
 IF EQ JUMP Write_8bit_Reg_Command;  {    / . () }  {3}

 AR=AR-1;
 NONE=PASS AR;
 IF EQ JUMP Read_8bit_Reg_Command;                                                 {4}

 AR=AR-1;
 NONE=PASS AR;
 IF EQ JUMP Write_16bit_Reg_Command;                                               {5}  

 AR=AR-1;
 NONE=PASS AR;
 IF EQ JUMP Read_16bit_Reg_Command;                                                {6}

 AR=AR-1;
 NONE=PASS AR;
 IF EQ JUMP Write_24bit_Reg_Command;                                               {7}

 AR=AR-1;
 NONE=PASS AR;
 IF EQ JUMP Read_24bit_Reg_Command;                                                {8}
                                           
 AR=AR-1;
 NONE=PASS AR;
 IF EQ JUMP Data_Acquisition_Command; {     }    {9}


 AR=AR-1;
 NONE=PASS AR;
 IF EQ JUMP Calibr_4Ch;   {   }                                 {10}
  

 AR=AR-1;
 NONE=PASS AR;
 IF EQ JUMP Flash_Write_Command; {     }                       {11}


 AR=AR-1;
 NONE=PASS AR;
 IF EQ JUMP Flash_Read_Command; {     }                        {12}


 AR=AR-1;
 NONE=PASS AR;
 IF EQ JUMP Load_Channel;  {       }      {13}


 AR=AR-1;
 NONE=PASS AR;
 IF EQ JUMP Set_Ref;    {   . }                               {14}


 AR=AR-1;
 NONE=PASS AR;
 IF EQ JUMP Load_FIR;  {    - }          {15}


 AR=AR-1;
 NONE=PASS AR;
 IF EQ JUMP Load_IIR;  {    - }          {16}


 AR=AR-1;
 NONE=PASS AR;
 IF EQ JUMP Manage_Filters; { /   }          {17}


 AR=AR-1; 
 NONE=PASS AR;
 IF EQ JUMP Test_BIOS;             { - }                              {18}


 AR=AR-1; 
 NONE=PASS AR;
 IF EQ JUMP Load_DAC_Buffer;   {       }         {19}


 AR=AR-1; 
 NONE=PASS AR;
 IF EQ JUMP Calibr_8Ch;       {   8-  }                  {20}


 AR=AR-1; 
 NONE=PASS AR;
 IF EQ JUMP Test_Data_Aqcuisition;  {   }           {21}

 AR=AR-1; 
 NONE=PASS AR;
 IF EQ JUMP Check_SerNum_Code;      {    }                     {22}


 AR=AR-1; 
 NONE=PASS AR;
 IF EQ JUMP Get_SW_Version;       {    }                       {23}
                                                                              

 AR=AR-1; 
 NONE=PASS AR;
 IF EQ JUMP Get_SW_Date;    {     }                      {24}

                              
                                                                         
 AR=AR-1;                  
 NONE=PASS AR;                                                                     {25}
 IF EQ JUMP Check_Ch_mode;  {   }                                                                          {23}

AR=AR-1;                                                                          {26}

AR=AR-1;                                                                          {25}

AR=AR-1;                                                                          {27}

AR=AR-1;                                                                          {28}



AR=AR-1;                                                                          {29}
NONE=PASS AR;
IF EQ JUMP Dummy_Test;


AR=AR-1;                                                                          {30}

AR=AR-1;                                                                          {31}
NONE=PASS AR;
IF EQ JUMP Dummy_Stop;




JUMP MainLoop;


{******************************************************************************
                                           

*******************************************************************************}


Check_Ch_mode:

{CALL Delay_16mks;  }



CALL Command_Context_Definition;
AR=DM(Parity_Error_Flag);
NONE=PASS AR;
IF NE JUMP Parity_Error_Abort; {        . ,
                                   ""    .   }   
 



{CALL Eval_Parity;  }


AX1=16;
DM(CommandHByteTr)=AX1;  
DM(CommandLByteTr)=AR;
{SR=LSHIFT AR BY -8 (LO);   }

AR=0xFE{DM(Parity)}; 
DM(CommandMByteTr)=AR{SR0}; 
   

CALL MakeCommand;  
  TT;TT;TT;TT;TT;TT;TT;TT;TT;TT;TT;TT;TT;TT;
  

CALL Go_To_Next_CmdBuf_Position;   
JUMP MainLoop; 
       



{******************************************************************************
    AD7730                                     
*******************************************************************************}


Reset_AD7730_Command:

 AR=0;
 DM(Command)=AR;

 CALL Reset_AD7730;
 
 AR=1;  
 DM(CommandHByteTr)=AR;
 AR=0;
 DM(CommandMByteTr)=AR;
 DM(CommandLByteTr)=AR;

 CALL MakeCommand;
 

 CALL Go_To_Next_CmdBuf_Position;   
 JUMP MainLoop; 


 Reset_AD7730:
 
 RESET FL0;
 NOP; NOP; NOP; NOP; NOP; NOP; NOP; NOP; NOP; NOP; NOP; NOP;  
 SET FL0;
 RTS;
  

{******************************************************************************
   ,    AR (0-3)                                      

*******************************************************************************}


Select_Codec_Command:  

 CALL Command_Context_Definition; 

 {     -     }

 AR=DM(Parity_Error_Flag);
 NONE=PASS AR;
 IF NE JUMP Parity_Error_Abort; {        . ,
                                   ""    .   }   


 
 AR=DM(CmdContextMByte);
 SR=LSHIFT AR BY 8 (LO);
 AX0=DM(CmdContextLByte);
 AY0=SR0;
 AR=AX0 OR AY0;
 CALL Select_Codec;
 


 AR=2;
 DM(CommandHByteTr)=AR; {         }
 AR=0;
 DM(CommandMByteTr)=AR;
 DM(CommandLByteTr)=AR;
 CALL MakeCommand;


 CALL Go_To_Next_CmdBuf_Position;   
 JUMP MainLoop; 


 Select_Codec: 

 NONE=PASS AR;
 IF EQ JUMP Select_1_Codec;

 AR=AR-0x1;
 NONE=PASS AR;
 IF EQ JUMP Select_2_Codec;

 AR=AR-0x1;
 NONE=PASS AR;
 IF EQ JUMP Select_3_Codec;

 AR=AR-0x1;
 NONE=PASS AR;
 IF EQ JUMP Select_4_Codec;

 End_Select:
 AR=0;
 RTS;



 Select_1_Codec:
 
   
  AR=DM(Prog_Flag_Data);
  AR=CLRBIT 5 OF AR;
  DM(Prog_Flag_Data)=AR;

  NOP; 

  AR=SETBIT 5 OF AR;

  DM(Prog_Flag_Data)=AR; 

  NOP; 

  AR=CLRBIT 5 OF AR; 
 
  DM(Prog_Flag_Data)=AR; 

  NOP;  

  AR=SETBIT 4 OF AR; 
  DM(Prog_Flag_Data)=AR; 

  NOP; 
  
  AR=CLRBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR;  

  AR=0;
  DM(Selected_Codec)=AR; 

  AR=0;
  JUMP End_Select;  

 Select_2_Codec:
   

  AR=DM(Prog_Flag_Data);
  AR=CLRBIT 5 OF AR;
  DM(Prog_Flag_Data)=AR;

  NOP;  

  AR=SETBIT 5 OF AR;
  DM(Prog_Flag_Data)=AR; 

  NOP;

  AR=CLRBIT 5 OF AR;  
  DM(Prog_Flag_Data)=AR; 

  NOP;   

  AR=SETBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR; 

  NOP; 
  
  AR=CLRBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR; 

  NOP; 

  AR=SETBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR; 

  NOP; 

  AR=CLRBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR; 

  AR=1;
  DM(Selected_Codec)=AR; 

  AR=0;   
  JUMP End_Select;  


 Select_3_Codec:


  AR=DM(Prog_Flag_Data);
  AR=CLRBIT 5 OF AR;
  DM(Prog_Flag_Data)=AR;

  NOP;  

  AR=SETBIT 5 OF AR;
  DM(Prog_Flag_Data)=AR; 

  NOP;

  AR=CLRBIT 5 OF AR;  
  DM(Prog_Flag_Data)=AR; 

  NOP;   

  AR=SETBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR; 

  NOP; 
  
  AR=CLRBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR; 

  NOP; 

  AR=SETBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR; 

  NOP; 

  AR=CLRBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR;

  NOP;

  AR=SETBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR; 

  NOP; 

  AR=CLRBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR;

  AR=2;
  DM(Selected_Codec)=AR;      
 
  AR=0;
 
  JUMP End_Select;


 Select_4_Codec:
  

  AR=DM(Prog_Flag_Data);
  AR=CLRBIT 5 OF AR;
  DM(Prog_Flag_Data)=AR;

  NOP;  

  AR=SETBIT 5 OF AR;
  DM(Prog_Flag_Data)=AR; 

  NOP;

  AR=CLRBIT 5 OF AR;  
  DM(Prog_Flag_Data)=AR; 

  NOP;   

  AR=SETBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR; 

  NOP;   

  AR=CLRBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR; 

  NOP; 

  AR=SETBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR; 

  NOP; 

  AR=CLRBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR;

  NOP;

  AR=SETBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR; 

  NOP; 

  AR=CLRBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR;

  NOP;

  AR=SETBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR; 

  NOP; 

  AR=CLRBIT 4 OF AR;  
  DM(Prog_Flag_Data)=AR;
 
  AR=3;
  DM(Selected_Codec)=AR; 

  AR=0;  
  JUMP End_Select; 


 {********************************************************************************
      8-   (   )                                      

 *********************************************************************************}

 
 
Write_8bit_Reg_Command:

 AR=0;
 DM(Command)=AR; 

 CALL Command_Context_Definition;


 AR=DM(Parity_Error_Flag);
 NONE=PASS AR;
 IF NE JUMP Parity_Error_Abort; {        . ,
                                   ""    .   }   


 AR=DM(CmdContextLByte);{DM(CommandLByteRcv)}

 DM(Sport1TxData)=AR;   {         Sport1 }

 CALL Write_8bit_Reg;

  AR=3;
  DM(CommandHByteTr)=AR;
  AR=0;
  DM(CommandMByteTr)=AR;
  DM(CommandLByteTr)=AR;
  CALL MakeCommand;       {      }


 CALL Go_To_Next_CmdBuf_Position;   
 JUMP MainLoop; 



{********************************************************************************
      8-                                         

*********************************************************************************}

  
Write_8bit_Reg:

 AR=0;

 AR=B#0111111111000111;       { SLEN=7 (8-bit word }
 DM(Sport1_Ctrl_Reg) = AR;    { SClk-; RFS, TFS-., int., alt, neg }
    
 AR=65535; 
 DM(Sport1_Rfsdiv)=AR;

 AR=DM(Sport1TxData);   
 
 AR=NOT AR; 

 DM(Sport1TxData)=AR; 

 AX0=B#0001110000000000;         {   SPORT1  }     
 DM(Sys_Ctrl_Reg)=AX0;                                 



 TX1=AR;                          {     }

 WaitForTX1:                      { ,      }
 AR=DM(Sport1TxFlag);
 NONE=PASS AR;
 IF EQ JUMP WaitForTX1;

                                 {        }
 CALL Delay_7mks;

 AR=B#0001010000000000;           {  SPORT1    }
 DM(Sys_Ctrl_Reg)=AR;    

 AR=0;
 DM(Sport1TxFlag)=AR;              {     SPORT1 }  

 RTS; 

{********************************************************************************
      8-   (   )                                      

*********************************************************************************}

Read_8bit_Reg_Command:

 AR=0x0;
 DM(Command)=AR;

 CALL Read_8bit_Reg;

                          {   ,     , }
 AR=4;                    {                                   }
 DM(CommandHByteTr)=AR;

 AR=0;
 DM(CommandMByteTr)=AR;

 AR=DM(Sport1RxData); 
 DM(CommandLByteTr)=AR;

 CALL MakeCommand;    



 CALL Go_To_Next_CmdBuf_Position;   
 JUMP MainLoop; 


 Read_8bit_Reg:


 AR=2;
 DM(Sport1_Rfsdiv)=AR;

 AR=B#0111111111000111;       { SLEN=7 (8-bit word }
 DM(Sport1_Ctrl_Reg) = AR;    { SClk-internal; RFS, TFS-each word, int., alt, neg }
  

 AR=B#0001110000000000;       {   SPORT1    }
 DM(Sys_Ctrl_Reg)=AR;  

 WaitForRX1:                  { ,    }
 AR=DM(Sport1RxFlag);
 NONE=PASS AR;
 IF EQ JUMP WaitForRX1;

 AR=B#0001010000000000;       {   SPORT1   }
 DM(Sys_Ctrl_Reg)=AR; 

 AR=0;
 DM(Sport1RxFlag)=AR; 
  
 AR=0;

 RTS;


{*********************************************************************************
   16-   (   )

********************************************************************************}

Write_16bit_Reg_Command:


 AR=0;
 DM(Command)=AR;

 CALL Command_Context_Definition;

 AR=DM(Parity_Error_Flag);
 NONE=PASS AR;
 IF NE JUMP Parity_Error_Abort; {        . ,
                                   ""    .   }  
 AR=DM(CmdContextMByte);
 AX0=DM(CmdContextLByte);


 SR=LSHIFT AR BY 8 (LO);
 AY0=SR0;
 AR=AX0 OR AY0;

 DM(Sport1TxData)=AR;

 CALL Write_16bit_Reg;

  AR=5;
  DM(CommandHByteTr)=AR;
  AR=0;
  DM(CommandMByteTr)=AR;
  DM(CommandLByteTr)=AR;
  CALL MakeCommand;

 CALL Go_To_Next_CmdBuf_Position;   
 JUMP MainLoop; 


Write_16bit_Reg:

                 
 AR=65535;
 DM(Sport1_Rfsdiv)=AR;

 AR=B#0111111111001111;       { SLEN=15 (16-bit word }
 DM(Sport1_Ctrl_Reg) = AR;    { SClk-internal; RFS, TFS-each word, int., alt, neg }

 AR=DM(Sport1TxData);   
 AR=NOT AR; 

 AX0=B#0001110000000000;        {    SPORT1 enabled }     
 DM(Sys_Ctrl_Reg)=AX0;                                 

 TX1=AR;

WaitForTX1_16:
 AR=DM(Sport1TxFlag);
 NONE=PASS AR;
 IF EQ JUMP WaitForTX1_16;

 CALL Delay_16mks;

 AR=B#0001010000000000;           {  SPORT1 disabled   }
 DM(Sys_Ctrl_Reg)=AR;    

 AR=0;
 DM(Sport1TxFlag)=AR; 

 RTS;


{***********************************************************************************
   16-   (   )

************************************************************************************}

Read_16bit_Reg_Command:

 AR=0x0;
 DM(Command)=AR;

 CALL Read_16bit_Reg;
                          {   ,     , }
 AR=6;                    {      }
 DM(CommandHByteTr)=AR;

 AR=DM(Rd16bitRegValue);
 SR=LSHIFT AR BY -8 (LO); 
                                
 DM(CommandMByteTr)=SR0;
 DM(CommandLByteTr)=AR;
 CALL MakeCommand;        


 CALL Go_To_Next_CmdBuf_Position;   
 JUMP MainLoop; 


Read_16bit_Reg:


 AR=2; 
 DM(Sport1_Rfsdiv)=AR;

 AR=B#0111111111001111;       { SLEN=15 (16-bit word }
 DM(Sport1_Ctrl_Reg) = AR;    { SClk-internal; RFS, TFS-each word, int., alt, neg }

 IMASK=B#1000000110;          {     SPORT0} 

 AR=B#0001110000000000;       {  SPORT1 enabled      }
 DM(Sys_Ctrl_Reg)=AR;  

WaitForRX1_16:
 AR=DM(Sport1RxFlag);
 NONE=PASS AR;
 IF EQ JUMP WaitForRX1_16;

 AR=B#0001010000000000;        {  SPORT1 disabled      }
 DM(Sys_Ctrl_Reg)=AR; 

 IMASK=B#1000100110; {     SPORT0}

 AR=0;
 DM(Sport1RxFlag)=AR; 

 AR=DM(Sport1RxData);  
 DM(Rd16bitRegValue)=AR;

 AR=0;

 RTS;    



{*********************************************************************************
   24-   (   )

********************************************************************************}

Write_24bit_Reg_Command:


 AR=0x0;
 DM(Command)=AR;


 CALL Command_Context_Definition;


 AR=DM(Parity_Error_Flag);
 NONE=PASS AR;
 IF NE JUMP Parity_Error_Abort; {        . ,
                                   ""    .   }   
      
 AR=DM(Wr24bitRegWordCounter);
 NONE=PASS AR;
 IF NE JUMP tr16bit_part;

 AR=1;
 DM(Wr24bitRegWordCounter)=AR;

 AR=DM(CmdContextLByte);

 DM(Wr24bitRegFirst8Bits)=AR;

 CALL Go_To_Next_CmdBuf_Position;   
 JUMP MainLoop; 


tr16bit_part:

 AR=DM(CmdContextMByte);
 AX0=DM(CmdContextLByte);



 SR=LSHIFT AR BY 8 (LO);
 AY0=SR0;
 AR=AX0 OR AY0;

 DM(Wr24bitRegLast16Bits)=AR;
 CALL Write_24bit_Reg;

 AR=0;
 DM(Wr24bitRegWordCounter)=AR;


  AR=7;
  DM(CommandHByteTr)=AR;
  AR=0;
  DM(CommandMByteTr)=AR;
  DM(CommandLByteTr)=AR;
  CALL MakeCommand;


  CALL Go_To_Next_CmdBuf_Position;   
  JUMP MainLoop; 

   

Write_24bit_Reg:                
  

 AR=B#0111111111000111;       { SLEN=7 (8-bit word }
 DM(Sport1_Ctrl_Reg) = AR;    { SClk-internal; RFS, TFS-each word, int., alt, neg }

 AR=65535;
 DM(Sport1_Rfsdiv)=AR;

 AR=DM(Wr24bitRegFirst8Bits);   
 AR=NOT AR; 

 DM(Sport1TxData)=AR; 

 AX0=B#0001110000000000;         {    SPORT1 enabled }     
 DM(Sys_Ctrl_Reg)=AX0;                                 



 TX1=AR;

 WaitForTX1_24_8:
 AR=DM(Sport1TxFlag);
 NONE=PASS AR;
 IF EQ JUMP WaitForTX1_24_8;

 CALL Delay_7mks;


 AR=B#0001010000000000;           {  SPORT1 disabled   }
 DM(Sys_Ctrl_Reg)=AR;    

 AR=0;
 DM(Sport1TxFlag)=AR; 

 AR=65535;
 DM(Sport1_Rfsdiv)=AR;

 AR=B#0111111111001111;       { SLEN=15 (16-bit word }
 DM(Sport1_Ctrl_Reg) = AR;    { SClk-internal; RFS, TFS-each word, int., alt, neg }

 AR=DM(Wr24bitRegLast16Bits);   
 
 DM(Sport1TxData)=AR;
 
 AR=NOT AR; 

 AX0=B#0001110000000000;         {    SPORT1 enabled }     
 DM(Sys_Ctrl_Reg)=AX0;                                 

 TX1=AR;

 WaitForTX1_24_16:
 AR=DM(Sport1TxFlag);
 NONE=PASS AR;
 IF EQ JUMP WaitForTX1_24_16;

CALL Delay_16mks;

 AR=B#0001010000000000;           {  SPORT1 disabled   }
 DM(Sys_Ctrl_Reg)=AR;    
 
 AR=0;
 DM(Sport1TxFlag)=AR; 

 RTS; 


{***********************************************************************************
   24-   (   )

************************************************************************************}

Read_24bit_Reg_Command:

 AR=0x0;
 DM(Command)=AR;


 CALL Read_24bit_Reg;

 AX0=DM(Rd24bitRegValue_FirstByte);
 AY0=0;
 AR=8;

 DM(CommandHByteTr)=AR;  
 DM(CommandLByteTr)=AX0;  
 DM(CommandMByteTr)=AY0;

 CALL MakeCommand;


 WaitTrEnd:  
 AR=DM(TrFlag);
 NONE=PASS AR;
 IF NE JUMP WaitTrEnd; 

 TT;

 AR=DM(Rd24bitRegValue_LastTwoBytes);

 SR=LSHIFT AR BY -8 (LO); 
  
   
 DM(CommandMByteTr)=SR0;

 DM(CommandLByteTr)=AR;
 AR=8;
 DM(CommandHByteTr)=AR;   

 CALL MakeCommand; 


 CALL Go_To_Next_CmdBuf_Position;   
 JUMP MainLoop; 


 Read_24bit_Reg:


 AR=2;
 DM(Sport1_Rfsdiv)=AR;

 AR=B#0111111111000111;       { SLEN=7 (8-bit word }
 DM(Sport1_Ctrl_Reg) = AR;    { SClk-internal; RFS, TFS-each word, int., alt, neg }

 IMASK=B#1000000110;          {     SPORT0 } 

 AR=B#0001110000000000;       {  SPORT1 enabled      }
 DM(Sys_Ctrl_Reg)=AR;  

 WaitForRX1_24_1:
 AR=DM(Sport1RxFlag);
 NONE=PASS AR;
 IF EQ JUMP WaitForRX1_24_1;

 AR=B#0001010000000000;        {  SPORT1 disabled      }
 DM(Sys_Ctrl_Reg)=AR; 

 IMASK=B#1000100110; {     SPORT0} 



 AR=0;
 DM(Sport1RxFlag)=AR; 

 AX0=DM(Sport1RxData);  { H. Byte of 24-bit word }
 DM(Rd24bitRegValue_FirstByte)=AX0;


 AR=2;{10;}{1200;}
 DM(Sport1_Rfsdiv)=AR;


 AR=B#0111111111001111;       { SLEN=15 (16-bit word }
 DM(Sport1_Ctrl_Reg) = AR;    { SClk-internal; RFS, TFS-each word, int., alt, neg }

 IMASK=B#1000000110; {     SPORT0} 


 AR=B#0001110000000000;           {  SPORT1 enabled      }
 DM(Sys_Ctrl_Reg)=AR;  

 WaitForRX1_24_2:
 AR=DM(Sport1RxFlag);
 NONE=PASS AR;
 IF EQ JUMP WaitForRX1_24_2;

 AR=B#0001010000000000;           {  SPORT1 disabled      }
 DM(Sys_Ctrl_Reg)=AR; 

 IMASK=B#1000100110; {     SPORT0} 

 AR=0;
 DM(Sport1RxFlag)=AR; 

 AR=DM(Sport1RxData);
 DM(Rd24bitRegValue_LastTwoBytes)=AR; 

 RTS; 


{****************************************************************************************
                   .  

****************************************************************************************} 
                          
 
Load_Channel:

 Call Command_Context_Definition;

 AR=DM(Parity_Error_Flag);
 NONE=PASS AR;
 IF NE JUMP Parity_Error_Abort; {        . ,
                                   ""    .   }   
 
 AR=0x0;
 DM(Command)=AR;


 I2=^Mode_8chan_Ranges;
 L2=0;


 AR=DM(CmdContextMByte);
 SR=LSHIFT AR BY 8 (LO);
 AY0=DM(CmdContextLByte);
 AX0=SR0;
 AR=AX0 OR AY0;
 
 SR0=DM(CmdContextMByte);  {          }
 SR=LSHIFT SR0 BY -5 (LO);


 M2=SR0;     
 MODIFY(I2,M2);
 M2=0;   

 AX0=B#0001111111111111;
 AY0=AR;                 {         }   
 AR=AX0 AND AY0;

 DM(I2,M2)=AR; 


  AR=13;
  DM(CommandHByteTr)=AR;
  AR=0;
  DM(CommandMByteTr)=AR;
  DM(CommandLByteTr)=AR;
  CALL MakeCommand;

 CALL Go_To_Next_CmdBuf_Position;   
 JUMP MainLoop; 


{ ********************************************************************************************* 
            -  

 ********************************************************************************************* }

Data_Acquisition_Command:

 AR=0x0;
 DM(Command)=AR;

 Call Command_Context_Definition;

 AR=DM(Parity_Error_Flag);
 NONE=PASS AR;
 IF NE JUMP Parity_Error_Abort; {        . ,
                                   ""    .   }   


 AR=DM(CmdContextLByte);
 DM(Channel_Mask)=AR;


 AR=DM(CmdContextMByte);
 NONE=PASS AR;
 IF NE JUMP Mode_8Channel;


 Mode_4Channel:   {  4-   }


  AR=9{10};
  DM(CommandHByteTr)=AR;
  AR=0;
  DM(CommandMByteTr)=AR;
  DM(CommandLByteTr)=AR;
  CALL MakeCommand;     {    }



CALL Go_To_Next_CmdBuf_Position;


 I0=^Samples_For_Filter_0;
 AR=DM(FIR_Order);
 L0=AR;
 M0=1;


 I7=^Pointer_Sample_Buf;
 L7=4;
 M7=1;

 AR=I0;
 DM(I7,M7)=AR;

 I0=^Samples_For_Filter_1;      {         }
 AR=I0;
 DM(I7,M7)=AR;

 I0=^Samples_For_Filter_2;
 AR=I0;
 DM(I7,M7)=AR;
 
 I0=^Samples_For_Filter_3;      
 AR=I0;
 DM(I7,M7)=AR;


 I5=^FIR_Coeffs;
 AR=DM(FIR_Order);
 L5=AR;
 M5=1;

 I6=^Pointer_DelayLine;
 L6=4;
 M6=1;

 I3=^DelayLine_0;
 AR=I3;
 DM(I6,M6)=AR;

 I3=^DelayLine_1;
 AR=I3;
 DM(I6,M6)=AR;

 I3=^DelayLine_2;
 AR=I3;
 DM(I6,M6)=AR;

 I3=^DelayLine_3;
 AR=I3;
 DM(I6,M6)=AR;

 L3=4;  

 AR=DM(Dec_Factor);
 DM(Dec_Counter)=AR;

 AR=DM(FIR_Order);
 DM(FIR_Fill_Counter)=AR;

 AR=4;
 DM(IIR_Fill_Counter)=AR;

 AR=25;
 DM(Rubbish_Counter)=AR;

 I4=^IIR_Coeffs;  {     - }
 L4=5;
 M4=1;

 AR=0;
 CALL Select_Codec;

 AR=0x13;
 DM(Sport1TxData)=AR;   {        }
 CALL Write_8bit_Reg;   {         }

 CALL Read_24bit_Reg;
 AX0=DM(Rd24bitRegValue_LastTwoBytes); {       }
 AY0=0x0210;

 AR=AR AND AY0;{ ,    SKIP+CHOP.   -    }
 NONE=PASS AR;
 IF EQ CALL Reset_CHOP_Flag;
 IF NE CALL Set_CHOP_Flag;

 AX0=DM(IIR_ENA);
 AY0=DM(FIR_ENA);
 AR=AX0 OR AY0;

 DM(IIRorFIR_Ena)=AR;
 
 RESET FL1;

 CNTR=4;

 DO Prepare_Cont_Read UNTIL CE;

 AX0=4;
 AY0=CNTR;

 AR=AX0-AY0;
 AY1=AR;

 CALL Select_Codec;  

  
 AR=0x04;
 DM(Sport1TxData)=AR;    {       }  
 CALL Write_8bit_Reg;    {      }  

 I1=^Calibr_DAC_Buf;
 L1=0; 
 M1=AY1{SR0};
 MODIFY(I1,M1);
 M1=0;  

 AX1=DM(I1,M1); 
 DM(Sport1TxData)=AX1;   {            }
 CALL Write_8bit_Reg;
                       
 AR=0x02;                {     }
 DM(Sport1TxData)=AR;    {    }
 CALL Write_8bit_Reg;


 I1=^Mode_8chan_Ranges; 
 L1=0;
 M1=AY1{MR0};
 MODIFY(I1,M1);
 M1=0;

 AX1=DM(I1,M1);
 
 AR=SETBIT 13 OF AX1;   
 AX1=AR;
                   
 DM(Sport1TxData)=AX1;   { Set continuos conversion mode etc }
 CALL Write_16bit_Reg;

 AR=0x21;                { Set next operation - cont. read }
 DM(Sport1TxData)=AR;
 CALL Write_8bit_Reg;



 Prepare_Cont_Read: NOP;

   
   
  {**********  !!!!      !!!!!*********** }

  
AX0=DM(Prog_Flag_Data); { For Continues read set PF6;    }
AR=SETBIT 6 OF AX0;
DM(Prog_Flag_Data)=AR;
                    
SET FL1;     
 
Acquisition_Cycle:

AR=DM(IIR_ENA);
NONE=PASS AR;
IF EQ JUMP Skip_Wait_For_Rubbish_Del;


AR=DM(Rubbish_Counter);
NONE=PASS AR;
IF NE AR=AR-1;
DM(Rubbish_Counter)=AR;


IF NE JUMP Cont_After_FIR_Cntr_Update; {    ,    FIR }
 
Skip_Wait_For_Rubbish_Del:

CALL FIR_Counters_Update;


Cont_After_FIR_Cntr_Update:


AY1=DM(Channel_Mask);
  

CALL Wait_for_all_ready;  

AX0=DM(Command);     {    "",     }
AY0=0xDF;            { ""  ,..                      }
AR=AX0 AND AY0;
AX0=AR;
AY0=31;              {    }
AR=AX0 XOR AY0;
NONE=PASS AR;

IF EQ JUMP Finish_4Ch_Mode;  


  
bb:
AR=DM(PortIsFree_Tr);
NONE=PASS AR;
IF NE JUMP bb;


CNTR=4;
DO Dynamic_mode_end UNTIL CE; 
 
AX0=4; 
AY0=CNTR;
AR=AX0-AY0;

DM(DataHByteTr)=AR;  
                              
          
CALL Select_Codec;    
AR=DM(IIRorFIR_Ena);
NONE=PASS AR;
IF NE JUMP Acq_With_Filters;        


CALL Read_24bit_Reg; 
JUMP Skip_FIR;


       


 Acq_With_Filters:
 

 CALL Read_16bit_Reg;

 AR=DM(Rd16bitRegValue);
 AR=AR-0x8000;

 DM(Filtered_Sample)=AR;

 AR=DM(IIR_ENA);
 NONE=PASS AR;
 IF NE JUMP Call_IIR;  
 JUMP Skip_IIR;

 Call_IIR: 

 M6=0;
 AR=DM(I6,M6);
 I3=AR;
 M3=1;
 M6=1;
       
 SR1=DM(Filtered_Sample); 
               

 AR=DM(IIR_Fill_Counter);
 NONE=PASS AR;
 IF NE JUMP Fill_Delay_Line;
 IF EQ CALL IIR;   
      
 AR=I3;
 DM(I6,M6)=AR;
 
 AR=DM(Rubbish_Counter);
 NONE=PASS AR;
 IF NE JUMP Skip_Channel; {    -    -,   }

      
 Skip_IIR:  
 
 
 AR=DM(FIR_ENA);
 NONE=PASS AR;
 IF NE JUMP Call_FIR;
  JUMP bebe;
                
 Call_FIR:                             
                             

 M7=0;
 AR=DM(I7,M7);
 I0=AR; 
 M7=1;
 
 AR=DM(Filtered_Sample);
 DM(I0,M0)=AR;    

  
 AR=I0;
 DM(I7,M7)=AR;

 AR=DM(FIR_Fill_Counter);   
 NONE=PASS AR;
 IF NE JUMP Skip_Channel;  {     ,      }
 CALL FIR;  {  FIR }




 AR=DM(Dec_Counter);
 NONE=PASS AR;
 IF NE JUMP Skip_Channel;

   

bebe:

 AR=0;

 DM(Rd24bitRegValue_FirstByte)=AR;

 AR=DM(Filtered_Sample);
 DM(Rd24bitRegValue_LastTwoBytes)=AR;


Skip_FIR: 

 AX1=B#00000001;
 AR=AX1 AND AY1;
 NONE=PASS AR;

 IF EQ JUMP Skip_Channel; 
 

AR=DM(Rd24bitRegValue_FirstByte);

                   
 SR=LSHIFT AR BY -8 (LO);     
 
 DM(DataMByteTr)=SR0;

 DM(DataLByteTr)=AR; 

 CALL MakeData; 


bbb:
AR=DM(PortIsFree_Tr);
NONE=PASS AR;
IF NE JUMP bbb;
 

 AR=DM(Rd24bitRegValue_LastTwoBytes);

                  
 SR=LSHIFT AR BY -8 (LO);     
 DM(DataMByteTr)=SR0;
 DM(DataLByteTr)=AR; 
 CALL MakeData; 
 

Skip_Channel: 
 AR=AY1;
 SR=LSHIFT AR BY -1 (LO);
 AY1=SR0;
 

Dynamic_mode_end: NOP;

CALL Check_For_Dec_Counter;

AR=DM(IIR_Fill_Counter);
NONE=PASS AR;
IF NE AR=AR-1;
DM(IIR_Fill_Counter)=AR;

Check_For_Stop:

AR=DM(Frame_Flag); 
NONE=PASS AR;
IF NE JUMP Finish_4Ch_Mode; 


JUMP Acquisition_Cycle;  
 


Finish_4Ch_Mode:                           { Cancel of continuous read }



AR=0;
DM(Command)=AR;  


{RESET FL1;    }
{TT;TT;TT;TT;TT;TT;   }
 


AX0=DM(Prog_Flag_Data); 
AR=CLRBIT 6 OF AX0;
DM(Prog_Flag_Data)=AR;

 

{
RESET FL1;
TT;TT;TT;TT;TT;TT;
 }   

CNTR=4;

DO Cancel_Dynamic_Mode UNTIL CE; 
 
AX0=4; 
AY0=CNTR;
AR=AX0-AY0;  

CALL Select_Codec;     


AR=0x30;  
DM(Sport1TxData)=AR;
CALL Write_8bit_Reg;   


AR=0x02;
DM(Sport1TxData)=AR;  
CALL Write_8bit_Reg;  


AR=0x01B0;          
DM(Sport1TxData)=AR;
CALL Write_16bit_Reg;

Cancel_Dynamic_Mode: NOP; 

{CALL Reset_AD7730; }  

 
{
AX0=DM(Prog_Flag_Data);  For Continues read set PF6; 
AR=CLRBIT 6 OF AX0;
DM(Prog_Flag_Data)=AR; 
 }


 

RESET FL1;   

{JUMP Mode_4Channel;   }
   

AR=31; {     }
  DM(CommandHByteTr)=AR;
  AR=0;
  DM(CommandMByteTr)=AR;
  DM(CommandLByteTr)=AR;
  CALL MakeCommand;


CALL Go_To_Next_CmdBuf_Position;   
JUMP MainLoop; 




{ ******************************************************** }


Mode_8Channel: 

AR=0x0;
DM(Channel_Group)=AR;

RESET FL1;

AR=9{10};
  DM(CommandHByteTr)=AR;
  AR=0;
  DM(CommandMByteTr)=AR;
  DM(CommandLByteTr)=AR;
  CALL MakeCommand;     {    }



CALL Go_To_Next_CmdBuf_Position;


Static_8_Chan:

 

CNTR=4; {   }

DO Prepare_Cont_Read_Static UNTIL CE;


AX0=4;
AY0=CNTR;

AR=AX0-AY0;
AY1=AR;


CALL Select_Codec;   {   }



AR=0x04;
DM(Sport1TxData)=AR;   {      }  
CALL Write_8bit_Reg;   {      } 



MR0=AY1;
MX0=4;
MY0=DM(Channel_Group);
MR=MR+MX0*MY0(UU);



                        {     }
SR0=MR0;

I1=^Calibr_DAC_Buf; 
M1=SR0;
MODIFY(I1,M1);
M1=0; 

AX1=DM(I1,M1);   
DM(Sport1TxData)=AX1;  {             }
CALL Write_8bit_Reg;


{**         **}

          {  C    , MR   }
 

I1=^Mode_8chan_Ranges; 
L1=0;
M1=MR0;                 {    }
MODIFY(I1,M1);  
M1=0; 


AX1=DM(I1,M1); {        ! } 




AR=0x02;                {     }
DM(Sport1TxData)=AR;    {    }
CALL Write_8bit_Reg;
  
             {          } 
             {  AX1          }
             {   AX0    . . ..  14-  }

AR=SETBIT 14 OF AX1;
AX1=AR; 
     
 
DM(Sport1TxData)=AX1;   
                        
CALL Write_16bit_Reg;  {     }
                       

Prepare_Cont_Read_Static: NOP;   
                               {  ,      , }
                               {  ,       }
                               { , FL1,    SYNC                    } 



 
                               
SET FL1;  {Synchronization of filters}    

 
Acquisition_Cycle_Static:


AY1=DM(Channel_Mask);


AR=DM(Channel_Group);
NONE=PASS AR;

IF NE CALL Channel_Mask_Shift; 


CALL Wait_for_all_ready;
RESET FL1;



CNTR=4;
DO Static_mode_end UNTIL CE; 
 
AX0=4; 
AY0=CNTR;
AR=AX0-AY0;
AX1=AR; 



MR0=AX1;
MX0=4; 
MY0=DM(Channel_Group);
MR=MR+MX0*MY0(UU);
                    {  AX1 -   4 ! (0-4)}

 
DM(DataHByteTr)=MR0;


AR=AX1;
CALL Select_Codec;  

AR=0x11;               {    ,    }
DM(Sport1TxData)=AR;   {       }
CALL Write_8bit_Reg;
    
CALL Read_24bit_Reg;


AX1=B#00000001;
AR=AX1 AND AY1;
IF EQ JUMP Skip_Channel_8;



wait_for_tr_end:
AR=DM(PortIsFree_Tr);
NONE=PASS AR;
IF NE JUMP wait_for_tr_end;




AR=DM(Rd24bitRegValue_FirstByte);

                   
 SR=LSHIFT AR BY -8 (LO);     
 
 DM(DataMByteTr)=SR0;

 DM(DataLByteTr)=AR; 

 CALL MakeData; 




wait_for_tr_end_1:
AR=DM(PortIsFree_Tr);
NONE=PASS AR;
IF NE JUMP wait_for_tr_end_1;
 


AR=DM(Rd24bitRegValue_LastTwoBytes);

                  
 SR=LSHIFT AR BY -8 (LO);     
 
 DM(DataMByteTr)=SR0;

 DM(DataLByteTr)=AR; 

 CALL MakeData; 

 

Skip_Channel_8:

AR=AY1;
SR=LSHIFT AR BY -1 (LO);
AY1=SR0;
            

Static_mode_end: NOP;
                          

AX0=DM(Channel_Group);
AY0=1;
AR=AX0 XOR AY0;
DM(Channel_Group)=AR; 



AX0=DM(Command);     {    "",     }
AY0=0xDF;            { ""  ,..                      }
AR=AX0 AND AY0;
AX0=AR;
AY0=31;              {    }
AR=AX0 XOR AY0;
NONE=PASS AR;


IF NE JUMP Static_8_Chan;   

TT;TT;TT;TT;TT;TT;TT;   

{CALL Reset_AD7730;  }

AR=31; {     }
  DM(CommandHByteTr)=AR;
  AR=0;
  DM(CommandMByteTr)=AR;
  DM(CommandLByteTr)=AR;
  CALL MakeCommand;

AR=0;
DM(Command)=AR;
RESET FL1; 

CALL Go_To_Next_CmdBuf_Position;   
JUMP MainLoop; 



{ ******************************************************** }

Wait_for_all_ready:

 AX0=IO(0); 
 AY0=0xF0;

 AR=AX0 XOR AY0;
 NONE=PASS AR;
 IF NE JUMP Wait_for_all_ready;

RTS; 

{ ******************************************************* }


MakeCommand:
{         }

{AR=1;   ,        ,     
DM(PortIsFree_Tr)=AR; }


 AX0=B#011111111;  
AY0=DM(CommandMByteTr);
AR=AX0 AND AY0;
DM(MByteTr)=AR;


AX0=B#011111111;  
AY0=DM(CommandLByteTr);
AR=AX0 AND AY0;
DM(LByteTr)=AR;



SR0=DM(CommandHByteTr);
AX1=DM(MByteTr);
AY1=DM(LByteTr);


CALL Eval_Parity;

{      AR   }

SR=LSHIFT AR BY 5 (LO);
AX0=SR0; {************** 0 -   !!!!!!!!!!!!!!!!!***********************}
AY0=DM(CommandHByteTr);  

AR=AX0 OR AY0;

{        }

AX0=AR{DM(CommandHByteTr)}; AY0=B#111000000;
AR=AX0 OR AY0;  
DM(HByteTr)=AR;



  AR=1;
  DM(TrFlag)=AR;
  DM(PortIsFree_Tr)=AR;  
  TX0=DM(HByteTr);
   
RTS;

MakeData:

{AR=1;   ,        ,     
DM(PortIsFree_Tr)=AR;   }




AR=DM(Global_Data_Counter);
SR=LSHIFT AR BY 4 (LO);

AR=AR+1;
AF=AR XOR 16;
NONE=PASS AF;
IF EQ AR=AR XOR 16;   

DM(Global_Data_Counter)=AR;

AY0=SR0;
AX0=DM(DataHByteTr); 
    
AR=AX0 OR AY0;

AY0=B#0111111111;

AR=AR AND AY0;  
DM(HByteTr)=AR;



AX0=B#011111111;  
AY0=DM(DataMByteTr);
AR=AX0 AND AY0;
DM(MByteTr)=AR;


AX0=B#011111111;  
AY0=DM(DataLByteTr);
AR=AX0 AND AY0;
DM(LByteTr)=AR;


  AR=1;
  DM(TrFlag)=AR; 
  DM(PortIsFree_Tr)=AR; 
  TX0=DM(HByteTr);



RTS; 


Set_Ref:


{AR=DM(CommandLByteRcv); }

Call Command_Context_Definition;
AR=DM(Parity_Error_Flag);
NONE=PASS AR;
IF NE JUMP Parity_Error_Abort; {        . ,
                                   ""    .   }   




AR=DM(CmdContextLByte);
DM(HIREF_ENA)=AR;

NONE=PASS AR;

IF NE JUMP Enable_HIREF;
IF EQ JUMP Disable_HIREF;

Enable_HIREF:
  RESET FL2;
  JUMP End_Set_Ref;
Disable_HIREF:
  SET FL2;
End_Set_Ref:

 AR=14;
  DM(CommandHByteTr)=AR;
  AR=0;
  DM(CommandMByteTr)=AR;
  DM(CommandLByteTr)=AR;
  CALL MakeCommand;


CALL Go_To_Next_CmdBuf_Position;   
JUMP MainLoop; 



Load_FIR:


AR=0;
DM(Command)=AR;           {      -  }

Call Command_Context_Definition;

AR=DM(Parity_Error_Flag);
NONE=PASS AR;
IF NE JUMP Parity_Error_Abort; {        . ,
                                   ""    .   } 


 
AR=DM(Load_FIR_Counter);

NONE=PASS AR;
IF NE JUMP Load_FIR_Coeffs;

Load_FIR_Order:
AR=DM(CmdContextLByte); { DM(CommandLByteRcv);   }

DM(FIR_Order)=AR;


I5=^FIR_Coeffs;    
L5=AR;
M5=1;  

           

AR=DM(CmdContextMByte); { DM(CommandMByteRcv); }


DM(Dec_Factor)=AR;


AR=DM(Load_FIR_Counter);
AR=AR+1;
DM(Load_FIR_Counter)=AR;

CALL Go_To_Next_CmdBuf_Position;   
JUMP MainLoop; 





Load_FIR_Coeffs:

SR0=DM(CmdContextMByte); {DM(CommandMByteRcv); }
SR=LSHIFT SR0 BY 8 (LO);
AX0=SR0;

AY0=DM(CmdContextLByte); { DM(CommandLByteRcv);}
AR=AX0 OR AY0;

PM(I5,M5)=AR;


AX0=DM(Load_FIR_Counter);
AY0=DM(FIR_Order);

AR=AX0 XOR AY0;
NONE=PASS AR;
IF NE AR=AX0+1;
IF EQ AR=AX0 XOR AY0;

DM(Load_FIR_Counter)=AR;

NONE=PASS AR;
IF NE JUMP FIR_Load_End; 

hrych:

  AR=15;
  DM(CommandHByteTr)=AR;
  AR=0;
  DM(CommandMByteTr)=AR;
  DM(CommandLByteTr)=AR;
  CALL MakeCommand;

  


FIR_Load_End:
CALL Go_To_Next_CmdBuf_Position;   
JUMP MainLoop; 



Load_IIR:

AR=0;
DM(Command)=AR;

Call Command_Context_Definition;

AR=DM(Parity_Error_Flag);
NONE=PASS AR;
IF NE JUMP Parity_Error_Abort; {        . ,
                                   ""    .   }   




    
    I5=^IIR_Coeffs;
    L5=0;
    M5=DM(Load_IIR_Counter);  
    MODIFY(I5,M5);
    M5=0;
  
     



  
SR0=DM(CmdContextMByte);
SR=LSHIFT SR0 BY 8 (LO);
AX0=SR0;

AY0=DM(CmdContextLByte);
AR=AX0 OR AY0;

PM(I5,M5)=AR;




AR=DM(Load_IIR_Counter);

AR=AR+1;
DM(Load_IIR_Counter)=AR;

AX0=AR; AY0=5;

AR=AX0 XOR AY0;
NONE=PASS AR; 
IF NE JUMP IIR_Load_End;
 


  AR=16;
  DM(CommandHByteTr)=AR;
  AR=0;
  DM(CommandMByteTr)=AR;
  DM(CommandLByteTr)=AR;
  CALL MakeCommand;

  AR=0;
  DM(Load_IIR_Counter)=AR;

  

IIR_Load_End:
CALL Go_To_Next_CmdBuf_Position;   
JUMP MainLoop; 




IIR:
                 
   DIS M_MODE;  
    
   MR=0;

   M2=-3;
   M3=1;
   L3=0;
  
   MX0=DM(I3,M3), MY0=PM(I4,M4);
   MR=MX0*MY0(SS), MX1=DM(I3,M3), MY0=PM(I4,M4);
   MR=MR+MX1*MY0(SS), MY0=PM(I4,M4);
   MR=MR+SR1*MY0(SS), MX0=DM(I3,M3), MY0=PM(I4,M4);
   MR=MR+MX0*MY0(SS), MX0=DM(I3,M2), MY0=PM(I4,M4);
   DM(I3,M3)=MX1,  MR=MR+MX0*MY0(RND);

   IF MV SAT MR;    
      
   DM(I3,M3)=SR1, SR=ASHIFT MR1 (HI);

   DM(I3,M3)=MX0;
   DM(I3,M2)=SR1;

   DM(Filtered_Sample)=SR1;

   ENA M_MODE; 

    RTS;



FIR:

  DIS M_MODE;  {   MR }
  MR=0;  
     

  MX0=DM(I0, M0), 
  MY0=PM(I5,M5);
  
  AR=DM(FIR_Order);
  AR=AR-1;

   CNTR=AR; {   -1  }

   DO convolution UNTIL CE;    

  convolution: MR=MR+MX0*MY0(SS), MX0=DM(I0,M0), MY0=PM(I5,M5);
   
  MR=MR+MX0*MY0(RND);   
  IF MV SAT MR;   
  AR=PASS MR1;  

  DM(Filtered_Sample)=AR;
  ENA M_MODE;

  RTS ; 

Set_Frame_Mode:

AR=0;
DM(Command)=AR;

AR=1;
DM(Frame_Flag)=AR;

  AR=0x18;
  DM(CommandHByteTr)=AR;
  AR=0;
  DM(CommandMByteTr)=AR;
  DM(CommandLByteTr)=AR;
  CALL MakeCommand;



{JUMP MainLoop;    }

CALL Go_To_Next_CmdBuf_Position;   
JUMP MainLoop; 


Manage_Filters:

  AX0=DM(Command);
  AR=0;
  DM(Command)=AR;

 CALL Command_Context_Definition;

 AR=DM(Parity_Error_Flag);
NONE=PASS AR;
IF NE JUMP Parity_Error_Abort; {        . ,
                                   ""    .   }   





  AR=DM(CmdContextMByte);{DM(CommandMByteRcv);  }
  DM(IIR_ENA)=AR;

  AR=DM(CmdContextLByte);{DM(CommandLByteRcv);   }
  DM(FIR_ENA)=AR;

  AR=17;
  DM(CommandHByteTr)=AR;
  AR=0;
  DM(CommandMByteTr)=AR;
  DM(CommandLByteTr)=AR;
  CALL MakeCommand;


  {JUMP MainLoop;   }
CALL Go_To_Next_CmdBuf_Position;   
JUMP MainLoop; 






Test_BIOS:  {    }

AR=0;
DM(Command)=AR;
DM(CRC)=AR;

L6=0;

CNTR=4096;  
DO Check_CRC_PM UNTIL CE;   {    }

AX0=4096;   
AY0=CNTR;
AR=AX0-AY0;
I6=0x0;
M6=AR;
MODIFY(I6,M6);
M6=0;

AR=PM(I6,M6);
SR0=AR;
SR=LSHIFT SR0 BY -8 (LO); 
AY1=AR;




AX0=SR0;      {      CRC }
AY0=DM(CRC);  {     }
CALL Eval_CRC;





AX0=AY1;     
AY0=0x00FF;  {   }
AR=AX0 AND AY0;



AX0=AR;
AY0=DM(CRC);
CALL Eval_CRC;
 



AX0=PX;      {   }
AY0=DM(CRC);
CALL Eval_CRC;



Check_CRC_PM: NOP;


AX1=18;
AR=DM(CRC);


DM(CommandHByteTr)=AX1;

SR=LSHIFT AR BY -8 (LO);     
 
 DM(CommandMByteTr)=SR0;

 DM(CommandLByteTr)=AR; 

 CALL MakeCommand; 
TT;TT;TT;TT;TT;TT;


CALL Go_To_Next_CmdBuf_Position;   
JUMP MainLoop; 



/************************************************************
      

*************************************************************/


 Eval_CRC:

 AR=pass AY0; { w= *crc }
 AY0= 0x1021; { polynom }
 SR0= AX0;
 AX0= 0x8000;
 SR= lshift SR0 BY 8(LO);  { sr0= b<<8 } {     ? }
 AF= pass sr0;
 AR= AR XOR AF;  { w= w^ (b<<8) }
 CNTR=8;
 DO bitloop UNTIL CE;
    SR0= AR;                 {sr0= w}
    SR= LSHIFT SR0 BY 1(LO); {sr0= w<<1, temporary var. } {  ,    1-}
    AF= PASS AX0;
    AF= AR AND AF;  { af= 0x8000}
    IF NE JUMP branch_polynom;
    AR=SR0;    {ar= w<<1 }
    JUMP bitloop;
branch_polynom:
    AR= SR0 XOR AY0;   { ar= (w<<1)^0x1021 }    

bitloop: NOP;

DM(CRC)=AR;

 RTS;







{**************************************************************************
             

**************************************************************************}

Load_DAC_Buffer:

CALL Command_Context_Definition;

AR=DM(Parity_Error_Flag);
NONE=PASS AR;
IF NE JUMP Parity_Error_Abort; {        . ,
                                   ""    .   }   




AX0=DM(CmdContextLByte);   {    }
AY0=DM(CmdContextMByte);    {    }






I1=^Calibr_DAC_Buf;
M1=AY0;
MODIFY(I1,M1);
M1=0;



DM(I1,M1)=AX0;


  AR=19;
  DM(CommandHByteTr)=AR;

AR=0; 
 
 DM(CommandMByteTr)=AR;

 DM(CommandLByteTr)=AR; 

 CALL MakeCommand; 


CALL Go_To_Next_CmdBuf_Position;   
JUMP MainLoop; 


Check_For_Dec_Counter:
  
 AR=DM(Dec_Counter);
 NONE=PASS AR;
 IF EQ JUMP Set_Dec_Counter;
 IF NE RTS;

 Set_Dec_Counter:
 AR=DM(Dec_Factor);
 DM(Dec_Counter)=AR;

 RTS;

Get_Filter_Info:
AR=0;
DM(Command)=AR;

AR=0x17;
AX0=DM(Dec_Factor);
AY0=DM(FIR_Order);


DM(CommandMByteTr)=AX0;
DM(CommandLByteTr)=AY0;
DM(CommandHByteTr)=AR;
Call MakeCommand;

{JUMP MainLoop; }

CALL Go_To_Next_CmdBuf_Position;   
JUMP MainLoop; 





Fill_Delay_Line:

DM(I3,M3)=SR1; 
JUMP Skip_Channel;
 


Channel_Mask_Shift:
SR0=AY1;
SR=LSHIFT SR0 BY -4 (LO);
AY1=SR0;
RTS;


Eval_Medium_Val:

{ I1=^Previous_Samples;        

 AR=DM(Filtered_Sample);
 SR=LSHIFT AR BY -1 (LO);       
 AX0=SR0;
 M1=1;  ! 
 M1=DM(Selected_Codec);
 AY0=DM(I1,M1);   ,    
 M1=0;
 AR=AX0+AY0;
 DM(Filtered_Sample)=AR;
 DM(I1,M1)=AX0;    ,    
}
RTS;


Reset_CHOP_Flag:
AR=0;
DM(Chop_Flag)=AR;
RTS;

Set_CHOP_Flag:
AR=1;
DM(Chop_Flag)=AR;
RTS;


Command_Context_Definition:

IMASK=B#1000000110; {     SPORT0}


I4=DM(Cur_Command_Loop_Addr);
L4=%Commands_Buf;
M4=0;   {    !!! }

AX0=PM(I4,M4);
 


{   }
SR0=PX;



SR=LSHIFT SR0 BY -5 (LO);
DM(Parity)=SR0;


 

AY0=0x00FF;
AR=AX0 AND AY0;   
DM(CmdContextLByte)=AR;

SR0=AX0;
SR=LSHIFT SR0 BY -8 (LO);
DM(CmdContextMByte)=SR0;


SR0=PX;

IMASK=B#1000100110; {     SPORT0} 

AX1=DM(CmdContextMByte); {        } 
AY1=DM(CmdContextLByte);

CALL Eval_Parity;

{     AR   2- .    
                  }
AX0=AR;
AY0=DM(Parity);
AR=AX0 XOR AY0;

DM(Parity_Error_Flag)=AR;

RTS;  




Go_To_Next_CmdBuf_Position:

 IMASK=B#1000000110; {     SPORT0} 


 I4=DM(Cur_Command_Loop_Addr);
 L4=%Commands_Buf;
 M4=1;

 
 AR=0;

 PX=0;
 PM(I4,M4)=AR;

 DM(Cur_Command_Loop_Addr)=I4;

IMASK=B#1000100110; {     SPORT0} 



RTS;

{********************************************************************************
    !!!!!!!!!!!

*********************************************************************************}

Test_Data_Aqcuisition:



Call Command_Context_Definition;

AR=DM(Parity_Error_Flag);
NONE=PASS AR;
IF NE JUMP Parity_Error_Abort; {        . ,
                                   ""    .   }   





AX1=DM(CmdContextMByte);
 

DM(Time_Between_Pack)=AX1;     


  AR=21;
  DM(CommandHByteTr)=AR;
  AR=0;
  DM(CommandMByteTr)=AR;
  DM(CommandLByteTr)=AR;
  CALL MakeCommand;

TT;TT;TT;TT;TT; 



CALL Go_To_Next_CmdBuf_Position;   
 



AY1=0;


DM(Prev_Command)=AY1;   

 ff:




 CNTR=4;
 DO End_Send UNTIL CE;

 AX0=4;
 AY0=CNTR;
 AR=AX0-AY0;
 MR0=AR;


 
 DM(DataHByteTr)=MR0;





wait_for_tr_end_tst:
AR=DM(PortIsFree_Tr);
NONE=PASS AR;
IF NE JUMP wait_for_tr_end_tst;




 AR=1160;  
                   
 SR=LSHIFT AR BY -8 (LO);     
 
 DM(DataMByteTr)=SR0;

 DM(DataLByteTr)=AR; 

CALL MakeData;  



 


End_Send: NOP;   

{
IMASK=B#1000000110;      SPORT0

I4=DM(Cur_Command_Loop_Addr);
M4=0;
L4=%Commands_Buf;


AR=PM(I4,M4);
DM(CmdTmp)=PX;

IMASK=B#1000100110;      SPORT0

     
 }



IMASK=B#1000000110; {     SPORT0}

I4=DM(Cur_Command_Loop_Addr);
M4=0;
L4=%Commands_Buf;


AR=PM(I4,M4);
AX0=PX;
AY0=0x1F; {           }
AR=AX0 AND AY0;
DM(CmdTmp)=AR;{PX;}

IMASK=B#1000100110; {     SPORT0} 


 AX0=DM(CmdTmp);

 AY0=31;
 AR=AX0 XOR AY0;
 NONE=PASS AR;
 IF EQ JUMP StopIfTest;   


 AY0=29;
 AR=AX0 XOR AY0;
 NONE=PASS AR;
 IF EQ CALL Send_TestCommand;   



{End_Send: NOP;    }
 
 JUMP ff;  

 

StopIfTest:


wait_for_tr_end_tst_stop:
AR=DM(PortIsFree_Tr);
NONE=PASS AR;
IF NE JUMP wait_for_tr_end_tst_stop;
 

TT;TT;TT;TT;TT;TT;TT;   



  AR=31; {     }
  DM(CommandHByteTr)=AR;
  AR=0;
  DM(CommandMByteTr)=AR;
  DM(CommandLByteTr)=AR;
  CALL MakeCommand;

TT;TT;TT;TT;TT;  
 
 


CALL Go_To_Next_CmdBuf_Position;   
JUMP MainLoop; 






Send_TestCommand:


Call Command_Context_Definition;


AR=DM(Parity_Error_Flag);
NONE=PASS AR;
IF NE JUMP Parity_Error_Abort; {        . ,
                                   ""    .   }  

  

AR=29;
DM(CommandHByteTr)=AR;

AX0=DM(CmdContextMByte);
DM(CommandMByteTr)=AX0;

AY0=DM(CmdContextLByte);
DM(CommandLByteTr)=AY0;


SR0=AX0;

SR=LSHIFT SR0 BY 8 (LO);
AX0=SR0;
AR=AX0 OR AY0;
NONE=PASS AR;
IF EQ JUMP cont; 

AY1=AR;

AX0=DM(Prev_Command);
AX1=AX0;

AY0=0xFFFF;
AR=AX0 XOR AY0;
NONE=PASS AR;

IF EQ JUMP cont;


AR=AY1-AX1;
AY0=1;

AR=AR XOR AY0;
NONE=PASS AR;
IF NE CALL Test_DetectError;    

cont:
DM(Prev_Command)=AY1;


wait_for_tr_end_tst_cmd:
AR=DM(PortIsFree_Tr);
NONE=PASS AR;
IF NE JUMP wait_for_tr_end_tst_cmd;

{TT;TT;TT;TT;   }

CALL MakeCommand;
{TT;TT;TT;TT;  } 

CALL Go_To_Next_CmdBuf_Position;

RTS;


Test_DetectError:
 {Toggle_Flag:
 TOGGLE FL1;  }


AX0=28;
DM(CommandHByteTr)=AX0;

RTS;



FIR_Counters_Update:

 AR=DM(Dec_Counter);
AR=AR-1;
DM(Dec_Counter)=AR;

AR=DM(FIR_Fill_Counter);
NONE=PASS AR;
IF NE AR=AR-1;
DM(FIR_Fill_Counter)=AR;

RTS; 

Dummy_Stop: {       ,  ""    }
  CALL Go_To_Next_CmdBuf_Position; {    }  
  JUMP MainLoop; 


Dummy_Test:
 AX0=27;
DM(CommandHByteTr)=AX0;
AR=0x11;
  DM(CommandMByteTr)=AR;
  DM(CommandLByteTr)=AR;
  CALL MakeCommand;

TT;TT;TT;TT;TT; 

CALL Go_To_Next_CmdBuf_Position; 
  
JUMP MainLoop;

Check_SerNum_Code:

 Call Command_Context_Definition;

AR=DM(Parity_Error_Flag);
NONE=PASS AR;
IF NE JUMP Parity_Error_Abort; {        . ,
                                   ""    .   }   

 
 SR0=DM(CmdContextMByte);
 SR=LSHIFT SR0 BY 8 (LO);
 AX0=SR0;

 AY0=DM(CmdContextLByte);
 AR=AX0 OR AY0;

 AX0=AR;
 AY0=53637;

 AR=AX0 XOR AY0;
 NONE=PASS AR;
 IF EQ JUMP Send_SN_Err_Code;

 AR=1;

 Send_SN_Err_Code:

 AX1=22;
 AY1=0;
 
 DM(CommandHByteTr)=AX1;
 DM(CommandMByteTr)=AY1;
 DM(CommandLByteTr)=AR;
 CALL MakeCommand;

TT;TT;TT;TT;TT; 


CALL Go_To_Next_CmdBuf_Position;   
JUMP MainLoop;


Eval_Parity:

{     2- .  SR0  
  5    ,  AX1     ,
   AY1 -   . } 



{      5    }



AR=TSTBIT 0 OF SR0;
AY0=AR;

CNTR=4; {   ,  ,  : 0  1 }
DO Parity_Processing1 UNTIL CE;

SR=LSHIFT SR0 BY -1 (LO);

AR=TSTBIT 0 OF SR0;
AX0=AR;

AR=AX0 XOR AY0; {        AR }
AY0=AR;

Parity_Processing1:
NOP;

{   AY0 -   }




SR0=AX1;{DM(CmdContextMByte);  } 

SR=LSHIFT SR0 BY 8 (LO);
{AX0=SR0;}

AX1=SR0;
{AY0=AY1;}{DM(CmdContextLByte);}  

{AR=AX0 OR AY0; }
AR=AX1 OR AY1;

SR0=AR;

{ XOR       }

AR=TSTBIT 0 OF SR0;
AX0=AR;
AR=AX0 XOR AY0;
AY0=AR;



CNTR=15; {   ,  ,  : 0  1 }
DO Parity_Processing2 UNTIL CE;

SR=LSHIFT SR0 BY -1 (LO);

AR=TSTBIT 0 OF SR0;
AX0=AR;

AR=AX0 XOR AY0; {        AR }
AY0=AR;

Parity_Processing2:
NOP;

RTS;


{          }

Parity_Error_Abort:

 AX1=27;
 AY1=0;

 DM(Parity_Error_Flag)=AY1;

 DM(CommandHByteTr)=AX1;
 DM(CommandMByteTr)=AY1;
 DM(CommandLByteTr)=AY1;
 CALL MakeCommand;

CALL Go_To_Next_CmdBuf_Position;   
JUMP MainLoop;


Get_SW_Version:


Call Command_Context_Definition;

AR=DM(Parity_Error_Flag);
NONE=PASS AR;
IF NE JUMP Parity_Error_Abort; {        . ,
                                   ""    .   }   



AR=23;
DM(CommandHByteTr)=AR;


 AR=DM(SW_MajorVersion);     
 DM(CommandMByteTr)=AR;

 AR=DM(SW_MinorVersion);  
 DM(CommandLByteTr)=AR; 

 CALL MakeCommand; 
TT;TT;TT;TT;TT;TT;

CALL Go_To_Next_CmdBuf_Position;   
JUMP MainLoop;




Get_SW_Date:



Call Command_Context_Definition;

AR=DM(Parity_Error_Flag);
NONE=PASS AR;
IF NE JUMP Parity_Error_Abort; {        . ,
                                   ""    .   }   



AR=24;
DM(CommandHByteTr)=AR;


AR=DM(SW_Date_Year); 

                  
 SR=LSHIFT AR BY -8 (LO);     
 
 DM(CommandMByteTr)=SR0;

 DM(CommandLByteTr)=AR; 

 CALL MakeCommand; 

wait_for_tr_data_end:
AR=DM(PortIsFree_Tr);
NONE=PASS AR;
IF NE JUMP wait_for_tr_data_end;



AR=24;
DM(CommandHByteTr)=AR;


 AR=DM(SW_Date_Month);     
 DM(CommandMByteTr)=AR;

 AR=DM(SW_Date_Day);  
 DM(CommandLByteTr)=AR; 

 CALL MakeCommand; 
TT;TT;TT;TT;TT;TT;



CALL Go_To_Next_CmdBuf_Position;   
JUMP MainLoop;





Delay_7mks:
 CNTR={350}130;
 DO End_Delay_7mks UNTIL CE;
 NOP;
 End_Delay_7mks: NOP;
RTS;

Delay_16mks:
 CNTR={800}297;
 DO End_Delay_16mks UNTIL CE;
 NOP;
 End_Delay_16mks: NOP;
RTS;



#include "sport.h"
#include "calibr.h"
#include "flash.h" 
   
.ENDMOD;


