unit EXAMP212;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls,
  SYNCOBJS,       //- 
  ltrapi,         //-
  ltrapitypes,    //-  
  ltrapidefine,   //-  
  ltr212api,      //-212
  ltr021api,
  LTR212REC_THREAD,
  AppEvnts, Spin;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Label1: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Panel2: TPanel;
    Timer1: TTimer;
    GroupBox3: TGroupBox;
    RadioGroup1: TRadioGroup;
    GroupBox1: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    GroupBox2: TGroupBox;
    GroupBox4: TGroupBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Edit4: TEdit;
    Edit5: TEdit;
    Button3: TButton;
    Button4: TButton;
    Button1: TButton;
    Button2: TButton;
    Panel3: TPanel;
    Edit1: TEdit;
    Label4: TLabel;
    Label7: TLabel;
    Edit2: TEdit;
    Label11: TLabel;
    Edit6: TEdit;
    Label12: TLabel;
    Edit7: TEdit;
    Label13: TLabel;
    Edit8: TEdit;
    Label14: TLabel;
    Edit9: TEdit;
    Label15: TLabel;
    Edit10: TEdit;
    Label16: TLabel;
    Edit11: TEdit;
    Label17: TLabel;
    Edit12: TEdit;
    Label18: TLabel;
    Edit13: TEdit;
    Edit14: TEdit;
    Label19: TLabel;
    OpenDialog1: TOpenDialog;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Button5: TButton;
    GroupBox5: TGroupBox;
    Edit3: TEdit;
    CheckBox5: TCheckBox;
    Button6: TButton;
    SaveDialog1: TSaveDialog;
    Edit15: TEdit;
    Edit16: TEdit;
    SpinEdit1: TSpinEdit;
    Label6: TLabel;
    Button7: TButton;
    Button8: TButton;
    Edit17: TEdit;
    Procedure OpenLTR_SEARH_LTR;
    Procedure SETONLTR_AND_FIND_212;
    Procedure IndicateFoundedCrates;
    Procedure IndicateFoundedSlots;
    Procedure ConnectToSlotBySelection;
    Procedure ShowFormState;
    procedure SpeedButton1Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  LTR:TLTR;
  LTR021:TLTR021;

  LTR_CRATES:array[0..CRATE_MAX-1]of SERNUMtext;
  NOM_OF_CRATES:integer;
  SELECTED_CRATE:integer;
  LTRONLINE:integer;

  LTR212ALL:array[0..MODULE_MAX-1]of integer;
  LTR212COUNT:integer;
  LTR021ALL:array[0..MODULE_MAX-1]of integer;
  LTR021COUNT:integer;

  LTR212ONLINE:BOOLEAN;
  LTR021ONLINE:BOOLEAN;
  LTR212REC: BOOLEAN;

  SLOTINUSE:integer;

  VISUAL_BOXES:array[0..8]of Pointer;
  CheckBoxes:array[0..9]of Pointer;
  LevelBoxes:array[0..9]of Pointer;
  OtherBOX:array[0..2]of Pointer;
implementation

{$R *.dfm}

//**********************************************************************************************
//
//        
//**********************************************************************************************
Procedure Tform1.OpenLTR_SEARH_LTR;
var
  res:integer;
begin
	LTR_Init(@LTR);
	LTR.cc:=CC_CONTROL;
  NOM_OF_CRATES:=0;
	res:=LTR_Open(@LTR);
	if (res=LTR_OK) then
	begin
		res:=LTR_GetCrates(@LTR, @LTR_CRATES);
		if(res<>LTR_OK)then
		begin

		end;
		SELECTED_CRATE:=0;
	end;
  for res:=0 to  CRATE_MAX-1 do
  if(LTR_CRATES[res][0]<>'')then
  begin
     NOM_OF_CRATES:=NOM_OF_CRATES+1;
  end;
end;
//**********************************************************************************************
//      
//**********************************************************************************************
Procedure Tform1.SETONLTR_AND_FIND_212;
var
    i,res,found,j:integer;
  	SLTN:array[0..15]of integer;
	  mid:array[0..MODULE_MAX-1]of WORD;
begin
  //  
	LTR.cc:=CC_CONTROL;
	LTR.csn:=LTR_CRATES[SELECTED_CRATE];
	//  
	res:=LTR_Open(@LTR);
	if(res=LTR_OK)then
	begin
		LTRONLINE:=1;
    LTR212ONLINE:=false;
    LTR021ONLINE:=FALSE;
		res:=LTR_GetCrateModules(@LTR, @mid[0]);
   
		if(res=LTR_OK)then
		begin
      LTR212COUNT:=0;
      LTR021COUNT:=0;
			for i:=0 to MODULE_MAX-1 do
			begin
				if (mid[i]=MID_LTR212)then
				begin
					LTR212ALL[LTR212COUNT]:=i+1;
					LTR212COUNT:=LTR212COUNT+1;
          LTR212ONLINE:=true;
				end;
        if (mid[i]=$1515)then
        begin
          LTR021ALL[LTR021COUNT]:=i+1;
					LTR021COUNT:=LTR021COUNT+1;
          LTR021ONLINE:=true;
        end;
			end;
		end;
	end;
end;
//**********************************************************************************************
//  212- ,   .
//**********************************************************************************************
Procedure Tform1.ConnectToSlotBySelection;
begin
end;
//**********************************************************************************************
//
//**********************************************************************************************
Procedure Tform1.IndicateFoundedCrates;
var i:integer;
    j:integer;
begin
    ComboBox1.Clear;
    for i:=0 to NOM_OF_CRATES-1 do
    begin
       ComboBox1.AddItem(LTR_CRATES[i],ComboBox1);
    end;
    ComboBox1.ItemIndex:=0;
end;
//**********************************************************************************************
//
//**********************************************************************************************
Procedure Tform1.IndicateFoundedSlots;
var i,j:integer;
begin
    ComboBox2.Clear;
    for i:=0 to LTR212COUNT-1 do
    begin
       ComboBox2.AddItem(Inttostr(LTR212ALL[i]),ComboBox2);
    end;
    SLOTINUSE:=0;
    ComboBox2.ItemIndex:=0;
end;


procedure tform1.ShowFormState;
var
    BUF:boolean;
begin
    Form1.RadioGroup1.Enabled:=LTR021ONLINE;
    buf:=LTR212ONLINE and not(LTR212REC);
    FORM1.GroupBox1.Enabled:=BUF;
    FORM1.GroupBox2.Enabled:=LTR212ONLINE;
    FORM1.GroupBox3.Enabled:=LTR212ONLINE;
    FORM1.GroupBox4.Enabled:=BUF;
    FORM1.GroupBox5.Enabled:=BUF;
    FORM1.ComboBox3.Enabled:=BUF;
    FORM1.ComboBox4.Enabled:=BUF;
    FORM1.ComboBox5.Enabled:=BUF;
    FORM1.CheckBox1.Enabled:=BUF;
    FORM1.CheckBox2.Enabled:=BUF;
    FORM1.CheckBox3.Enabled:=BUF;
    FORM1.CheckBox4.Enabled:=BUF;
    form1.CheckBox5.Enabled:=BUF;
    //form1.CheckBox4.Enabled:=BUF;
    form1.ComboBox1.Enabled:=not(LTR212REC);
    form1.ComboBox2.Enabled:=not(LTR212REC);
    form1.SpeedButton1.Enabled:=not(LTR212REC);
    form1.Edit3.Enabled:=BUF and form1.CheckBox5.Checked;
    form1.Edit4.Enabled:=BUF and form1.CheckBox3.Checked;
    form1.Edit5.Enabled:=BUF and form1.CheckBox4.Checked;
    form1.button3.Enabled:=BUF and form1.CheckBox3.Checked;
    form1.Button4.Enabled:=BUF and form1.CheckBox4.Checked;
    form1.Button6.Enabled:=BUF and form1.CheckBox5.Checked;
    form1.Button1.Enabled:=BUF;
    form1.Button5.Enabled:=BUF;
    form1.Button8.Enabled:=BUF;
    form1.Button2.Enabled:=LTR212REC;
end;
//SEARCHING FOR LTR BUTTON
procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
    OpenLTR_SEARH_LTR;
    IndicateFoundedCrates;
    SETONLTR_AND_FIND_212;
    IndicateFoundedSlots;
    ShowFormState;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  ShowFormState;
  if LTR021ONLINE then
    begin
      LTR021_Init(@LTR021);
      LTR021_Open(@LTR021, LTR.saddr, LTR.sport, @LTR_CRATES[SELECTED_CRATE][0]);
      if form1.RadioGroup1.itemindex>=5 then
      begin
         LTR021_SetCrateSyncInternalPeriod(@LTR021, StrToInt(Edit17.text));
      end;
      LTR021_SetCrateSyncType(@LTR021, form1.RadioGroup1.itemindex);
      LTR021_Close(@LTR021);
    end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
   res,err,i:integer;
   S:String;
begin
    LTR212REC:=true;
    if LTR021ONLINE then
    begin
      LTR021_Init(@LTR021);
      LTR021_Open(@LTR021, LTR.saddr, LTR.sport, @LTR_CRATES[SELECTED_CRATE][0]);
      LTR021_SetCrateSyncType(@LTR021, form1.RadioGroup1.itemindex);
      LTR021_Close(@LTR021);
    end;
    S:='data\ltr212.bio';
    LTR212_Init(@LTR212);
    res:=LTR212_Open(@LTR212,LTR.saddr,LTR.sport,@LTR_CRATES[SELECTED_CRATE][0],LTR212ALL[ComboBox2.ItemIndex],@S[1]);
    if res=LTR_OK then
    begin
      LTR212.size:=sizeof(TLTR212);  	              //   
		  LTR212.AcqMode:=form1.Combobox4.ItemIndex;    //  0-4M;  1-4H;  2-8H;
		  LTR212.UseClb:=ord(checkbox1.checked);        //      
		  LTR212.UseFabricClb:=ord(checkbox2.checked);  //      . .
		  LTR212.REF:=form1.ComboBox5.ItemIndex;        //     5 .
		  LTR212.AC:=0;                                 //    
      LTR212.filter.IIR:=ord(checkbox3.checked);
      for i:=0 to 255 do LTR212.filter.IIR_Name[i]:=Edit4.text[i+1];
      LTR212.filter.FIR:=ord(checkbox4.Checked);
      for i:=0 to 255 do LTR212.filter.FIR_Name[i]:=Edit5.text[i+1];

      MAX_CH:=form1.SpinEdit1.Value;
      if LTR212.AcqMode<2 then
      if MAX_CH>4 then MAX_CH:=4;
      form1.SpinEdit1.Value:=MAX_CH;

      //  t 
		  //      
		  NCH:=0;
		  for i:=0 to MAX_CH-1 do
		  begin
			  begin
				  LTR212.LChTbl[NCH]:=LTR212_CreateLChannel(i+1,form1.ComboBox3.ItemIndex);
				  NCH:=NCH+1;
			  end;
		  end;
  	  LTR212.LChQnt:=NCH;//    - 4
		  //      
    	err:=LTR212_SetADC(@LTR212);
		  if err<>0 then
 		  begin
         LTR212REC:=false;
         LTR212_Close(@LTR212);
  		end else
      begin
         Flag_DO_MESURE:=true;


         YSS:=SY/NCH;
         XSS:=SX/10;

         LTR212THREAD.Create(false);
      end ;
    end else LTR212REC:=false;
   ShowFormState;
end;

procedure TForm1.Button2Click(Sender: TObject);
var res,count:integer;
begin
    Button2.Enabled:=false;
    count:=0;
    Flag_DO_MESURE:=false;


    while Flag_DO_REC do
    begin
       sleep(100);
       count:=count+1;
    end;
    res:=LTR212_Close(@LTR212);
    LTR212REC:=false;
    ShowFormState;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
    SELECTED_CRATE:=combobox1.ItemIndex;
    SETONLTR_AND_FIND_212;
    IndicateFoundedSlots;
    ShowFormState;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    OpenLTR_SEARH_LTR;
    IndicateFoundedCrates;
    SETONLTR_AND_FIND_212;
    IndicateFoundedSlots;
    ShowFormState;
    section:=tcriticalsection.Create;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
if opendialog1.Execute then
begin
   Edit4.Text:=opendialog1.FileName;
end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
if opendialog1.Execute then
begin
   Edit5.Text:=opendialog1.FileName;
end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  LChannel_MaskBYTE:byte;
  res,i,err:integer;
   S:String;
begin
    Groupbox2.Color:=clyellow;
    S:='data\ltr212.bio';
    LTR212_Init(@LTR212);
    res:=LTR212_Open(@LTR212,LTR.saddr,LTR.sport,@LTR_CRATES[SELECTED_CRATE][0],LTR212ALL[ComboBox2.ItemIndex],@S[1]);
    if res=LTR_OK then
    begin
      LTR212.size:=sizeof(TLTR212);  	              //   
		  LTR212.AcqMode:=form1.Combobox4.ItemIndex;    //  0-4M;  1-4H;  2-8H;
		  LTR212.UseClb:=ord(checkbox1.checked);        //      
		  LTR212.UseFabricClb:=ord(checkbox2.checked);  //      . .
		  LTR212.REF:=form1.ComboBox5.ItemIndex;        //     5 .
		  LTR212.AC:=0;                                 //    
      LTR212.filter.IIR:=ord(checkbox3.checked);
      for i:=0 to 255 do LTR212.filter.IIR_Name[i]:=Edit4.text[i+1];
      LTR212.filter.FIR:=ord(checkbox4.Checked);
      for i:=0 to 255 do LTR212.filter.FIR_Name[i]:=Edit5.text[i+1];
      if LTR212.AcqMode>1 then
		    MAX_CH:=8
		  else
		    MAX_CH:=4;
      //  t 
      //      
		  NCH:=0;
		  for i:=0 to MAX_CH-1 do
		  begin
			  begin
				  LTR212.LChTbl[NCH]:=LTR212_CreateLChannel(i+1,form1.ComboBox3.ItemIndex);
				  NCH:=NCH+1;
			  end;
		  end;
  	  LTR212.LChQnt:=NCH;//    - 4
		  //      
    	err:=LTR212_SetADC(@LTR212);
      LChannel_MaskBYTE:=$F;
      res:=LTR212_Calibrate(@LTR212, @LChannel_MaskBYTE, 3, 0);
      if res=ltr_ok then
      begin
        ShowFormState;
        Groupbox2.Color:=clGREEN;
      end
      else Groupbox2.Color:=clRED;
      LTR212_CLOSE(@LTR212);
    end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
if savedialog1.Execute then
begin
   Edit3.Text:=savedialog1.FileName;
end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   section.Enter;
   Edit1.Text :=EDits[0];
   Edit2.Text :=EDits[1];
   Edit6.Text :=EDits[2];
   Edit7.Text :=EDits[3];
   Edit8.Text :=EDits[4];
   Edit9.Text :=EDits[5];
   Edit10.Text:=EDits[6];
   Edit11.Text:=EDits[7];
   Edit12.Text:=EDits[8];
   Edit13.Text:=EDits[9];
   Edit14.Text:=EDits[10];
   Edit15.Text:=EDits[11];
   Edit16.Text:=EDits[12];
   section.Leave;
   end;
procedure TForm1.Button7Click(Sender: TObject);
begin
NEED_TO_RESET:=1;
end;

procedure TForm1.Button8Click(Sender: TObject);
var
  LChannel_MaskBYTE:byte;
  res,i,err:integer;
   S:String;
begin
    Groupbox2.Color:=clYELLOW;
    S:='data\ltr212.bio';
    LTR212_Init(@LTR212);
    res:=LTR212_Open(@LTR212,LTR.saddr,LTR.sport,@LTR_CRATES[SELECTED_CRATE][0],LTR212ALL[ComboBox2.ItemIndex],@S[1]);
    if res=LTR_OK then
    begin
      LTR212.size:=sizeof(TLTR212);  	              //   
		  LTR212.AcqMode:=form1.Combobox4.ItemIndex;    //  0-4M;  1-4H;  2-8H;
		  LTR212.UseClb:=ord(checkbox1.checked);        //      
		  LTR212.UseFabricClb:=ord(checkbox2.checked);  //      . .
		  LTR212.REF:=form1.ComboBox5.ItemIndex;        //     5 .
		  LTR212.AC:=0;                                 //    
      LTR212.filter.IIR:=ord(checkbox3.checked);
      for i:=0 to 255 do LTR212.filter.IIR_Name[i]:=Edit4.text[i+1];
      LTR212.filter.FIR:=ord(checkbox4.Checked);
      for i:=0 to 255 do LTR212.filter.FIR_Name[i]:=Edit5.text[i+1];
      if LTR212.AcqMode>1 then
		    MAX_CH:=8
		  else
		    MAX_CH:=4;
      //  t 
      //      
		  NCH:=0;
		  for i:=0 to MAX_CH-1 do
		  begin
			  begin
				  LTR212.LChTbl[NCH]:=LTR212_CreateLChannel(i+1,form1.ComboBox3.ItemIndex);
				  NCH:=NCH+1;
			  end;
		  end;
  	  LTR212.LChQnt:=NCH;//    - 4
		  //      
    	err:=LTR212_SetADC(@LTR212);
      LChannel_MaskBYTE:=$F;
      res:=LTR212_Calibrate(@LTR212, @LChannel_MaskBYTE, 6, 0);

      if res=ltr_ok then
      begin
        ShowFormState;
        Groupbox2.Color:=clGREEN;
      end
      else Groupbox2.Color:=clRED;
      LTR212_CLOSE(@LTR212);
    end;
end;

end.
