// example.cpp : Defines the entry point for the console application.
//
#include "stdafx.h"
#include "stdio.h"
#include "stdlib.h"
#include "conio.h"
#include <windows.h>
#include "ltr\include\ltr41api.h"

TLTR41 hltr41;
char ErrorString[255];
char MsgString[255];

void oem_printf(char *s)
{
 CharToOem(s,s);
 printf("%s",s);
}


int main(int argc, char* argv[])
{

WORD InputWord;
INT err;                 //    


//*          */
 sprintf(MsgString,"  \n");
 oem_printf(MsgString);

 err=LTR41_Init(&hltr41);

 if(err)
 {
 strcpy(ErrorString, (char *) LTR41_GetErrorString(err));
 oem_printf(ErrorString);
 goto End;
  }
 else
 {
  sprintf(MsgString,"LTR41_Init()->OK\n");
  oem_printf(MsgString);
 }

//  .    .      -  
//     ;
//    - 1;

err=LTR41_Open(&hltr41, SADDR_DEFAULT, SPORT_DEFAULT, "", CC_MODULE1);
 if(err)
 {
   if(err==LTR_WARNING_MODULE_IN_USE)
    {
    strcpy(ErrorString, (char *) LTR41_GetErrorString(err));
    oem_printf(ErrorString);
    }
   else
    {
     strcpy(ErrorString, (char *) LTR41_GetErrorString(err));
     oem_printf(ErrorString);
     goto End;
    }
  }
 else
  {
  sprintf(MsgString,"LTR41_Open()->OK\n");
  oem_printf(MsgString);
 }

sprintf(MsgString," : %s\n", hltr41.ModuleInfo.Name);
oem_printf(MsgString);

sprintf(MsgString,"  AVR: %s\n", hltr41.ModuleInfo.FirmwareVersion);
oem_printf(MsgString);

sprintf(MsgString,"   AVR: %s\n", hltr41.ModuleInfo.FirmwareDate);
oem_printf(MsgString);

sprintf(MsgString,"  : %s\n\n", hltr41.ModuleInfo.Serial);
oem_printf(MsgString);

 //        
 //    -
/*
hltr41.IO_Ports.Port1=0;  //        
hltr41.IO_Ports.Port2=1;  //  
hltr41.IO_Ports.Port3=1;  //  
hltr41.IO_Ports.Port4=0;  //  
*/

/*   */
hltr41.Marks.SecondMark_Mode=1;     //    .    
hltr41.Marks.StartMark_Mode=0;      //    



//    
err=LTR41_Config(&hltr41);
if(err)
 {
 strcpy(ErrorString, (char *) LTR41_GetErrorString(err));
 LTR41_Close(&hltr41);
 oem_printf(ErrorString);
 goto End;
  }
 else
  {
  sprintf(MsgString,"LTR41_Config()->OK\n");
  oem_printf(MsgString);
 }


  /*      -.      
  ,    , ..   9-24. */
/*
sprintf(MsgString,"   -  0x00A17400\n");
oem_printf(MsgString);

OutputWord=0x00B17400;

err=LTR41_WritePort(&hltr41, OutputWord);
if(err)
 {
   strcpy(ErrorString, (char *) LTR41_GetErrorString(err));
   LTR41_Close(&hltr41);
   oem_printf(ErrorString);
   goto End;
  }
 else
   {
  sprintf(MsgString,"LTR41_WritePort()->OK\n");
  oem_printf(MsgString);
 }*/

//      -.

sprintf(MsgString,"     -\n");
oem_printf(MsgString);

err=LTR41_ReadPort(&hltr41, &InputWord);
if(err)
 {
  strcpy(ErrorString, (char *) LTR41_GetErrorString(err));
  LTR41_Close(&hltr41);
  oem_printf(ErrorString);
  goto End;
  }
 else
 {
  sprintf(MsgString,"LTR41_ReadPort()->OK\n");
  oem_printf(MsgString);
 }
  //      
  sprintf(MsgString, " : %x hex\n", InputWord);
  oem_printf(MsgString);
/*
/*     5    - */
/*
err= LTR41_WriteArray(&hltr41,  OutputArray, 5);
if(err)
  {
   strcpy(ErrorString, (char *) LTR41_GetErrorString(err));
   LTR41_Close(&hltr41);
   oem_printf(ErrorString);
   goto End;
  }
else
  {
  sprintf(MsgString,"LTR41_WriteArray->OK\n");
  oem_printf(MsgString);
 }*/

 //    
sprintf(MsgString,"   \n");
oem_printf(MsgString);

err= LTR41_StartSecondMark(&hltr41);
if(err)
  {
   strcpy(ErrorString, (char *) LTR41_GetErrorString(err));
   LTR41_Close(&hltr41);
   oem_printf(ErrorString);
   goto End;
  }
else
  {
  sprintf(MsgString,"LTR41_StartSecondMarks()->OK\n");
  oem_printf(MsgString);
 }

 //  3 .     ,   3  
 Sleep(3000);

sprintf(MsgString,"   \n");
oem_printf(MsgString);

//    

err= LTR41_StopSecondMark(&hltr41);
if(err)
  {
   strcpy(ErrorString, (char *) LTR41_GetErrorString(err));
   LTR41_Close(&hltr41);
   oem_printf(ErrorString);
   goto End;
  }
else
  {
  sprintf(MsgString,"LTR41_StopSecondMark()->OK\n");
  oem_printf(MsgString);
  }

 //   

  sprintf(MsgString,"  \n");
  oem_printf(MsgString);

err= LTR41_MakeStartMark(&hltr41);
if(err)
  {
   strcpy(ErrorString, (char *) LTR41_GetErrorString(err));
   LTR41_Close(&hltr41);
   oem_printf(ErrorString);
   goto End;
  }
else
 {
  sprintf(MsgString,"LTR41_MakeStartMark()->OK\n");
  oem_printf(MsgString);
 }


End:
sprintf(MsgString,">>     \n");
oem_printf(MsgString);

   while(!kbhit())
        continue;

        return 0;
}


