//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "DialogAddIP.h"
#include "common.h"
#include "stringres.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormAddIPDialog *FormAddIPDialog;
//---------------------------------------------------------------------------
__fastcall TFormAddIPDialog::TFormAddIPDialog(TComponent* Owner)
    : TForm(Owner)
    {
    }
//---------------------------------------------------------------------------
void __fastcall TFormAddIPDialog::FormShow(TObject *Sender)
    {
    /*    */
    Caption = LoadStr(IDS_dlgcap_AddIP);
    LabelIP->Caption = LoadStr(IDS_lblcap_IPAddress);
    CheckBoxConnectNow->Caption = LoadStr(IDS_cbcap_ConnectNow);
    CheckBoxAutoConnect->Caption = LoadStr(IDS_cbcap_ConnectAtStartup);
    ButtonAdd->Caption = LoadStr(IDS_btncap_Add);
    ButtonCancel->Caption = LoadStr(IDS_btncap_Cancel);

    EditIP->Text = "";
    ButtonAdd->Enabled = false;
    }
//---------------------------------------------------------------------------
void __fastcall TFormAddIPDialog::EditIPChange(TObject *Sender)
    {
    /*    */
    IP_Addr = StrToIP(EditIP->Text.Trim());
    if (IP_Addr)
        {
        ButtonAdd->Enabled = true;
        EditIP->Font->Color = clWindowText;
        }
    else
        {
        ButtonAdd->Enabled = false;
        EditIP->Font->Color = clRed;
        }
    }
//---------------------------------------------------------------------------
