#ifndef LogfileH
#define LogfileH

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop
#include "critical.h"

/*================================================================================================*/
/*              TStringList.
 *     .
 *     ,   "".
 */
class TLogfile
    {
private:
    TCritical cs;
    HANDLE hFile;
    TStringList *pLogBuffer;
    unsigned int TaskCount;
    AnsiString *TaskNames;
    int *TaskLevels;
public:
/*------------------------------------------------------------------------------------------------*/
    __fastcall TLogfile(void);
    __fastcall ~TLogfile(void);
/*------------------------------------------------------------------------------------------------*/
    void __fastcall Configure       /*   */
        (
        const AnsiString &FileName,     /*   (  ':', '/', '\' -   EXE) */
        unsigned int inTaskCount,       /*   "" */
        const AnsiString *inTaskNames,  /*   TaskCount  "" */
        const int *inTaskLevels         /*       */
        );
/*------------------------------------------------------------------------------------------------*/
    void __fastcall Write           /*     */
        (
        AnsiString Message,             /*   */
        unsigned int TaskID,            /*  "" */
        int Level                       /*   ( = ) */
        );
/*------------------------------------------------------------------------------------------------*/
    void __fastcall Flush               /*       */
        (void);
/*------------------------------------------------------------------------------------------------*/
    void __fastcall Flush               /*          */
        (
        TStringList *pDisplay,          /*     */
        int MaxDisplayLines             /*  scrollback   (0 =  ) */
        );
/*------------------------------------------------------------------------------------------------*/
    };
/*================================================================================================*/

#endif
