/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2007. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  MCUFLASH                        1       /* callback function: mcuflash */
#define  MCUFLASH_serial                 2
#define  MCUFLASH_write_start            3       /* callback function: mcuflash_write_start */
#define  MCUFLASH_write_stop             4       /* callback function: mcuflash_write_stop */
#define  MCUFLASH_TEXTMSG                5
#define  MCUFLASH_bar                    6
#define  MCUFLASH_DECORATION             7
#define  MCUFLASH_text                   8
#define  MCUFLASH_percent                9
#define  MCUFLASH_fname                  10
#define  MCUFLASH_DECORATION_2           11
#define  MCUFLASH_ledinit                12

#define  MCUFUSES                        2       /* callback function: mcufuses */
#define  MCUFUSES_default                2       /* callback function: mcufuses_default */
#define  MCUFUSES_write                  3       /* callback function: mcufuses_write */
#define  MCUFUSES_read                   4       /* callback function: mcufuses_read */
#define  MCUFUSES_FUSE05                 5
#define  MCUFUSES_FUSE04                 6
#define  MCUFUSES_FUSE06                 7
#define  MCUFUSES_FUSE07                 8
#define  MCUFUSES_FUSE12                 9
#define  MCUFUSES_FUSE11                 10
#define  MCUFUSES_DECORATION_3           11
#define  MCUFUSES_FUSE10                 12
#define  MCUFUSES_FUSE13                 13
#define  MCUFUSES_FUSE14                 14
#define  MCUFUSES_FUSE03                 15
#define  MCUFUSES_FUSE15                 16
#define  MCUFUSES_FUSE02                 17
#define  MCUFUSES_FUSE16                 18
#define  MCUFUSES_FUSE01                 19
#define  MCUFUSES_FUSE17                 20
#define  MCUFUSES_FIRST_TIME             21
#define  MCUFUSES_FUSE00                 22
#define  MCUFUSES_TEXTBOX                23

#define  TPNL                            3       /* callback function: testpanel_cb */
#define  TPNL_stop                       2       /* callback function: tfuncpnl_stop */
#define  TPNL_close                      3       /* callback function: tfuncpnl_close */
#define  TPNL_clear                      4       /* callback function: tfuncpnl_clear */
#define  TPNL_run                        5       /* callback function: tfuncpnl_run */
#define  TPNL_led                        6
#define  TPNL_isbreak                    7
#define  TPNL_isloop                     8
#define  TPNL_bar                        9
#define  TPNL_tbar                       10
#define  TPNL_loop                       11
#define  TPNL_TEXTMSG                    12
#define  TPNL_percent                    13
#define  TPNL_tpercent                   14
#define  TPNL_DECORATION                 15
#define  TPNL_TEXTMSG_3                  16
#define  TPNL_TEXTMSG_2                  17
#define  TPNL_DECORATION_5               18
#define  TPNL_DECORATION_2               19
#define  TPNL_DECORATION_3               20
#define  TPNL_tname                      21
#define  TPNL_decor                      22
#define  TPNL_patternB                   23      /* callback function: singletest_func */
#define  TPNL_patternL                   24
#define  TPNL_DECORATION_4               25
#define  TPNL_patternP_Manual_2          26
#define  TPNL_patternP_Manual            27
#define  TPNL_patternP_NUse              28
#define  TPNL_patternN                   29
#define  TPNL_patternL2                  30
#define  TPNL_ledoverall                 31
#define  TPNL_TEXTMSG_4                  32
#define  TPNL_ledinit                    33
#define  TPNL_ledkeithley                34
#define  TPNL_ledinitres                 35
#define  TPNL_ledte01ex                  36
#define  TPNL_ledte01                    37
#define  TPNL_ledhw                      38
#define  TPNL_clearspec                  39      /* callback function: tfuncpnl_clearspec */


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK mcuflash(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mcuflash_write_start(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mcuflash_write_stop(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mcufuses(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mcufuses_default(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mcufuses_read(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mcufuses_write(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK singletest_func(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK testpanel_cb(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK tfuncpnl_clear(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK tfuncpnl_clearspec(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK tfuncpnl_close(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK tfuncpnl_run(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK tfuncpnl_stop(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
