#include "te01api.h"


void SetSDAC_Value(TE01 *te01, double t_val, char range);


void SetADC_Range(TE01 *te01, int range);


double GetUADC_Val(TE01 *te01);


int calc_best_base_freq(double frequency, int size, int *base_frec_index);

int calc_real_frequency(double *frequency, int *base_freq_index, int *step, int ram_size);

void FDAC_sin_image_make(WORD *image, int size);

int FDAC_set_image(TE01 *te01, int size, int periods);

int FDAC_ramsize_from_frequency(double freq, int *base_freq_index, int *ram_size);

void FDAC_frequency_from_ramsize(int base_freq_index, int ram_size, double *freq);

int FDAC_set_sin_signal(TE01 *te01, int image_size, int base_freq_index, int step, double voltage, int band);

int FDAC_SetSin(TE01 *te01, double *freq, double voltage, int band);
