/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2007. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  P1                              1       /* callback function: p1_close */
#define  P1_REQ_BAD_E                    2
#define  P1_REQ_BAD_I                    3
#define  P1_REQ_BAD_U                    4
#define  P1_REQ_BAD                      5
#define  P1_REQ_TOTAL                    6
#define  P1_COMN                         7
#define  P1_MESSAGE_LIST                 8
#define  P1_OPEN                         9       /* callback function: open_interface */
#define  P1_CALIBRATION                  10      /* callback function: panel_load */
#define  P1_TEST                         11      /* callback function: panel_load */
#define  P1_SIGNAL                       12      /* callback function: panel_load */
#define  P1_IADC_RANGE                   13
#define  P1_FDAC_BANDPASS                14
#define  P1_CHANNEL                      15
#define  P1_UADC_RANGE                   16      /* callback function: uadc_range_change */
#define  P1_IADC_FILTER                  17
#define  P1_SDAC_RANGE                   18      /* callback function: sdac_range_changed */
#define  P1_RAM_FREQ                     19      /* callback function: signal_freq */
#define  P1_FDAC_RANGE                   20      /* callback function: fdac_range_changed */
#define  P1_UADC_FILTER                  21
#define  P1_RAM_SAMPLES                  22
#define  P1_SIGNAL_FREQ                  23      /* callback function: signal_freq */
#define  P1_SDAC_VAL                     24      /* callback function: sdac_val */
#define  P1_FDAC_MIN_2                   25      /* callback function: fdac_value_change */
#define  P1_FDAC_MAX_2                   26      /* callback function: fdac_value_change */
#define  P1_FDAC_MIN                     27      /* callback function: fdac_value_change */
#define  P1_FDAC_MAX                     28      /* callback function: fdac_value_change */
#define  P1_I_COUNTER                    29      /* callback function: i_counter */
#define  P1_I_DX                         30      /* callback function: fdac_value_change */
#define  P1_I_MX                         31      /* callback function: fdac_value_change */
#define  P1_I_X                          32      /* callback function: fdac_value_change */
#define  P1_COMMANDBUTTON_2              33      /* callback function: get_config */
#define  P1_SET_CONFIG                   34      /* callback function: set_config */
#define  P1_U_COUNTER                    35      /* callback function: u_counter */
#define  P1_U_DX                         36      /* callback function: fdac_value_change */
#define  P1_U_MX                         37      /* callback function: fdac_value_change */
#define  P1_U_X                          38      /* callback function: fdac_value_change */
#define  P1_CANVAS                       39
#define  P1_RADIO_U14                    40      /* callback function: uadc_switch */
#define  P1_RADIO_U13                    41      /* callback function: uadc_switch */
#define  P1_RADIO_U12                    42      /* callback function: uadc_switch */
#define  P1_RADIO_U11                    43      /* callback function: uadc_switch */
#define  P1_RADIO_U10                    44      /* callback function: uadc_switch */
#define  P1_RADIO_U09                    45      /* callback function: uadc_switch */
#define  P1_RADIO_U08                    46      /* callback function: uadc_switch */
#define  P1_RADIO_U07                    47      /* callback function: uadc_switch */
#define  P1_RADIO_U06                    48      /* callback function: uadc_switch */
#define  P1_RADIO_U02                    49      /* callback function: uadc_switch */
#define  P1_RADIO_U05                    50      /* callback function: uadc_switch */
#define  P1_RADIO_I03                    51      /* callback function: iadc_switch */
#define  P1_RADIO_I02                    52      /* callback function: iadc_switch */
#define  P1_RADIO_I00                    53      /* callback function: iadc_switch */
#define  P1_RADIO_I01                    54      /* callback function: iadc_switch */
#define  P1_RADIO_U04                    55      /* callback function: uadc_switch */
#define  P1_RADIO_U03                    56      /* callback function: uadc_switch */
#define  P1_RADIO_U01                    57      /* callback function: uadc_switch */
#define  P1_RADIO_OUT4                   58      /* callback function: em_out_switch */
#define  P1_RADIO_OUT3                   59      /* callback function: em_out_switch */
#define  P1_RADIO_OUT2                   60      /* callback function: em_out_switch */
#define  P1_RADIO_IN4                    61      /* callback function: em_in_switch */
#define  P1_RADIO_IN3                    62      /* callback function: em_in_switch */
#define  P1_RADIO_OUT1                   63      /* callback function: em_out_switch */
#define  P1_RADIO_IN2                    64      /* callback function: em_in_switch */
#define  P1_RADIO_IN1                    65      /* callback function: em_in_switch */
#define  P1_TEXTBOX                      66
#define  P1_CANVAS_2                     67
#define  P1_FCORRECTION                  68      /* callback function: use_correction */
#define  P1_SCORRECTION                  69      /* callback function: use_correction */
#define  P1_ICORRECTION                  70      /* callback function: use_correction */
#define  P1_IGRAPH                       71      /* callback function: panel_load */
#define  P1_UGRAPH                       72      /* callback function: panel_load */
#define  P1_OMMETR_USE                   73      /* callback function: ommetr */
#define  P1_UCORRECTION                  74      /* callback function: use_correction */
#define  P1_CHECKBOX                     75
#define  P1_OMMETR                       76
#define  P1_TEXTBOX_2                    77
#define  P1_RELAY2                       78
#define  P1_RELAY1                       79
#define  P1_TIMER                        80      /* callback function: timer */
#define  P1_DECORATION_6                 81
#define  P1_DECORATION_10                82
#define  P1_DECORATION_9                 83
#define  P1_DECORATION_7                 84
#define  P1_DECORATION_11                85
#define  P1_MDECORATION                  86
#define  P1_TEXTMSG_46                   87
#define  P1_TEXTMSG_45                   88
#define  P1_TEXTMSG_52                   89
#define  P1_TEXTMSG_53                   90
#define  P1_TEXTMSG                      91
#define  P1_TEXTMSG_51                   92
#define  P1_TEXTMSG_48                   93
#define  P1_DECORATION_5                 94
#define  P1_TEXTMSG_55                   95
#define  P1_DECORATION_12                96
#define  P1_IMODULE_OVERLOAD             97
#define  P1_USERIAL                      98
#define  P1_ISERIAL                      99
#define  P1_BID_MID                      100
#define  P1_DECORATION                   101
#define  P1_TEXTMSG_54                   102
#define  P1_UMODULE_OVERLOAD             103
#define  P1_DECORATION_2                 104
#define  P1_DECORATION_13                105
#define  P1_DECORATION_14                106
#define  P1_TEXTMSG_57                   107
#define  P1_TEXTMSG_56                   108
#define  P1_DECORATION_15                109

#define  P2                              2       /* callback function: panel_close */
#define  P2_ISCALE                       2       /* callback function: scale_change */
#define  P2_USCALE                       3       /* callback function: scale_change */
#define  P2_ITYPE                        4       /* callback function: uitype */
#define  P2_UTYPE                        5       /* callback function: uitype */
#define  P2_IGRAPH                       6       /* callback function: graph */
#define  P2_UGRAPH                       7       /* callback function: graph */
#define  P2_USTRIP                       8
#define  P2_ISTRIP                       9

#define  P3                              3       /* callback function: panel_close */
#define  P3_EE_00                        2       /* callback function: key_pressed */
#define  P3_EE_01                        3       /* callback function: key_pressed */
#define  P3_EE_02                        4       /* callback function: key_pressed */
#define  P3_EE_03                        5       /* callback function: key_pressed */
#define  P3_EE_STR                       6       /* callback function: key_pressed */
#define  P3_EREAD                        7       /* callback function: eread */
#define  P3_EWRITE                       8       /* callback function: ewrite */
#define  P3_STRING                       9       /* callback function: eefocus */
#define  P3_EEPROM                       10      /* callback function: eeselect */
#define  P3_CRC                          11      /* callback function: crc_update */

#define  P4                              4       /* callback function: panel_close */
#define  P4_SIGNAL                       2       /* callback function: src_dst */
#define  P4_SRC_DST                      3       /* callback function: src_dst */
#define  P4_SIGNAL_MIN                   4
#define  P4_SIZE                         5
#define  P4_ROM_START                    6
#define  P4_RAM_START                    7
#define  P4_SIGNAL_MAX                   8
#define  P4_CANCEL_SIGNAL                9       /* callback function: panel_cancel */
#define  P4_TRSM_SIGNAL                  10      /* callback function: trsm_signal */

#define  P5                              5       /* callback function: panel_close */
#define  P5_TEST6                        2
#define  P5_TEST5                        3
#define  P5_TEST4                        4
#define  P5_TEST3                        5
#define  P5_TEST2                        6
#define  P5_TEST1                        7
#define  P5_AEEWRITE                     8       /* callback function: aeewrite */
#define  P5_IEEWRITE                     9       /* callback function: ieewrite */
#define  P5_ASN                          10
#define  P5_UEEWRITE                     11      /* callback function: ueewrite */
#define  P5_ISN                          12
#define  P5_MEEWRITE                     13      /* callback function: meewrite */
#define  P5_USN                          14
#define  P5_START                        15      /* callback function: test_start */
#define  P5_MSN                          16
#define  P5_TEXTBOX                      17
#define  P5_AREV                         18
#define  P5_IREV                         19
#define  P5_UREV                         20
#define  P5_MREV                         21
#define  P5_BID_MID                      22
#define  P5_DECORATION                   23
#define  P5_DECORATION_2                 24
#define  P5_TEXTMSG                      25

#define  P6                              6       /* callback function: panel_close */
#define  P6_FDAC_METHOD                  2       /* callback function: reinit */
#define  P6_SDAC_METHOD                  3       /* callback function: reinit */
#define  P6_METHOD_U                     4       /* callback function: method_u */
#define  P6_BS3                          5       /* callback function: k_b_changed */
#define  P6_BI8                          6       /* callback function: k_b_changed */
#define  P6_BI5                          7       /* callback function: k_b_changed */
#define  P6_BF8                          8       /* callback function: k_b_changed */
#define  P6_BI7                          9       /* callback function: k_b_changed */
#define  P6_BF5                          10      /* callback function: k_b_changed */
#define  P6_BI4                          11      /* callback function: k_b_changed */
#define  P6_BU5                          12      /* callback function: k_b_changed */
#define  P6_BI6                          13      /* callback function: k_b_changed */
#define  P6_KI8                          14      /* callback function: k_b_changed */
#define  P6_BF7                          15      /* callback function: k_b_changed */
#define  P6_BS2                          16      /* callback function: k_b_changed */
#define  P6_BI3                          17      /* callback function: k_b_changed */
#define  P6_KI5                          18      /* callback function: k_b_changed */
#define  P6_BF4                          19      /* callback function: k_b_changed */
#define  P6_BI2                          20      /* callback function: k_b_changed */
#define  P6_KI7                          21      /* callback function: k_b_changed */
#define  P6_BS1                          22      /* callback function: k_b_changed */
#define  P6_BF6                          23      /* callback function: k_b_changed */
#define  P6_KI6                          24      /* callback function: k_b_changed */
#define  P6_KF8                          25      /* callback function: k_b_changed */
#define  P6_BU4                          26      /* callback function: k_b_changed */
#define  P6_KI4                          27      /* callback function: k_b_changed */
#define  P6_BI1                          28      /* callback function: k_b_changed */
#define  P6_KS3                          29      /* callback function: k_b_changed */
#define  P6_KI3                          30      /* callback function: k_b_changed */
#define  P6_CHECKBOX38                   31
#define  P6_CHECKBOX37                   32
#define  P6_CHECKBOX36                   33
#define  P6_KI2                          34      /* callback function: k_b_changed */
#define  P6_KI1                          35      /* callback function: k_b_changed */
#define  P6_BF3                          36      /* callback function: k_b_changed */
#define  P6_KF5                          37      /* callback function: k_b_changed */
#define  P6_KS2                          38      /* callback function: k_b_changed */
#define  P6_BF2                          39      /* callback function: k_b_changed */
#define  P6_KF7                          40      /* callback function: k_b_changed */
#define  P6_CHECKBOX35                   41
#define  P6_CHECKBOX34                   42
#define  P6_CHECKBOX33                   43
#define  P6_CHECKBOX32                   44
#define  P6_CHECKBOX31                   45
#define  P6_KS1                          46      /* callback function: k_b_changed */
#define  P6_BU3                          47      /* callback function: k_b_changed */
#define  P6_KF6                          48      /* callback function: k_b_changed */
#define  P6_KD                           49      /* callback function: k_b_changed */
#define  P6_KU5                          50      /* callback function: k_b_changed */
#define  P6_BU                           51      /* callback function: k_b_changed */
#define  P6_KF4                          52      /* callback function: k_b_changed */
#define  P6_BF1                          53      /* callback function: k_b_changed */
#define  P6_BU2                          54      /* callback function: k_b_changed */
#define  P6_KF3                          55      /* callback function: k_b_changed */
#define  P6_CHECKBOX28                   56
#define  P6_CHECKBOX27                   57
#define  P6_CHECKBOX26                   58
#define  P6_KF2                          59      /* callback function: k_b_changed */
#define  P6_KF1                          60      /* callback function: k_b_changed */
#define  P6_CHECKBOX13                   61
#define  P6_CHECKBOX12                   62
#define  P6_FDAC_GRAPH                   63
#define  P6_SDAC_GRAPH                   64
#define  P6_CHECKBOX11                   65
#define  P6_CHECKBOX25                   66
#define  P6_CHECKBOX24                   67
#define  P6_CHECKBOX23                   68
#define  P6_CHECKBOX22                   69
#define  P6_CHECKBOX21                   70
#define  P6_KU4                          71      /* callback function: k_b_changed */
#define  P6_BU1                          72      /* callback function: k_b_changed */
#define  P6_KU                           73      /* callback function: k_b_changed */
#define  P6_KU3                          74      /* callback function: k_b_changed */
#define  P6_KU2                          75      /* callback function: k_b_changed */
#define  P6_KU1                          76      /* callback function: k_b_changed */
#define  P6_VOLTAGE                      77      /* callback function: voltage */
#define  P6_UMODULE_CALIBR               78      /* callback function: umodule_calibr */
#define  P6_WRITE                        79      /* callback function: write */
#define  P6_READ                         80      /* callback function: read */
#define  P6_WRITE_ALL                    81      /* callback function: write_all */
#define  P6_READ_ALL                     82      /* callback function: read_all */
#define  P6_CHECKBOX6                    83
#define  P6_CHECKBOX5                    84
#define  P6_CHECKBOX4                    85
#define  P6_CHECKBOX3                    86
#define  P6_CHECKBOX2                    87
#define  P6_CHECKBOX1                    88
#define  P6_TOGGLEBUTTON4                89      /* callback function: calibr_switch */
#define  P6_TOGGLEBUTTON2                90      /* callback function: calibr_switch */
#define  P6_TOGGLEBUTTON3                91      /* callback function: calibr_switch */
#define  P6_FDAC_NPOINT                  92
#define  P6_TOGGLEBUTTON1                93      /* callback function: calibr_switch */
#define  P6_SDAC_NPOINT                  94
#define  P6_CHECKBOX8                    95
#define  P6_DECORATION                   96
#define  P6_DECORATION_2                 97
#define  P6_DECORATION_5                 98
#define  P6_DECORATION_3                 99
#define  P6_DECORATION_4                 100

#define  P7                              7       /* callback function: panel_close */
#define  P7_GRAPH                        2

#define  P9                              8       /* callback function: panel_close */
#define  P9_FORMAT                       2       /* callback function: format_change */

#define  PANEL                           9
#define  PANEL_s1                        2
#define  PANEL_s2                        3
#define  PANEL_s3                        4


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK aeewrite(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK calibr_switch(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK crc_update(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK eefocus(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK eeselect(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK em_in_switch(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK em_out_switch(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK eread(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ewrite(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK fdac_range_changed(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK fdac_value_change(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK format_change(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK get_config(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK graph(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK i_counter(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK iadc_switch(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ieewrite(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK k_b_changed(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK key_pressed(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK meewrite(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK method_u(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ommetr(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK open_interface(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK p1_close(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK panel_cancel(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK panel_close(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK panel_load(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK read(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK read_all(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK reinit(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK scale_change(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK sdac_range_changed(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK sdac_val(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK set_config(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK signal_freq(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK src_dst(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK test_start(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK timer(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK trsm_signal(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK u_counter(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK uadc_range_change(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK uadc_switch(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ueewrite(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK uitype(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK umodule_calibr(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK use_correction(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK voltage(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK write(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK write_all(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
