#ifndef __UTS_REPORTER__H
#define __UTS_REPORTER__H

#pragma pack(1)
typedef struct utsReporter utsReporter;

struct utsReporter {
  unsigned int   id;
  char *msg;
  utsReporter *prev;
  utsReporter *next;
};
#pragma pack()

utsReporter* addReporter(utsReporter *list, int id, char *msg);
void         freeReporter(utsReporter **list);

int openReporter(void cbf(void));
int closeReporter(void);
int closeReporterFromExecEnv(void);
int updateReporter(unsigned int id, char *msg);
utsReporter *GetReporter(void);

int EnaReporterClose(void);
int DisReporterClose(void);

#endif

