/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2006. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  PANEL                           1
#define  PANEL_decor                     2
#define  PANEL_descr                     3
#define  PANEL_help                      4       /* callback function: mf_help */
#define  PANEL_close                     5       /* callback function: mf_close */
#define  PANEL_DECORATION                6
#define  PANEL_TEXTMSG                   7
#define  PANEL_TEXTMSG_3                 8
#define  PANEL_led                       9
#define  PANEL_value                     10
#define  PANEL_gr_value                  11
#define  PANEL_sec_mark                  12
#define  PANEL_ramka                     13


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK mf_close(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_help(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
