#ifndef __UTSMATH__H
#define __UTSMATH__H

void   utsMath_ACDC(double *X, int N, double *URms, double *UDc);
int    utsMath_FindSyncIndex(double *X, int n, double tau, int dir, double *t, double u, int isDC);
int    utsMath_RemoveDC(double *X, int n, double *Y);
double utsMath_GetDCLine(double *X, int n, int isDC);

int utsMath_DoFFT(double *Values, int ValuesDimension1, int isDC,
					 int win, double fs, int *nfft, double *y,  
					 double *fsignal, double *pwr,
					 double * SNR, double * THD, double * SINAD, double * SFDR, double *ENOB); 

#endif

