#include "uts\\common\\include\\commondef.h"
#include "uts\\services\\common\\include\\servicedef.h"
#include <utility.h>


serviceDefine * __stdcall getUTServiceDefine(void); 


// ----------------------------------------------------------------------------
//   
// ----------------------------------------------------------------------------
void closeUTServiceDLL(serviceManager *p) 
{
 if(p->id >= 0) UnloadExternalModule(p->id); 
 p->id= -2;
};
// ----------------------------------------------------------------------------
//    (srcpath)   serviceManager
// ----------------------------------------------------------------------------
int  openUTServiceDLL(serviceManager *p, char *srcpath) 
{
 int  s, n;
 char cur_dir[FNAMELEN+1], dir[FNAMELEN+1], path[FNAMELEN+1], *sptr;
 serviceDefine *d;
 
// SetDllDirectory(path); <- only WinXP & Win2003
 strcpy(dir, srcpath); 
 if((sptr=strrchr(dir, '\\'))==NULL) goto __bad_ret; 
 *sptr=0;
 GetCurrentDirectory(sizeof(cur_dir), cur_dir);
 SetCurrentDirectory(dir);

 memset(p, 0x0, sizeof(serviceManager));
 p->id= -2;

 strcpy(path, srcpath); 
 if((sptr=strrchr(path, '.'))==NULL) goto __bad_ret; 
 *sptr=0;
 strcat(path, ".lib");

 if((p->id=LoadExternalModule(path)) < 0) goto __bad_ret; 
 p->service= (void *)GetExternalModuleAddr (p->id, "getUTServiceDefine", &s);
 if(s || (p->service == NULL)) goto __bad_ret; 
 
 SetCurrentDirectory(cur_dir);
 return 0;

__bad_ret:
 SetCurrentDirectory(cur_dir);
 closeUTServiceDLL(p);
 return 1;
};
