#include <ansi_c.h>
#include "uts\\services\\common\\include\\servicedef.h"
#include "uts\\services\\common\\include\\serviceexport.h"
#include "uts\\common\\include\\commondef.h"
#include <userint.h>

extern int  openUTService(serviceStrucOpen *);
extern int  reopenUTService(serviceStrucOpen *);
extern void closeUTService(void);
extern int  updateUTService(int, serviceStrucData *, char *);
extern int  numUTService(void);
extern int  nameUTService(int num, char *name);
extern int  bring2frontUTService(char *name);

static serviceDefine hystService= {
 PSERVNAME("Oscilloscope..."), 
 PSERVER("1.0"), 
 PSERVDESCR("Virtual oscilloscope"),
 PSERVTYPE(UTSADC),  // !!! tmp  --   

 FSERVOPEN(openUTService),
 FSERVREOPEN(reopenUTService),
 FSERVCLOSE(closeUTService),
 FSERVUPDATE(updateUTService),
 FSERVNUM(numUTService),
 FSERVNUM(nameUTService),
 FSERVNUM(bring2frontUTService)
};

// -----------------------------------------------------------------------


// -----------------------------------------------------------------------
serviceDefine * DLLEXPORT DLLSTDCALL getUTServiceDefine(void) {
  return &hystService; 
};

