/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2007. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  BRIDGE                          1
#define  BRIDGE_ok                       2       /* callback function: slf_ok */
#define  BRIDGE_list                     3
#define  BRIDGE_cancel                   4       /* callback function: slf_cancel */
#define  BRIDGE_text                     5
#define  BRIDGE_TEXTMSG                  6

#define  NAV                             2
#define  NAV_list                        2       /* callback function: slf_nav */
#define  NAV_stop                        3       /* callback function: slf_stop */
#define  NAV_start                       4       /* callback function: slf_start */
#define  NAV_closenav                    5       /* callback function: slf_closenav */
#define  NAV_data                        6


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK slf_cancel(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK slf_closenav(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK slf_nav(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK slf_ok(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK slf_start(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK slf_stop(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
