
{******************** SPORT0 & SPORT1 IRQ handlers ************************************}


{******************** SPORT 0 Receive IRQ Handler **************************************}

Sport0Receive_IRQ:


        ENA SEC_REG;
       { TOGGLE FL1;}
        
        AR=DM(BytesRcvCounter);
        AR=AR+1;        
        DM(BytesRcvCounter)=AR;

  
        AX0=1;
        AY0=DM(BytesRcvCounter);

        AR=AX0 XOR AY0;
        NONE=PASS AR;
        IF EQ JUMP HByteRcv;

        AX0=2;
        AR=AX0 XOR AY0;
        NONE=PASS AR;
        IF EQ JUMP MByteRcv;

        AX0=3;
        AR=AX0 XOR AY0;
        NONE=PASS AR;
        IF EQ JUMP LByteRcv;


HByteRcv:
        DM(CommandHByteRcv)=RX0; 
       { TT;TT;   }
        JUMP IRQ_R_End;

MByteRcv:
        DM(CommandMByteRcv)=RX0; 
      {  TT; TT;  }
        JUMP IRQ_R_End;

LByteRcv:
               
        DM(CommandLByteRcv)=RX0;  
        AR=0;
        DM(BytesRcvCounter)=AR;
  
        AX0=DM(CommandHByteRcv); 
        AY0=B#100000000;
   

        AR=AX0 AND AY0;
        NONE=PASS AR;
        IF EQ JUMP IRQ_R_End;  

        AY0=B#000111111;                      
        AR=AX0 AND AY0;   
{***************************************}  
        DM(Command)=AR;    
        
        DM(I_tmp)=I4;
        DM(L_tmp)=L4;
        DM(M_tmp)=M4;

       


        I4=DM(Cur_Command_Buf_Addr);
        L4=%Commands_Buf;
        M4=1;  

        PX=AR;  {  8  -   }

        SR0=DM(CommandMByteRcv);
        SR=LSHIFT SR0 BY 8 (LO);
        AX0=SR0;
        AY0=DM(CommandLByteRcv);
        AR=AX0 OR AY0;

       
        PM(I4,M4)=AR;
        DM(Cur_Command_Buf_Addr)=I4; {        }

        I4=DM(I_tmp);  {     } 
        L4=DM(L_tmp);
        M4=DM(M_tmp);     
         


    

{***************************************}
        

        {DM(Command)=AR; }  
        JUMP IRQ_R_End;

IRQ_R_End:
        
     
        DIS SEC_REG;  
        RTI;

{**************   SPORT 0 Transmit IRQ (IRQ2)  ************************************}       
 
IRQ2_Handler: { Sport0Transmit_IRQ: }
   

       ENA SEC_REG;


       AR=DM(TrFlag);
       NONE=PASS AR;
       IF EQ JUMP IRQ2_PreEnd;
       
       AR=DM(BytesTrCounter);
       AR=AR+1;
       DM(BytesTrCounter)=AR;

       
       AR=AR-1;
       NONE=PASS AR;
       IF EQ JUMP M_Byte_Transmission;

       AR=AR-1;
       NONE=PASS AR;
       IF EQ JUMP L_Byte_Transmission;


M_Byte_Transmission:

        TX0=DM(MByteTr); 
       JUMP IRQ2_End;

L_Byte_Transmission:
       


       TX0=DM(LByteTr);   
       AR=0;
       DM(BytesTrCounter)=AR;
       DM(TrFlag)=AR; 
       JUMP IRQ2_End;

IRQ2_PreEnd:
      AR=0;
      DM(PortIsFree_Tr)=AR;


IRQ2_End:
       
       DIS SEC_REG; 
       RTI;

{*************************** SPORT1 Transmit IRQ *********************************************}

Sport1Transmit_IRQ:                                                  


ENA SEC_REG;
AR=1;
DM(Sport1TxFlag)={AX1}AR; 
DIS SEC_REG;
                                                                     
RTI;
{*********************************************************************************************}

{***************************SPORT1 Receive IRQ ***********************************************}
                                                                      
Sport1Receive_IRQ:

ENA SEC_REG;

 
AR=1;
DM(Sport1RxFlag)=AR;
DM(Sport1RxData)=RX1;  
DIS SEC_REG;
                                                                     

 
RTI;
 

