/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2007. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  CLB                             1
#define  CLB_clbclose                    2       /* callback function: clbf_close */
#define  CLB_stage1                      3       /* callback function: clbf_stage1 */
#define  CLB_mode                        4       /* callback function: clbf_mode */
#define  CLB_DECORATION                  5
#define  CLB_d_8                         6
#define  CLB_d_7                         7
#define  CLB_d_6                         8
#define  CLB_d_5                         9
#define  CLB_d_4                         10
#define  CLB_d_3                         11
#define  CLB_d_2                         12
#define  CLB_d_1                         13
#define  CLB_TEXTMSG_2                   14
#define  CLB_c_8                         15      /* callback function: clbf_channel */
#define  CLB_c_7                         16      /* callback function: clbf_channel */
#define  CLB_c_6                         17      /* callback function: clbf_channel */
#define  CLB_c_5                         18      /* callback function: clbf_channel */
#define  CLB_c_4                         19      /* callback function: clbf_channel */
#define  CLB_c_3                         20      /* callback function: clbf_channel */
#define  CLB_c_2                         21      /* callback function: clbf_channel */
#define  CLB_c_1                         22      /* callback function: clbf_channel */
#define  CLB_l_8                         23
#define  CLB_l_7                         24
#define  CLB_l_6                         25
#define  CLB_l_5                         26
#define  CLB_l_4                         27
#define  CLB_l_3                         28
#define  CLB_l_2                         29
#define  CLB_l_1                         30
#define  CLB_DECORATION_2                31
#define  CLB_list                        32      /* callback function: clbf_list */
#define  CLB_DECORATION_3                33
#define  CLB_DECORATION_4                34
#define  CLB_TEXTMSG_5                   35
#define  CLB_toggle                      36      /* callback function: clbf_toggle */
#define  CLB_led                         37
#define  CLB_reset                       38

#define  PANEL                           2
#define  PANEL_s_8                       2
#define  PANEL_s_7                       3
#define  PANEL_s_6                       4
#define  PANEL_s_5                       5
#define  PANEL_cfgdone                   6       /* callback function: mf_apply */
#define  PANEL_calibr                    7       /* callback function: mf_calibr */
#define  PANEL_firselect                 8       /* callback function: mf_firselect */
#define  PANEL_iirselect                 9       /* callback function: mf_iirselect */
#define  PANEL_s_4                       10
#define  PANEL_s_3                       11
#define  PANEL_s_2                       12
#define  PANEL_s_1                       13
#define  PANEL_clb                       14      /* callback function: mf_UseClb */
#define  PANEL_c_8                       15      /* callback function: mf_chan */
#define  PANEL_to                        16
#define  PANEL_time                      17
#define  PANEL_c_7                       18      /* callback function: mf_chan */
#define  PANEL_c_6                       19      /* callback function: mf_chan */
#define  PANEL_c_5                       20      /* callback function: mf_chan */
#define  PANEL_c_4                       21      /* callback function: mf_chan */
#define  PANEL_c_3                       22      /* callback function: mf_chan */
#define  PANEL_c_2                       23      /* callback function: mf_chan */
#define  PANEL_c_1                       24      /* callback function: mf_chan */
#define  PANEL_fs                        25
#define  PANEL_fsFlt                     26
#define  PANEL_fs0                       27
#define  PANEL_fir                       28      /* callback function: mf_freq */
#define  PANEL_iir                       29      /* callback function: mf_freq */
#define  PANEL_ppoint                    30      /* callback function: mf_point */
#define  PANEL_point                     31      /* callback function: mf_point */
#define  PANEL_ac                        32      /* callback function: mf_ac */
#define  PANEL_ref                       33
#define  PANEL_DECORATION                34
#define  PANEL_DECORATION_2              35
#define  PANEL_DECORATION_3              36
#define  PANEL_DECORATION_4              37
#define  PANEL_firname                   38
#define  PANEL_iirname                   39
#define  PANEL_taps                      40
#define  PANEL_decimation                41
#define  PANEL_DECORATION_6              42
#define  PANEL_decor                     43
#define  PANEL_TEXTMSG                   44
#define  PANEL_TEXTMSG_2                 45
#define  PANEL_TEXTMSG_3                 46
#define  PANEL_TEXTMSG_4                 47
#define  PANEL_acq_mode                  48      /* callback function: mf_acq_mode */
#define  PANEL_fabric_clb                49      /* callback function: mf_UseFabricClb */
#define  PANEL_DECORATION_5              50

#define  WP                              3
#define  WP_TEXTMSG                      2


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK clbf_channel(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK clbf_close(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK clbf_list(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK clbf_mode(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK clbf_stage1(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK clbf_toggle(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_ac(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_acq_mode(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_apply(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_calibr(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_chan(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_firselect(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_freq(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_iirselect(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_point(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_UseClb(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_UseFabricClb(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
