#ifndef LTR22_LOCAL_DEFS__H
#define LTR22_LOCAL_DEFS__H
//-----------------------------------------------------------------------------
#include "uts\\systems\\common\\include\\tfuncdef.h"
#include "uts\\systems\\common\\include\\plugindef.h"
#include "uts\\systems\\common\\include\\utspfunc.h"
#include "uts\\services\\common\\include\\servicedef.h"
#include "uts\\systems\\ltr\\common\\include\\ltrspecific.h"
#include "ltrspecificMy.h" 
#include "ltr\\include\\ltr22api.h"
#include "uts\\instruments\\te01\\te01api.h"    
//-----------------------------------------------------------------------------
#define MAXNPOINTS    100000
#define TE01EXTNAME   "TE-01-EXT"             // 9 char maximum
#define INIFNAME      "ltr22ini.ini"
//-----------------------------------------------------------------------------
#pragma pack(1)
typedef struct 							 //
{	
 bool ExternalStart;
 BOOL UseCalibration;					 //    . 
 DWORD ProcDataSize;						 //   
 DWORD AcqDataSize;						 //    ( )
 
 struct 
 {								 //
	bool onoff;							 //  /
 } LogChan[LTR22_ADC_NUMBERS];			 //   
 
 TLTR22 ModulesConfiguration[17];

} IniSet_LTR22;							 //
#pragma pack()
//-----------------------------------------------------------------------------
//extern TLTR22 module;
//extern DESCRIPTION_LTR22 description;
extern IniSet_LTR22 IniSet;
//-----------------------------------------------------------------------------
void openThisPlugin(void);
void closeThisPlugin(void);
int   openModule(TCONTEXT *tc);
int  closeModule(void);
int configModule(void);
void readINI(char *inidir);
void writeINI(char *inidir);
#endif


