/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2006. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  PANEL                           1
#define  PANEL_cfgdone                   2       /* callback function: mf_apply */
#define  PANEL_divider                   3       /* callback function: cbf_control */
#define  PANEL_to                        4
#define  PANEL_time                      5
#define  PANEL_freq                      6
#define  PANEL_DECORATION_5              7
#define  PANEL_DECORATION                8
#define  PANEL_fch                       9
#define  PANEL_list                      10      /* callback function: cbf_list */
#define  PANEL_DECORATION_3              11
#define  PANEL_clear                     12      /* callback function: cbf_clear */
#define  PANEL_DECORATION_4              13
#define  PANEL_TEXTMSG                   14
#define  PANEL_total                     15
#define  PANEL_nlchan                    16
#define  PANEL_TEXTMSG_2                 17
#define  PANEL_calibr                    18      /* callback function: cbf_control */
#define  PANEL_procpoint                 19      /* callback function: cbf_control */
#define  PANEL_point                     20      /* callback function: cbf_control */
#define  PANEL_debug_on                  21
#define  PANEL_info                      22

#define  WP                              2
#define  WP_TEXTMSG                      2


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK cbf_clear(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cbf_control(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cbf_list(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_apply(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
