/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2006. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  PANEL_Conf                      1       /* callback function: CloseAll */
#define  PANEL_Conf_Exit_BTN             2       /* callback function: Exit_CLB */
#define  PANEL_Conf_IO_1_8_SW            3
#define  PANEL_Conf_IO_9_16_SW           4
#define  PANEL_Conf_IO_17_24_SW          5
#define  PANEL_Conf_IO_25_32_SW          6
#define  PANEL_Conf_Lines_TXT_2          7
#define  PANEL_Conf_Lines_TXT            8
#define  PANEL_Conf_DECORATION_4         9
#define  PANEL_Conf_StartMark_mode       10
#define  PANEL_Conf_Lines_TXT_4          11
#define  PANEL_Conf_DECORATION_3         12
#define  PANEL_Conf_SecondMark_mode      13
#define  PANEL_Conf_Lines_TXT_3          14
#define  PANEL_Conf_Work_BTN             15      /* callback function: Work_CLB */
#define  PANEL_Conf_RS485_FrameSize_NUM  16
#define  PANEL_Conf_RS485_Baud_NUM       17
#define  PANEL_Conf_RS485_Parity_RING    18
#define  PANEL_Conf_RS485_StopBit_SW     19
#define  PANEL_Conf_InMultiplier_NUM     20
#define  PANEL_Conf_DECORATION_5         21
#define  PANEL_Conf_DECORATION_2         22
#define  PANEL_Conf_OutMultiplier_NUM    23
#define  PANEL_Conf_StreamFreq_NUM       24
#define  PANEL_Conf_DECORATION           25

#define  PANEL_RS                        2
#define  PANEL_RS_ExitRS485Work_BTN      2       /* callback function: ExitRS485Work_CLB */
#define  PANEL_RS_InArray_TBL            3
#define  PANEL_RS_OutArray_TBL           4
#define  PANEL_RS_InSize_RNG             5       /* callback function: InSize_CLB */
#define  PANEL_RS_OutSize_RNG            6       /* callback function: OutSize_CLB */
#define  PANEL_RS_RS485_Exchange_BTN     7       /* callback function: RS485_Exchange_CLB */
#define  PANEL_RS_RcvTimeOut_NUM         8
#define  PANEL_RS_TrTimeOut_NUM          9
#define  PANEL_RS_StopBit_NUM            10
#define  PANEL_RS_FrameSize_NUM          11
#define  PANEL_RS_Baud_NUM               12
#define  PANEL_RS_Parity_STR             13
#define  PANEL_RS_Status485_TXT          14
#define  PANEL_RS_DECORATION             15
#define  PANEL_RS_DECORATION_2           16

#define  PANEL_Work                      3       /* callback function: Close */
#define  PANEL_Work_ExitWork_BTN         2       /* callback function: ExitWork_CLB */
#define  PANEL_Work_L1                   3
#define  PANEL_Work_WriteWord_BTN        4       /* callback function: WriteWord_CLB */
#define  PANEL_Work_ReadWord_BTN         5       /* callback function: ReadWord_CLB */
#define  PANEL_Work_DEC                  6
#define  PANEL_Work_HEX                  7
#define  PANEL_Work_MakeStartMark_BTN    8       /* callback function: MakeStartMark_CLB */
#define  PANEL_Work_SecondMarksStop_BTN  9       /* callback function: SecondMarksStop_CLB */
#define  PANEL_Work_SecondMarksGo_BTN    10      /* callback function: SecondMarksGo_CLB */
#define  PANEL_Work_DECORATION           11
#define  PANEL_Work_DECORATION_2         12
#define  PANEL_Work_RS485_BTN            13      /* callback function: RS485_CLB */
#define  PANEL_Work_Ports_STR            14
#define  PANEL_Work_Serial_STR           15
#define  PANEL_Work_Slot_NUM             16
#define  PANEL_Work_StreamRead_BTN       17      /* callback function: StreamRead_CLB */
#define  PANEL_Work_StreamReadStop_BTN   18      /* callback function: StreamReadStop_CLB */
#define  PANEL_Work_DECORATION_3         19
#define  PANEL_Work_DECORATION_4         20
#define  PANEL_Work_Stream_LED           21
#define  PANEL_Work_StreamFreq_NUM       22
#define  PANEL_Work_PointsQnt_NUM        23
#define  PANEL_Work_DECORATION_5         24
#define  PANEL_Work_TEXTMSG              25
#define  PANEL_Work_Status_TXT           26


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK Close(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK CloseAll(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Exit_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ExitRS485Work_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ExitWork_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK InSize_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK MakeStartMark_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK OutSize_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ReadWord_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK RS485_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK RS485_Exchange_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SecondMarksGo_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SecondMarksStop_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK StreamRead_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK StreamReadStop_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Work_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK WriteWord_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
