#include <windows.h>
#include <ansi_c.h>
#include <userint.h>
//#include "te01api.h"
//#include "pluginuir.h"
#include "pluginuir.h"  
//#include "tfuncdef.h"
#include "localdefs.h"

#include <analysis.h>
#include <utility.h>

#include <windows.h>
#include <ansi_c.h>
#include <userint.h>
#include "uts\\instruments\\te01\\te01api.h"
#include "pluginuir.h"
#include "UTS\\systems\\common\\include\\tfuncdef.h"
#include "localdefs.h"
#include "UTS\\systems\\common\\include\\plugindef.h"
#include "UTS\\systems\\ltr\\common\\include\\ltrspecific.h"
#include "C:\\prj\\UTS\\services\\common\\include\\servicedef.h"
#include "ltr\\include\\ltr212api.h"
#include "ltr\\include\\ltr43api.h" 
#include <analysis.h>

LPCSTR error_string; 
//char error_string[100];
static int PH_Work;
static int PH_RS485;  
static int  SecondMarksFlag=0;    

static int Pnl= -1;
//static int TePnl= -1;
#define P(x)  PANEL_##x
#define TOTAL_IO_LINES 32


extern TLTR43 hltr43;
  
 //hltr43.k/*RS485.Ena*/=1;
// hltr212.AcqMode=1;
  
  

  
/*extern*/ TLTR channel;


static char thePATH[FNAMELEN+1];


 int LinesIDs[32];
 int decs[4];
 int HEX[4];
 int Ports[4];
  
int PointsQnt;

HANDLE ReadThread;

int StreamRead_Flag=0;
int StopStreamRead_Flag=0;
int QuitLockFlag=0;

static TCONTEXT theTCONTEXT;    

// -------------------------------------------------------------
static void calcFS(double *fsBase, double *fs);

//#define THE8CHANTIME 1.0/50e3  // !!! tmp
#define MAX_LINE 32
//#define QFreq 4.9152e6


//extern TLTR43 hltr43; 

//***********************************************************************************************************

int utspGetDIODescr(TCONTEXT *tc, pluginDIO *D, int line);


static void StreamRead_Func(void *par) 
{

 DWORD *data;
 DWORD *ReceivedWords;
 int ReceivedWordsQnt;
 
 int i;
 int j;
 DWORD k=0;
 int LineVal; 
DWORD size;
 int err;
 int timeout;
 int tick1,tick2,tick;   

 StreamRead_Flag=1;
 QuitLockFlag=1;
 
 size=2*PointsQnt;
 timeout=(int) (1000*(2*PointsQnt/hltr43.StreamReadRate)+1000);  //   
 
 data=calloc(2*PointsQnt, sizeof(DWORD));
 ReceivedWords=calloc(PointsQnt, sizeof(DWORD));  
 
 
 while(StreamRead_Flag)
  {
    ReceivedWordsQnt=LTR43_Recv(&hltr43, data, NULL, 2*PointsQnt, timeout);
    
    if(ReceivedWordsQnt!=2*PointsQnt)
     {
	  MessagePopup ("Error!", "Less samples received! Stream reading will be aborted!");
      StreamRead_Flag=0;
      break;
     }
    
    
    err=LTR43_ProcessData(&hltr43, data, ReceivedWords, &size); 
    if(err)
     {
     
      error_string=LTR43_GetErrorString(err); 
      if(theTCONTEXT.cbf!=NULL)theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
      StreamRead_Flag=0;
      break;
     }
     
    tick1=GetTickCount(); 
    
     SetCtrlVal (PH_Work, PANEL_Work_Stream_LED, k&0x1);
	   k++;
    
    
     for(i=0;i<size; i++)
      {
     
    	for(j=0;j<32;j++)
		 {
		 
		  LineVal=(ReceivedWords[i]>>j)&0x1;
		  SetCtrlVal (PH_Work,LinesIDs[j], LineVal);
		  
		 }	   
		 
		 
		for(j=0;j<32;j+=8)
		 SetCtrlVal (PH_Work, HEX[3-j/8], (ReceivedWords[i]>>j)&0xFF);     
		 //ProcessSystemEvents();   
	
    tick2=GetTickCount();
    tick=tick2-tick1;
    
		 ;
    
     } //  for(i=0...)	 
    
    
  } //  while
  
 StopStreamRead_Flag=1; 
 free(data);
 free(ReceivedWords);
  
}






void closeUIR(void) {
  if(Pnl!= -1)   { DiscardPanel(Pnl);   Pnl= -1;   };
  //if(TePnl!= -1) { DiscardPanel(TePnl); TePnl= -1; };  
};

//**********************************************************************************************************

int utspConfigTest(TCONTEXT *tc, void *p) {  return 0; };
int utspVirtualDevice(TCONTEXT *tc, void *p) { return 0; };


#pragma pack(1)

typedef struct
 {
  int Pins1_8;  //        
  int Pins9_16;
  int Pins17_24;
  int Pins25_32;
  double StreamReadFreq;
  int RS485_Baud;   //    RS485
  int RS485_FrameSize;
  int RS485_Parity;
  int RS485_StopBit;
  int RS485_OutPackSize;
  int RS485_InPackSize;
  int RS485_OutMultiplier;
  int RS485_InMultiplier;
  int SecMark_EnaDis;   //  
  int Start_Mark_Ena; //  ""
  int SecMark_Mode;
  int StartMark_Mode;  
 } IniSet_43;
  
  
#pragma pack()

//static IniSet_XXX IniSet;
static IniSet_43 IniSet;

static char theDIR[FNAMELEN+1], theMDESCR[COMMENTLEN+1];  

//*************************************************************************************

static void writeINI(void) {                           
  FILE *f;                                             
  char fname[FNAMELEN+1];                              
  sprintf(fname, "%s\\%s", theDIR, theMDESCR);         
  if((f= fopen(fname, "wb")) == NULL) return;          
  fwrite (&IniSet, sizeof(IniSet_43), 1, f);           
  fclose(f);                                           
};                                                     
                                                       
//*************************************************************************************************************

 
 
static void fillINI(void) 
{  //   UIR- 
 

 memset(&IniSet, 0x0, sizeof(IniSet_43));
 
IniSet.Pins1_8=0;
IniSet.Pins9_16=0; 
IniSet.Pins17_24=0; 
IniSet.Pins25_32=0; 
IniSet.Pins1_8=0; 

IniSet.StreamReadFreq=10000;

IniSet.SecMark_EnaDis=0; 
IniSet.Start_Mark_Ena=0;
IniSet.SecMark_Mode=0;



  IniSet.RS485_Baud=4800;   //    RS485
  IniSet.RS485_FrameSize=8;
  IniSet.RS485_Parity=0;
  IniSet.RS485_StopBit=0;
  IniSet.RS485_OutPackSize=1;
  IniSet.RS485_InPackSize=1;
  IniSet.RS485_OutMultiplier=10;
  IniSet.RS485_InMultiplier=10;



//writeINI();

 

};

//#define INIFNAME "inifile.ini"

//*************************************************************************************************

static void readINI(char *xdir, char *mdescr) {
  FILE *f;
  char fname[FNAMELEN+1];
  strcpy(theDIR, xdir);
  strcpy(theMDESCR, mdescr);  
  fillINI();
  sprintf(fname, "%s\\%s", theDIR, theMDESCR);
  if((f= fopen(fname, "rb")) == NULL) return;
  fread (&IniSet, sizeof(IniSet_43), 1, f);
  fclose(f);
};

//*****************************************************************************************************

// -------------------------------------------------------------------------------------
static void showINI(void) {



SetCtrlVal (Pnl, PANEL_Conf_IO_1_8_SW, IniSet.Pins1_8);
SetCtrlVal (Pnl, PANEL_Conf_IO_9_16_SW, IniSet.Pins9_16);   
SetCtrlVal (Pnl, PANEL_Conf_IO_17_24_SW, IniSet.Pins17_24);   
SetCtrlVal (Pnl, PANEL_Conf_IO_25_32_SW, IniSet.Pins25_32);  
//SetCtrlVal (Pnl, PANEL_Conf_RS485_SW,IniSet.RS485_EnaDis);
//SetCtrlVal (Pnl, PANEL_Conf_Sec_Mark_SW,IniSet.SecMark_EnaDis);  
SetCtrlVal (Pnl, PANEL_Conf_StreamFreq_NUM, IniSet.StreamReadFreq);    

SetCtrlVal (Pnl, PANEL_Conf_SecondMark_mode , IniSet.SecMark_Mode);  
SetCtrlVal (Pnl, PANEL_Conf_StartMark_mode , IniSet.StartMark_Mode); 

 // RS-485

SetCtrlVal (Pnl, PANEL_Conf_RS485_Baud_NUM , IniSet.RS485_Baud);  
SetCtrlVal (Pnl, PANEL_Conf_RS485_FrameSize_NUM , IniSet.RS485_FrameSize);  
SetCtrlVal (Pnl, PANEL_Conf_RS485_Parity_RING , IniSet.RS485_Parity);  
SetCtrlVal (Pnl, PANEL_Conf_RS485_StopBit_SW , IniSet.RS485_StopBit);  
//SetCtrlVal (Pnl, PANEL_Conf_OutPackSize_NUM , IniSet.RS485_OutPackSize);  
//SetCtrlVal (Pnl, PANEL_Conf_InPackSize_NUM , IniSet.RS485_InPackSize);  


//SetCtrlVal (Pnl, PANEL_RS_OutSize_RNG ,IniSet.RS485_OutPackSize);  
//SetCtrlVal (Pnl, PANEL_RS_InSize_RNG , IniSet.RS485_InPackSize);  
            
SetCtrlVal (Pnl, PANEL_Conf_OutMultiplier_NUM , IniSet.RS485_OutMultiplier);  
SetCtrlVal (Pnl, PANEL_Conf_InMultiplier_NUM , IniSet.RS485_InMultiplier);  

};  

static int numOfVChan(void);

static void copyIni2Ltr43Struc(TLTR43 *hltr43)
{
 
 
 hltr43->IO_Ports.Port1=IniSet.Pins1_8;
 hltr43->IO_Ports.Port2=IniSet.Pins9_16;
 hltr43->IO_Ports.Port3=IniSet.Pins17_24;
 hltr43->IO_Ports.Port4=IniSet.Pins25_32;   
 
						//GetCtrlVal (PH_Work, PANEL_Work_StreamFreq_NUM, );
 hltr43->StreamReadRate=IniSet.StreamReadFreq;
 
 hltr43->Marks.SecondMark_Mode=IniSet.SecMark_Mode;
 hltr43->Marks.StartMark_Mode=IniSet.StartMark_Mode;   
 
 // RS-485
 
 hltr43->RS485.Baud=IniSet.RS485_Baud;
 hltr43->RS485.FrameSize=IniSet.RS485_FrameSize;  
 hltr43->RS485.StopBit=IniSet.RS485_StopBit;  
 hltr43->RS485.Parity=IniSet.RS485_Parity;  
 hltr43->RS485.SendTimeoutMultiplier=IniSet.RS485_OutMultiplier;  
 hltr43->RS485.ReceiveTimeoutMultiplier=IniSet.RS485_InMultiplier;  
 
};

// -------------------------------------------------------------------------------------

//static TCONTEXT theTCONTEXT;

//************************************************************************************************************

int utspConfigDevice(TCONTEXT *tc, void *q) {
  char ppath[FNAMELEN+1];
  
  memcpy(&theTCONTEXT, tc, sizeof(TCONTEXT));
  
  readINI(tc->dllpath, tc->mdescr);
  sprintf(ppath, "%s\\%s", tc->dllpath, "pluginuir.uir");
 strcpy(thePATH, ppath);
  
  Pnl= LoadPanelEx (0, ppath, PANEL_Conf, __CVIUserHInst); // ppath - , ,   uir!!! 
 
  
  showINI();  
  

  
  InstallPopup(Pnl);

  return 0;
};

// ------------------------------------------------


static int getCtrlVals(void) {


			 GetCtrlVal (Pnl, PANEL_Conf_IO_1_8_SW, &IniSet.Pins1_8);
			 GetCtrlVal (Pnl, PANEL_Conf_IO_9_16_SW, &IniSet.Pins9_16); 
			 GetCtrlVal (Pnl, PANEL_Conf_IO_17_24_SW, &IniSet.Pins17_24); 
			 GetCtrlVal (Pnl, PANEL_Conf_IO_25_32_SW, &IniSet.Pins25_32);

			 GetCtrlVal (Pnl, PANEL_Conf_StreamFreq_NUM, &IniSet.StreamReadFreq);   
			 
			 GetCtrlVal (Pnl, PANEL_Conf_SecondMark_mode , &IniSet.SecMark_Mode); 
			 GetCtrlVal (Pnl, PANEL_Conf_StartMark_mode , &IniSet.StartMark_Mode); 
			 
			 
			 // RS-485

            GetCtrlVal (Pnl, PANEL_Conf_RS485_Baud_NUM , &IniSet.RS485_Baud);  
            GetCtrlVal (Pnl, PANEL_Conf_RS485_FrameSize_NUM , &IniSet.RS485_FrameSize);  
            GetCtrlVal (Pnl, PANEL_Conf_RS485_Parity_RING , &IniSet.RS485_Parity);  
            GetCtrlVal (Pnl, PANEL_Conf_RS485_StopBit_SW , &IniSet.RS485_StopBit);  
            //GetCtrlVal (Pnl, PANEL_RS_OutSize_RNG , &IniSet.RS485_OutPackSize);  
            GetCtrlVal (Pnl, PANEL_RS_InSize_RNG , &IniSet.RS485_InPackSize);  
            GetCtrlVal (Pnl, PANEL_Conf_OutMultiplier_NUM , &IniSet.RS485_OutMultiplier);  
            GetCtrlVal (Pnl, PANEL_Conf_InMultiplier_NUM , &IniSet.RS485_InMultiplier);  
			 
 			return 0;
};

int CVICALLBACK mf_apply (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {


	switch (event) {
		case EVENT_COMMIT:
		
		
		
		    getCtrlVals();
		
 			
		    writeINI(); 
		    DiscardPanel(Pnl);
		    Pnl= -1;		    
		break;
	}
	return 0;
};

// ***********************************************************************
static HANDLE hThread;
static int (*dataUpdateCBF)(int nchan, serviceStrucData X[], char *info)= NULL;

//static double rd_buf_double[MAXNPOINTS * MAX_CHANNEL];
//static double rd_buf_double_u[MAXNPOINTS * MAX_CHANNEL];

//static double dbuf[MAX_CHANNEL][MAXNPOINTS];
static serviceStrucData serviceDATA[MAX_LINE];

static int runFlag;

//**************************************************************************

int calcTimeOutMs(void);

static void DataRecorder(void *par) 
{
 int j;
 int n=/*32*/TOTAL_IO_LINES;
 double line_val[32][1];
 int SecMark_Flag=0;
 
 DWORD port_data_inp, port_data_out;
 
 int err;
 
 while(runFlag) { 
 
  
  

 //     
 err=LTR43_ReadPort(&hltr43, &port_data_inp); 
  
 SecMark_Flag=0; 

 



   for(j= 0; j< n; j++) 
     {
       serviceDATA[j].point= 1;
       serviceDATA[j].iarray= NULL; 
       serviceDATA[j].darray= NULL; 
       //serviceDATA[j].fs= 0;
     };

 
  //serviceDATA[0].fs=hltr43.Marks.SecondMarks_Qnt;  
  
 
 
   
   for(j= 0; j< n; j++)
     {
       
       line_val[j][0]=(double) ((port_data_inp>>j)&(0x00000001));
       serviceDATA[j].point=  1;
       serviceDATA[j].iarray=line_val[j];
     };


__skip_processing:

   
   dataUpdateCBF(n, serviceDATA, NULL);
   
   //  ,       
   
   port_data_out=0;
   
   for(j= 0; j< n; j++)
     {
       
       serviceDATA[j].point=  1;
       port_data_out|=((DWORD) *(serviceDATA[j].iarray))<<j;
       
     };
  
  //if(!SecMark_Flag) 
  err=LTR43_WritePort(&hltr43, port_data_out);  

   Sleep(0);
   
   
   
   
   
 };


 Sleep(500);
 ExitThread(0);
 
 

 
};

extern int testPlolog(TCONTEXT *tc);
extern void closeModule(void);

int configHW(TCONTEXT *tc, TLTR43 *hltr43)
{
 int j;
 LPCSTR error_string;
 
 
 readINI(tc->dllpath, tc->mdescr);
 copyIni2Ltr43Struc(hltr43);
 
 
 
 if( (j=LTR43_Config(hltr43)) ) 
 {
 
 
 error_string=LTR43_GetErrorString(j); 
 
 if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, (char*)error_string); 
  return j;
  
  }
  
  
  
 if(IniSet.SecMark_EnaDis)
  if( (j=LTR43_StartSecondMark(hltr43)) ) 
   {
 
 
 error_string=LTR43_GetErrorString(j); 
 
 if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, (char*)error_string); 
  return j;
  }
  
  
 
 return 0;
};

 //hltr43.RS485.Ena=1; 
 
 

int utspStart(TCONTEXT *tc, void *p) {
  DWORD TmpDWord;
  plugStartStruc *X;

  X= (plugStartStruc *)p;
  if(testPlolog(tc)) return 1;  // !!! ??? tmp
  
  

  if(configHW(tc, &hltr43)) 
  {
     closeModule();
     return 1;
  };  

  dataUpdateCBF= X->coreCBF; // (dataUpdateCBF_FPtr)p;


  runFlag= 1;
  hThread= CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)DataRecorder, 
                        NULL, CREATE_SUSPENDED, (LPDWORD)&TmpDWord);

  ResumeThread(hThread);        // start thread here
  
  return 0;
};


int utspStop(TCONTEXT *tc, void *p) {
  
  runFlag= 0;
  WaitForMultipleObjects(1, &hThread, TRUE, INFINITE);
  CloseHandle(hThread);
  

  closeModule();   // !!!          - 
   //   openmodule    
  return 0;
};


// *******************************************************************************

// -------------------------------------------------------------


// -------------------------------------------------------------
int utspConfigTe01Ext(TCONTEXT *tc, void *p) {
  return 0;
};



// -------------------------------------------------------------

// -------------------------------------------------------------
static void makeLineDescr(int ind, int type, char X[COMMENTLEN+1]) {
 
char line_type[10];    
    
  if(type==1)
    strcpy(line_type, "input");
  if(type==2)
    strcpy(line_type, "output"); 
    
    
    sprintf(X, "Line %d:%7s",ind+1,line_type);  
};
// -------------------------------------------------------------
 int utspGetDescrDIO(TCONTEXT *tc, pluginDIO *D, int line) { 
 int    ind= -1, q= 0, j;

 if(!line) readINI(tc->dllpath, tc->mdescr);
 
 memset(D, 0x0, sizeof(pluginDIO));
 
 for(j= 0; j< 32; j++) //   
  {
    if(j<8)
     {
      if(j==line)
       {
        ind= j;
        D->type=IniSet.Pins1_8+1; // ..  UTS  -1,  - 2.   LTR43 inp - 0; out - 1
        break; 
       };
        q++;
     };
     
     
    if((j>=8)&&(j<16))
     {
      if(j==line)
       {
        ind= j;
        D->type=IniSet.Pins9_16+1; // ..  UTS  -1,  - 2.   LTR43 inp - 0; out - 1
        break; 
       };
        q++;
     };
     
     
    if((j>=16)&&(j<24))
     {
      if(j==line)
       {
        ind= j;
        D->type=IniSet.Pins17_24+1; // ..  UTS  -1,  - 2.   LTR43 inp - 0; out - 1
        break; 
       };
        q++;
     };
     
    if((j>=24)&&(j<32))
     {
      if(j==line)
       {
        ind= j;
        D->type=IniSet.Pins25_32+1; // ..  UTS  -1,  - 2.   LTR43 inp - 0; out - 1
        break; 
       };
        q++;
     };
     
     
     
 };
 
 //D->type= UTSADC_FAST_SYNC; 
 D->tnline=32;
 //calcFS(&fb, &D->fs);
 
 if(ind == -1) return 1;
 
 D->line=line;
 
 makeLineDescr(ind, D->type, D->comment);
 
 //strcpy(D->unit, "");    
 

 return 0;
};


int CVICALLBACK mf_mode (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {

	switch (event) {
		case EVENT_COMMIT:

			break;
	}
	return 0;
}

int CVICALLBACK mf_chan (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {

	switch (event) {
		case EVENT_COMMIT:

			break;
	}
	return 0;
}



// ****************************************************************************
int utspVerifyModule(TCONTEXT *tc) {
 //jumpToCalibrPanel(tc);
 return 0;
};

// ************************************************************************

//static int calibrStartData(TCONTEXT *tc, void *p);
static int calibrStopData(TCONTEXT *tc, void *p);




int CVICALLBACK ExitWork_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 int err=0;
	switch (event)
		{
		case EVENT_COMMIT:
		
if(SecondMarksFlag)
  {
	err=LTR43_StopSecondMark(&hltr43); 
	
	if(err)
	{
     error_string=LTR43_GetErrorString(err); 
     if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
     ResetTextBox (PH_Work, PANEL_Work_Status_TXT, TimeStr());
     InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">      "); 
     
    }	
   else
   {
   ResetTextBox (PH_Work, PANEL_Work_Status_TXT, TimeStr());
   InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">    "); 
    SecondMarksFlag=0; 
   } 
   SecondMarksFlag;
		 
  }   //  if(SecondMarksFlag) 
							 
							 
  DiscardPanel(PH_Work);	
		
		
			break;
		}
	return 0;
}




int CVICALLBACK Work_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{

char s[32][15];
 

 char tmp_str[30];
 char pn[2];
 //char s2[20]="PANEL_Work_";
 int top, left, height, width;
 int d=25;

 int m;
 int h=0;
 
 int i;
 
 
 pluginDIO DIO_Descr[32];

	switch (event)
		{
		case EVENT_COMMIT:
		
	 getCtrlVals();
     writeINI(); 
     
     for(i=0;i<32;i++)
    utspGetDescrDIO(&theTCONTEXT, DIO_Descr+i, i);
     
		
	PH_Work = LoadPanelEx(0, "pluginuir.uir", PANEL_Work, __CVIUserHInst);
		//return -1;
	//DisplayPanel (PH_Work); 
//	InstallPopup(PH_Work); 	
	SetCtrlAttribute (PH_Work, PANEL_Work_StreamRead_BTN, ATTR_DIMMED, 1);
	SetCtrlAttribute (PH_Work, PANEL_Work_WriteWord_BTN, ATTR_DIMMED, 1);
	SetCtrlAttribute (PH_Work, PANEL_Work_ReadWord_BTN, ATTR_DIMMED, 1);
	
	
		

 SetCtrlVal(PH_Work, PANEL_Work_Ports_STR, "Port1");
 		
 GetCtrlBoundingRect (PH_Work, PANEL_Work_DEC, &top, &left, &height, &width);    		
		
	  for(i=0; i<4; i++)
     decs[i]=DuplicateCtrl (PH_Work, PANEL_Work_DEC, PH_Work,"\0",top, left+i*120);  

		
	
	GetCtrlBoundingRect (PH_Work, PANEL_Work_L1, &top, &left, &height, &width); 
	
	
	for(i=0;i<32;i++) 
	{
	
	if((i>=0)&&(i<8))
	 m=0;
	 
	if((i>=8)&&(i<16))
	 m=120;
	
	 if((i>=16)&&(i<24))
	 m=240;
	
	if((i>=24)&&(i<32))
	 m=360;
	
	if(h==8)
	 h=0;
	
	strcpy(s[i],"IO");
	sprintf(tmp_str, "%d",32-i);   
	strncat(s[i],tmp_str,3);
	
	LinesIDs[31-i]=DuplicateCtrl (PH_Work, PANEL_Work_L1, PH_Work, s[i]/*char duplicateLabel[]*/, top+h*d, left+m);
	SetCtrlAttribute (PH_Work, LinesIDs[31-i], ATTR_VISIBLE, 1);
	
	//   :    . ....
	
	if(DIO_Descr[31-i].type==1)
	 {
	  SetCtrlAttribute (PH_Work, LinesIDs[31-i], ATTR_CTRL_MODE,  VAL_INDICATOR);
	 }
	else
	 {
	 SetCtrlAttribute (PH_Work, LinesIDs[31-i], ATTR_CTRL_MODE,  VAL_NORMAL); 
	 SetCtrlAttribute (PH_Work, LinesIDs[31-i], ATTR_OFF_COLOR , VAL_DK_YELLOW);
	 SetCtrlAttribute (PH_Work, LinesIDs[31-i], ATTR_ON_COLOR , VAL_YELLOW); 
	 
	  }
	  
	
	 h++;
	
	  } 
	  
	  
		  
    GetCtrlBoundingRect (PH_Work, PANEL_Work_HEX, &top, &left, &height, &width);    		
		
	 for(i=0; i<4; i++)
      HEX[i]=DuplicateCtrl (PH_Work, PANEL_Work_HEX, PH_Work,"HEX:",top, left+i*120);  
     
     
		SetCtrlAttribute (PH_Work, PANEL_Work_HEX, ATTR_VISIBLE, 0);
		
				

GetCtrlBoundingRect (PH_Work, PANEL_Work_Ports_STR, &top, &left, &height, &width); 
	
		
	 for(i=0; i<4; i++)
	  {
	  
	   sprintf(pn, "%d",4-i);   
	   strcpy(tmp_str,"");
	   strncat(tmp_str,pn,1);
	   
	   if(DIO_Descr[(3-i)*8].type==1)
	    strncat(tmp_str,", ",7);
	    
	   if(DIO_Descr[(3-i)*8].type==2)
	    strncat(tmp_str,", ",7); 
	    
	    
	   
       Ports[i]=DuplicateCtrl (PH_Work, PANEL_Work_Ports_STR, PH_Work,"\0",top, left+i*120); 
       
       SetCtrlVal(PH_Work, Ports[i], tmp_str);   
       
      }
     
		SetCtrlAttribute (PH_Work, PANEL_Work_Ports_STR, ATTR_VISIBLE, 0);
		
		
	//needOpen=1;	
		
   if(testPlolog(&theTCONTEXT)) 
     return 1;  
  
   SetCtrlVal (PH_Work, PANEL_Work_Serial_STR, hltr43.ModuleInfo.Serial);
   SetCtrlVal (PH_Work, PANEL_Work_Slot_NUM, hltr43.Channel.cc);   
  
  
   if(configHW(&theTCONTEXT, &hltr43)) 
   {
     closeModule();
     return 1;
   }; 
   
   
   SetCtrlVal (PH_Work, PANEL_Work_StreamFreq_NUM, hltr43.StreamReadRate);
   
   SetCtrlAttribute (PH_Work, PANEL_Work_StreamRead_BTN, ATTR_DIMMED, 0);
   SetCtrlAttribute (PH_Work, PANEL_Work_WriteWord_BTN, ATTR_DIMMED, 0);
   SetCtrlAttribute (PH_Work, PANEL_Work_ReadWord_BTN, ATTR_DIMMED, 0);
   
   SetCtrlAttribute (PH_Work, PANEL_Work_Status_TXT, ATTR_WRAP_MODE, VAL_LINE_WRAP); 
   
   ResetTextBox(PH_Work, PANEL_Work_Status_TXT, TimeStr());
   InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT,-1, ">     ");  
    
   InstallPopup(PH_Work); 	 		
		
//testPlolog  
	break;
		}
	return 0;
}


int CVICALLBACK ReadWord_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  int err;
  int LineVal;
  int i;
  
  DWORD ReceivedWord;
  

	switch (event)
		{
		case EVENT_COMMIT:
		
		
		err=LTR43_ReadPort(&hltr43, &ReceivedWord); 
		
		
		if(err)
		{
		   error_string=LTR43_GetErrorString(err); 
           if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
           ResetTextBox (PH_Work, PANEL_Work_Status_TXT, TimeStr()); 
           InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">       /!");   
           return 1;
         }
        else
         {
          ResetTextBox (PH_Work, PANEL_Work_Status_TXT, TimeStr());
          InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">     /  ");      
		
      	  }
		
		for(i=0;i<32;i++)
		 {
		 
		  LineVal=(ReceivedWord>>i)&0x1;
		  SetCtrlVal (PH_Work,LinesIDs[i], LineVal);
		  
		 }
		 
		 
		
		for(i=0;i<32;i+=8)
		 SetCtrlVal (PH_Work, HEX[3-i/8], (ReceivedWord>>i)&0xFF);   
		 
		
		
		

			break;
		}
	return 0;
}

int CVICALLBACK WriteWord_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{

  int LineVal;
  int i;
  int err=0;
  
  DWORD WordToWrite=0;

	switch (event)
		{
		case EVENT_COMMIT:
		
		//      
		
		for(i=0;i<32;i++)
		 {
		   GetCtrlVal (PH_Work, LinesIDs[i], &LineVal);
		   
		   //WordToWrite<<=1;
		   WordToWrite|=(LineVal<<i);
		   
		  } 
	 
		 for(i=0;i<32;i+=8)
		 SetCtrlVal (PH_Work, HEX[3-i/8], (WordToWrite>>i)&0xFF);  
		 
		 err=LTR43_WritePort(&hltr43, WordToWrite); 
		 
		 if(err)
		{
		   error_string=LTR43_GetErrorString(err); 
           if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
          ResetTextBox(PH_Work, PANEL_Work_Status_TXT, TimeStr());
          InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">       /!");        
           
           return 1;
         }
        else
        {			
          ResetTextBox(PH_Work, PANEL_Work_Status_TXT, TimeStr());
          InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT,-1, ">     /  ");      
        }   
		   
			break;
		}
	return 0;
}

int CVICALLBACK SecondMarksGo_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
    int err=0;
    
	switch (event)
		{
		case EVENT_COMMIT:
		
 err=LTR43_StartSecondMark(&hltr43);  
 
 if(err)
 {
  error_string=LTR43_GetErrorString(err); 
  if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string);
   ResetTextBox (PH_Work, PANEL_Work_Status_TXT, TimeStr());
   InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">      "); 
  
  return 1;
 }
 else
 {
   SecondMarksFlag=1;
   ResetTextBox (PH_Work, PANEL_Work_Status_TXT, TimeStr());
   InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">    "); 
 } 
 
		   

			break;
		}
	return 0;
}

int CVICALLBACK SecondMarksStop_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 int err=0;
 
	switch (event)
		{
		case EVENT_COMMIT:
		
	err=LTR43_StopSecondMark(&hltr43); 
	
	if(err)
	{
     error_string=LTR43_GetErrorString(err); 
     if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
     ResetTextBox (PH_Work, PANEL_Work_Status_TXT, TimeStr());
     InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">      "); 
     
    return 1;
    }	
   else
   {
   ResetTextBox (PH_Work, PANEL_Work_Status_TXT, TimeStr());
   InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">    "); 
    SecondMarksFlag=0; 
   } 
         
	
		

			break;
		}
	return 0;
}

int CVICALLBACK MakeStartMark_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 int err=0;
	switch (event)
		{
		case EVENT_COMMIT:
		
	err=LTR43_MakeStartMark(&hltr43);  
	
	if(err)
		{
		   error_string=LTR43_GetErrorString(err); 
           if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
            InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">     !");  
           return 1;
         }
   else
   {
   ResetTextBox (PH_Work, PANEL_Work_Status_TXT, TimeStr());
   InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">   "); 
   } 
         
	
	

			break;
		}
	return 0;
}



int CVICALLBACK StartMarksReset_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 int err=0;    
	switch (event)
		{
		case EVENT_COMMIT:
		
		//err=LTR43_ResetStartMarksCntr(&hltr43); 
		
		
		if(err)
		{
		   error_string=LTR43_GetErrorString(err); 
           if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
           return 1;
         }	 
         
     // SetCtrlVal (PH_Work, PANEL_Work_StartMarks_Cntr_NUM, hltr43.Marks.StartMarks_Qnt);  

			break;
		}
	return 0;
}

int CVICALLBACK SecondMarksReset_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 int err=0;
 
	switch (event)
		{
		case EVENT_COMMIT:
		
		
		
	//SetCtrlVal (PH_Work, PANEL_Work_SecondMarksReset_BTN, 1);   		
//	err=LTR43_ResetSecondMarksCntr(&hltr43); 
	
	//Sleep(1000);
	
	//SetCtrlVal (PH_Work, PANEL_Work_SecondMarksReset_BTN, 0);
	
	
	if(err)
		{
		   error_string=LTR43_GetErrorString(err); 
           if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
           return 1;
         }	 
         
      //SetCtrlVal (PH_Work, PANEL_Work_SecondMarks_Cntr_NUM, hltr43.Marks.SecondMarks_Qnt);       	

			break;
		}
	return 0;
}

int CVICALLBACK RS485_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  int InSize, OutSize;
  char ParityStrings[3][16]=
   {"",
    "",
    ""
    };
  
	switch (event)
		{
		case EVENT_COMMIT:
		
	PH_RS485 = LoadPanelEx(0, "pluginuir.uir", PANEL_RS, __CVIUserHInst);
		//return -1;
	//DisplayPanel (PH_Work); 						     
	InstallPopup(PH_RS485); 
	
	SetCtrlVal (PH_RS485, PANEL_RS_Baud_NUM, hltr43.RS485.Baud);
	SetCtrlVal (PH_RS485, PANEL_RS_StopBit_NUM, hltr43.RS485.StopBit+1); 
	SetCtrlVal (PH_RS485, PANEL_RS_FrameSize_NUM, hltr43.RS485.FrameSize); 
	SetCtrlVal (PH_RS485, PANEL_RS_Parity_STR, ParityStrings[hltr43.RS485.Parity]/*hltr43.RS485.FrameSize*/);    
	
//	SetCtrlVal (PH_RS485, PANEL_RS_Baud_NUM, hltr43.RS48.Bud); 
	
	GetCtrlVal (PH_RS485, PANEL_RS_OutSize_RNG, &OutSize);
	GetCtrlVal (PH_RS485, PANEL_RS_InSize_RNG, &InSize);
												  	   
	SetCtrlVal (PH_RS485, PANEL_RS_TrTimeOut_NUM, hltr43.RS485.SendTimeoutMultiplier*OutSize);   
	SetCtrlVal (PH_RS485, PANEL_RS_RcvTimeOut_NUM, hltr43.RS485.ReceiveTimeoutMultiplier*InSize);   
	
		

			break;
		}
	return 0;
}

int CVICALLBACK ExitRS485Work_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
		
		DiscardPanel(PH_RS485);	       

			break;
		}
	return 0;
}



int CVICALLBACK OutSize_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 int New_Size;
     
 
	switch (event)
		{
		case EVENT_VAL_CHANGED :
		
		GetCtrlVal (PH_RS485, PANEL_RS_OutSize_RNG, &New_Size);
	 	DeleteTableRows (PH_RS485, PANEL_RS_OutArray_TBL, 1, -1);    
		SetCtrlAttribute (PH_RS485, PANEL_RS_OutArray_TBL, ATTR_TABLE_MODE, VAL_COLUMN);
		SetTableColumnAttribute (PH_RS485, PANEL_RS_OutArray_TBL, 1,ATTR_DATA_TYPE, VAL_UNSIGNED_SHORT_INTEGER);
		SetTableColumnAttribute (PH_RS485, PANEL_RS_OutArray_TBL, 1, ATTR_FORMAT, VAL_HEX_FORMAT);	
		SetTableColumnAttribute (PH_RS485, PANEL_RS_OutArray_TBL, 1,ATTR_PADDING, 3); 	
		InsertTableRows (PH_RS485, PANEL_RS_OutArray_TBL, 1, New_Size, VAL_CELL_NUMERIC); 
		
		SetCtrlVal (PH_RS485, PANEL_RS_TrTimeOut_NUM, hltr43.RS485.SendTimeoutMultiplier*New_Size);  			 

			break;
		}
	return 0;
}

int CVICALLBACK InSize_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  int New_Size; 
  
  
	switch (event)
		{
		case EVENT_VAL_CHANGED :
		
		GetCtrlVal (PH_RS485, PANEL_RS_InSize_RNG, &New_Size);

	 
	SetCtrlVal (PH_RS485, PANEL_RS_RcvTimeOut_NUM, hltr43.RS485.ReceiveTimeoutMultiplier*New_Size);   	

			break;
		}
	return 0;
}

int CVICALLBACK RS485_Exchange_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 SHORT OutArray[10];
 SHORT InArray[10]; 
 
 int OutSize; 
 int InSize;   
 
 int err=0;
 
	switch (event)
		{
		case EVENT_COMMIT:
		
		
 GetCtrlVal (PH_RS485, PANEL_RS_OutSize_RNG, &OutSize);
 		
 GetTableCellRangeVals (PH_RS485, PANEL_RS_OutArray_TBL, MakeRect (1, 1, OutSize, 1), OutArray, VAL_COLUMN_MAJOR);
 
 
 
 
 
 
     GetCtrlVal (PH_RS485, PANEL_RS_InSize_RNG, &InSize);
        
     err=LTR43_RS485_Exchange(&hltr43, OutArray, InArray, OutSize, InSize);
        
     if(err)
	  {
		error_string=LTR43_GetErrorString(err); 
        if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
        ResetTextBox (PH_RS485, PANEL_RS_Status485_TXT, TimeStr()); 
        InsertTextBoxLine (PH_RS485, PANEL_RS_Status485_TXT, -1, ">       RS-485!");  
        
        return 1;
       }	
     else
      {			
       ResetTextBox(PH_RS485, PANEL_RS_Status485_TXT, TimeStr());
       InsertTextBoxLine (PH_RS485, PANEL_RS_Status485_TXT,-1, ">      RS-485");      
      }   
         
        
	 	DeleteTableRows (PH_RS485, PANEL_RS_InArray_TBL, 1, -1);    
		SetCtrlAttribute (PH_RS485, PANEL_RS_InArray_TBL, ATTR_TABLE_MODE, VAL_COLUMN);
		SetTableColumnAttribute (PH_RS485, PANEL_RS_InArray_TBL, 1,ATTR_DATA_TYPE, VAL_UNSIGNED_SHORT_INTEGER);
		SetTableColumnAttribute (PH_RS485, PANEL_RS_InArray_TBL, 1, ATTR_FORMAT, VAL_HEX_FORMAT);	
		SetTableColumnAttribute (PH_RS485, PANEL_RS_InArray_TBL, 1,ATTR_PADDING, 3); 	
		InsertTableRows (PH_RS485, PANEL_RS_InArray_TBL, 1, InSize, VAL_CELL_NUMERIC); 
 
 
 

       SetTableCellRangeVals (PH_RS485, PANEL_RS_InArray_TBL, MakeRect (1, 1, InSize, 1), InArray, VAL_COLUMN_MAJOR); 
 
 
 
 
		 //SetCtrlVal (PH_Work, PANEL_Work_SecondMarks_Cntr_NUM, hltr43.Marks.SecondMarks_Qnt);
		 //SetCtrlVal (PH_Work, PANEL_Work_StartMarks_Cntr_NUM, hltr43.Marks.StartMarks_Qnt); 	

			break;
		}
	return 0;
}

int CVICALLBACK Exit_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{

	switch (event)
		{
		case EVENT_COMMIT:
		
	     closeModule();	
	     
	     getCtrlVals();  
		 writeINI(); 
		    DiscardPanel(Pnl);
		    Pnl= -1;
		 
		 

			break;
		}
	return 0;
}

int CVICALLBACK StreamRead_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  int err=0;
  DWORD TmpDWord; 

  
	switch (event)
		{
		case EVENT_COMMIT:
		

 GetCtrlVal (PH_Work, PANEL_Work_PointsQnt_NUM, &PointsQnt);
 		

 
 


 //GetCtrlVal (PH_Work, PANEL_Work_StreamFreq_RNG, &Freq);
 SetCtrlAttribute (PH_Work, PANEL_Work_Stream_LED, ATTR_ON_COLOR,
				   VAL_GREEN);
 
 
		
		
 StopStreamRead_Flag=0;
		
 err=LTR43_StartStreamRead(&hltr43);   
 
 if(err)
  {
    error_string=LTR43_GetErrorString(err); 
    if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string);
    ResetTextBox (PH_Work, PANEL_Work_Status_TXT, TimeStr()); 
    InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">        /!");  
    return 1;
   }	 
  else
   {			
     ResetTextBox(PH_Work, PANEL_Work_Status_TXT, TimeStr());
     InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT,-1, "   ");      
   }   
		   
         
SetCtrlAttribute (PH_Work, PANEL_Work_ExitWork_BTN, ATTR_DIMMED, 1);            
SetCtrlAttribute (PH_Work, PANEL_Work_ReadWord_BTN, ATTR_DIMMED, 1);
SetCtrlAttribute (PH_Work, PANEL_Work_WriteWord_BTN, ATTR_DIMMED, 1);   
SetCtrlAttribute (PH_Work, PANEL_Work_MakeStartMark_BTN, ATTR_DIMMED,1);
SetCtrlAttribute (PH_Work, PANEL_Work_SecondMarksStop_BTN,ATTR_DIMMED, 1);
SetCtrlAttribute (PH_Work, PANEL_Work_SecondMarksGo_BTN, ATTR_DIMMED,1);
SetCtrlAttribute (PH_Work, PANEL_Work_RS485_BTN, ATTR_DIMMED, 1);
SetCtrlAttribute (PH_Work, PANEL_Work_StreamRead_BTN, ATTR_DIMMED, 1);   



 
ReadThread=CreateThread(NULL,0, (LPTHREAD_START_ROUTINE) StreamRead_Func, NULL, CREATE_SUSPENDED,(LPDWORD)&TmpDWord);

ResumeThread(ReadThread);


while(!StopStreamRead_Flag)
 ProcessSystemEvents();

Sleep(200);

CloseHandle(ReadThread);  

err=LTR43_StopStreamRead(&hltr43); 

SetCtrlAttribute (PH_Work, PANEL_Work_ReadWord_BTN, ATTR_DIMMED, 0);
SetCtrlAttribute (PH_Work, PANEL_Work_WriteWord_BTN, ATTR_DIMMED, 0);  
SetCtrlAttribute (PH_Work, PANEL_Work_ExitWork_BTN, ATTR_DIMMED, 0); 
SetCtrlAttribute (PH_Work, PANEL_Work_MakeStartMark_BTN, ATTR_DIMMED,0);
SetCtrlAttribute (PH_Work, PANEL_Work_SecondMarksStop_BTN,ATTR_DIMMED, 0);
SetCtrlAttribute (PH_Work, PANEL_Work_SecondMarksGo_BTN, ATTR_DIMMED,0);
SetCtrlAttribute (PH_Work, PANEL_Work_RS485_BTN, ATTR_DIMMED, 0); 
SetCtrlAttribute (PH_Work, PANEL_Work_StreamRead_BTN, ATTR_DIMMED, 0); 

if(err)
 {
   error_string=LTR43_GetErrorString(err); 
   if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
   ResetTextBox (PH_Work, PANEL_Work_Status_TXT, TimeStr()); 
   InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT, -1, ">        /!");  
   
   return 1;
  }	 
  else
   {			
     ResetTextBox(PH_Work, PANEL_Work_Status_TXT, TimeStr());
     InsertTextBoxLine (PH_Work, PANEL_Work_Status_TXT,-1, "   ");      
   }   
  


 

			break;
		}
	return 0;
}

 
 

int CVICALLBACK StreamReadStop_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
		
		
		StreamRead_Flag=0;

			break;
		}
	return 0;
}

int CVICALLBACK Close (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
		
		 DiscardPanel(PH_Work);	  

			break;
		}
	return 0;
}

int CVICALLBACK CloseAll (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
		
		  closeModule();	
	     
	     getCtrlVals();  
		 writeINI(); 
		    DiscardPanel(Pnl);
		    Pnl= -1;
		 
	

			break;
		}
	return 0;
}

int CVICALLBACK Array_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
DWORD OutArray[255];
 int i;
 int err;
 
	switch (event)
		{
		case EVENT_COMMIT:
		
		
	for(i=0;i<64;i++)
	 OutArray[i]=0x0;
	 
	for(i=64;i<128;i++)
	 OutArray[i]=0xFFFF;
	
	 
	for(i=128;i<192;i++)
	 OutArray[i]=0x0;
	 
	 
	for(i=192;i<255;i++)
	 OutArray[i]=0xFFFF;
	
	// StopArrayFlag=0;
	 

	// SetCtrlAttribute (PH_Work, PANEL_Work_Array_LED, ATTR_OFF_COLOR , VAL_DK_GREEN);
	 //SetCtrlAttribute (PH_Work, PANEL_Work_Array_LED, ATTR_ON_COLOR , VAL_GREEN); 
	 
	 
	/* while(!StopArrayFlag)
	 {  */
	 
	 i++;
	 
	err=LTR43_WriteArray(&hltr43, OutArray, 255); 
	
	
			break;
		}
	return 0;
}
