#include <windows.h>
#include <ansi_c.h>
#include <userint.h>
//#include "te01api.h"
//#include "pluginuir.h"
#include "pluginuir.h"  
//#include "tfuncdef.h"
#include "localdefs.h"

#include <analysis.h>

#include <windows.h>
#include <ansi_c.h>
#include <userint.h>
#include "uts\\instruments\\te01\\te01api.h"
#include "pluginuir.h"
#include "UTS\\systems\\common\\include\\tfuncdef.h"
#include "localdefs.h"
#include "UTS\\systems\\common\\include\\plugindef.h"
#include "UTS\\systems\\ltr\\common\\include\\ltrspecific.h"
#include "C:\\prj\\UTS\\services\\common\\include\\servicedef.h"
#include "ltr\\include\\ltr51api.h"     

#include <analysis.h>




//double Thresholds[16][2];

LPCSTR error_string; 
static int PH_Work;
static int PH_Conf;  

static int Pnl= -1;
static int Pnl_Work= -1; 
//static int TePnl= -1;
#define P(x)  CONF_##x
#define PW(x)  WORK_##x  
#define MAX_CHANNEL (16)
#define FS (500000.0)

#define BASE  (5000)


extern TLTR51 hltr51;
  
/*extern*/ TLTR channel;

static TE01 *theTE01;
static char thePATH[FNAMELEN+1];


int EnaPhysCh_Qnt=0;
int CurrentChannel=0;
int CurrentIndex=0;


 int Channel_Ctrls[MAX_CHANNEL];
 int Frequency_Ctrls[MAX_CHANNEL];
 int HighThreshold_Ctrls[MAX_CHANNEL];
 int LowThreshold_Ctrls[MAX_CHANNEL];  
 int Period_Ctrls[MAX_CHANNEL];
 int ImpCtrls[MAX_CHANNEL];  
 
 int BlockReady[2];



//***********************************************************************************************************


void closeUIR(void) {
  if(Pnl!= -1)   { DiscardPanel(Pnl);   Pnl= -1;   };
  //if(TePnl!= -1) { DiscardPanel(TePnl); TePnl= -1; };  
};

//**********************************************************************************************************

int utspConfigTest(TCONTEXT *tc, void *p) {  return 0; };
int utspVirtualDevice(TCONTEXT *tc, void *p) { return 0; };
extern int testPlolog(TCONTEXT *tc); 

extern void closeModule(void);
static double eval_Fref(WORD Fs);             //    
static double eval_Fbase(double Fs, WORD Base);  //    
static double eval_correct_threshold(double Voltage, int Range); //      
static double eval_Tw(WORD Fs, WORD Base, int TpQnt); 
static int calcTimeOutMs(void); 
static int numOfLChan(void);   

#pragma pack(1)


 // ,     ,     
  
typedef struct
 {
  double Fs;    //   
  WORD Base;  //     
  int AcqTime; //  
  int SamplesQnt;
  int LChQnt; //   
  int EdgeMode;

 } IniSet_common; 



 // ,          
 typedef struct 
 {
 
  int  onoff;           //     
  double  HighThreshold; //  
  double  LowThreshold;  //  
  int ThresholdRange;    //    (    .  )
  int EdgeMode;          //       
  
  } IniSet_chan;
  
  
 // ,          
typedef struct 
 {
  int point;  // -  
  int ppoint;  // - process points        

  IniSet_common common; //    
  IniSet_chan  chan[MAX_CHANNEL];//     (, ...)
  
 } IniSet_XXX;  
  
  
#pragma pack()


static IniSet_XXX IniSet;

static char theDIR[FNAMELEN+1], theMDESCR[COMMENTLEN+1];  


  char SubModuleList[16][50]=
                                 {
                                  " 1,  1",
                                  " 1,  2",
                                  " 2,  1",
                                  " 2,  2",
                                  " 3,  1",
                                  " 3,  2",
                                  " 4,  1",
                                  " 4,  2",
                                  " 5,  1",
                                  " 5,  2",
                                  " 6,  1",
                                  " 6,  2",
                                  " 7,  1",
                                  " 7,  2",
                                  " 8,  1",
                                  " 8,  2",
                                 }; 


//*************************************************************************************

static void writeINI(void) {                           
  FILE *f;                                             
  char fname[FNAMELEN+1];                              
  sprintf(fname, "%s\\%s", theDIR, theMDESCR);         
  if((f= fopen(fname, "wb")) == NULL) return;          
  fwrite (&IniSet, sizeof(IniSet_XXX), 1, f);           
  fclose(f);                                           
};                                                     
                                                       
//**************************************************************************************
 //     
static void fillINI(void) 
{  //   UIR- 
 int j;


 memset(&IniSet, 0x0, sizeof(IniSet_XXX));
 
 IniSet.point=1000;
 
 IniSet.common.AcqTime=1000;
 IniSet.common.Fs=FS;
 IniSet.point=(int)  ((IniSet.common.AcqTime*FS)/(1000*BASE));
 IniSet.common.Base=BASE; 
 IniSet.common.EdgeMode=0; 
 IniSet.common.LChQnt=16;


 for(j=0;j<16;j++)
  {
  IniSet.chan[j].HighThreshold=0.8;
  IniSet.chan[j].LowThreshold=-0.8; 
  IniSet.chan[j].ThresholdRange=1;
  IniSet.chan[j].EdgeMode=0;   
  IniSet.chan[j].onoff=1;
 
  }
};

//#define INIFNAME "inifile.ini"

/*************************************************************************************************

       
  
**************************************************************************************************/  

static void readINI(char *xdir, char *mdescr) {
  FILE *f;
  char fname[FNAMELEN+1];
  strcpy(theDIR, xdir);
  strcpy(theMDESCR, mdescr);  
  fillINI();
  sprintf(fname, "%s\\%s", theDIR, theMDESCR);
  if((f= fopen(fname, "rb")) == NULL) return;
  fread (&IniSet, sizeof(IniSet_XXX), 1, f);
  fclose(f);
};


/*************************************************************************************************

       .   
  
**************************************************************************************************/  


// -------------------------------------------------------------------------------------
static void showINI(void)
{
 int  i; 
 int j=0;
 WORD PhysChannelMask;
 double Fref, Fbase, Tw; //  
 char tmpstr[255];
 
SetCtrlVal(Pnl, P(Fs_NUM), IniSet.common.Fs);       
SetCtrlVal(Pnl, P(Base_NUM), IniSet.common.Base);  
SetCtrlVal(Pnl, P(EdgeMode_RNG), IniSet.common.EdgeMode);
SetCtrlVal(Pnl, P(PointsQnt_NUM), IniSet.point);   
SetCtrlVal(Pnl, P(AcqTime_NUM), IniSet.common.AcqTime);



PhysChannelMask=hltr51.ChannelsEna;  

	for(i=0;i<16;i++)
	 {
	  // ,  .  ,     
	  if((hltr51.ChannelsEna>>i)&0x1)
	  {
	   InsertListItem (Pnl, P(Channels_LST), -1, SubModuleList[i], i);
	   
	   
	   if(j==0)
	   {
		SetCtrlVal (Pnl, P(HighThreshold_NUM), IniSet.chan[i].HighThreshold);
		SetCtrlVal (Pnl, P(LowThreshold_NUM), IniSet.chan[i].LowThreshold); 
		SetCtrlVal (Pnl, P(ThresholdRange_SW), IniSet.chan[i].ThresholdRange); 
		SetCtrlVal (Pnl, P(EdgeMode_RNG), IniSet.chan[i].EdgeMode);  
		
		Fref=eval_Fref(IniSet.common.Fs);
		//SetCtrlVal (Pnl, P(FreqS_NUM), Fref); 
		
		Fbase=eval_Fbase(IniSet.common.Fs, IniSet.common.Base);
		SetCtrlVal (Pnl, P(FreqBase_NUM), Fbase); 
	/*	
		Tw=eval_Tw(IniSet.common.Fs, IniSet.common.Base, IniSet.point);
		SetCtrlVal (Pnl, P(AcqTime_NUM), Tw);  */
		
		
		
	 sprintf(tmpstr," .  : %d", j+1);
	 ResetTextBox(Pnl, P(ChanInfo_TBX), tmpstr);
	 
	 
	 sprintf(tmpstr,"  : %f ", IniSet.chan[j].HighThreshold);
	 InsertTextBoxLine(Pnl, P(ChanInfo_TBX), -1, tmpstr);
	 
	 sprintf(tmpstr,"  : %f ", IniSet.chan[j].LowThreshold); 
	 InsertTextBoxLine (Pnl, P(ChanInfo_TBX), -1, tmpstr);

     if(IniSet.chan[j].ThresholdRange)
	   sprintf(tmpstr,"  :\n    -1,224 ... +1.214 "); 
	 else  
	   sprintf(tmpstr,"  :\n    -10.19 ... +10,11 "); 
	   
	  InsertTextBoxLine (Pnl, P(ChanInfo_TBX), -1, tmpstr);  
	  
	 if(IniSet.chan[j].EdgeMode)       
	   sprintf(tmpstr," . . :\n    "); 
	 else 
	   sprintf(tmpstr," . . :\n    "); 
	   
	 InsertTextBoxLine (Pnl, P(ChanInfo_TBX), -1, tmpstr); 
		
	}
	   
	    //    ,     
	 if(IniSet.chan[i].onoff)
	 {
	    CheckListItem (Pnl, P(Channels_LST), j, 1);
	  }
	   
	   j++;
	 } //  if(ChannelsEna>>i... )
	  
	  EnaPhysCh_Qnt=j;

	}   //  for(i..)

	   //   ,   
	   
	 SetCtrlVal (Pnl, P(Serial_STR), hltr51.ModuleInfo.Serial);       

};  



/********************************************************************************

     .    
 
*********************************************************************************/ 


static void copyIni2Ltr51Struc(TLTR51 *hltr51)
{
 int i, j, k;
 int LChQnt=0;
 int channel=0;
 int Range=0;
 int checked;
 int ChannelsQnt;
 int ActChannelsQnt;
 
 //hltr51->Fs=IniSet.common.Fs;
 //hltr51->Base=IniSet.common.Base;
 hltr51->SetUserPars=0;
 hltr51->AcqTime=IniSet.common.AcqTime;

 	 //        
	GetNumListItems (Pnl, P(Channels_LST), &ChannelsQnt);

	//      
    GetNumCheckedItems (Pnl, P(Channels_LST), &ActChannelsQnt);	
	
	//      -  
    hltr51->LChQnt=ActChannelsQnt;
    
	j=0;	
	for(i=0;i<ChannelsQnt;i++)
	{
	 
	 IsListItemChecked (Pnl, P(Channels_LST), i, &checked);
	 
	 if(checked)
	 {
	  
	  GetValueFromIndex (Pnl, P(Channels_LST), i, &channel);
	  
	  hltr51->LChTbl[j]=LTR51_CreateLChannel(channel+1, &IniSet.chan[channel].HighThreshold, &IniSet.chan[channel].LowThreshold, IniSet.chan[channel].ThresholdRange, IniSet.chan[channel].EdgeMode);
	  
	  j++; 
	 }
	 
	} 
	
	  /*hltr51->LChTbl[0]=LTR51_CreateLChannel(5, &IniSet.chan[0].HighThreshold, &IniSet.chan[0].LowThreshold, IniSet.chan[0].ThresholdRange, IniSet.chan[0].EdgeMode);    
	  hltr51->LChTbl[1]=LTR51_CreateLChannel(1, &IniSet.chan[0].HighThreshold, &IniSet.chan[0].LowThreshold, IniSet.chan[0].ThresholdRange, IniSet.chan[0].EdgeMode); 
	  hltr51->LChTbl[2]=LTR51_CreateLChannel(9, &IniSet.chan[0].HighThreshold, &IniSet.chan[0].LowThreshold, IniSet.chan[0].ThresholdRange, IniSet.chan[0].EdgeMode); 
	  hltr51->LChTbl[3]=LTR51_CreateLChannel(15, &IniSet.chan[0].HighThreshold, &IniSet.chan[0].LowThreshold, IniSet.chan[0].ThresholdRange, IniSet.chan[0].EdgeMode); 
	   */
	
};

// -------------------------------------------------------------------------------------

static TCONTEXT theTCONTEXT;

/*************************************************************

        
 
**************************************************************/  

int utspConfigDevice(TCONTEXT *tc, void *q) 

{
  char ppath[FNAMELEN+1];
  WORD PhysChannelMask;
  int rs;
  
  memcpy(&theTCONTEXT, tc, sizeof(TCONTEXT));
  
  readINI(tc->dllpath, tc->mdescr);
  sprintf(ppath, "%s\\%s", tc->dllpath, "pluginuir.uir");
  strcpy(thePATH, ppath);
  
  
  Pnl= LoadPanelEx (0, ppath, WAIT, __CVIUserHInst);
  SetCtrlVal (Pnl, WAIT_TEXTMSG, "    ...");
  
  
  InstallPopup(Pnl);  
  
  //   
  rs=testPlolog(tc);
  
  DiscardPanel(Pnl);
  Pnl= -1;		    
  
  if(!rs) 
  {
	
  INT res;
		
  Pnl= LoadPanelEx (0, ppath, CONF, __CVIUserHInst); // ppath - , ,   uir!!! 
  Pnl_Work= LoadPanelEx (0, ppath, WORK, __CVIUserHInst);
 
  
  PhysChannelMask=hltr51.ChannelsEna;
  
  showINI();  
  

  
  InstallPopup(Pnl);

  return 0;
  }
  
  return 1;
};


/*************************************************************************************************

       (=  )
  
**************************************************************************************************/  


static int numOfLChan(void) 
 {
 int n= 0, j;
  
 GetNumCheckedItems (Pnl, P(Channels_LST), &n);

 return n; 

 };

/****************************************************************************************************

              
  
****************************************************************************************************/  



static int getCtrlVals(void) 
 {
   int j;
   int ChQnt;
   int ChNum;
   int checked;
   
   GetCtrlVal(Pnl, P(Fs_NUM), &IniSet.common.Fs);
   GetCtrlVal(Pnl, P(Base_NUM), &IniSet.common.Base);
   GetCtrlVal (Pnl,P(EdgeMode_RNG), &IniSet.common.EdgeMode);
   GetCtrlVal (Pnl,P(PointsQnt_NUM), &IniSet.point);
   GetCtrlVal (Pnl,P(AcqTime_NUM), &IniSet.common.AcqTime);  
   
   
   
   GetNumListItems (Pnl, P(Channels_LST), &ChQnt);


   for(j=0;j<ChQnt;j++)
    {
     IsListItemChecked (Pnl, P(Channels_LST), j, &checked);
     GetValueFromIndex (Pnl, P(Channels_LST), j, &ChNum);
     IniSet.chan[ChNum].onoff=checked;
    } 
			
 			return 0;
};



int CVICALLBACK mf_apply (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) 
		{
/*int j;

	switch (event) {
		case EVENT_COMMIT:
		    getCtrlVals();
		
 			
		    writeINI(); 
		    DiscardPanel(Pnl);
		    Pnl= -1;		    
		break;
	}
	return 0;  */
	return 0;
};			   




/******************************        *****************************************/


static HANDLE hThread;
static int (*dataUpdateCBF)(int nchan, serviceStrucData X[], char *info)= NULL;
static UINT32 rd_buf[MAXNPOINTS * MAX_CHANNEL];
static DWORD MNs[2][MAXNPOINTS * MAX_CHANNEL];
double freq[MAX_CHANNEL]; 
static double rd_buf_double[MAXNPOINTS * MAX_CHANNEL];
static serviceStrucData serviceDATA[MAX_CHANNEL];

static int runFlag;
static int CalibrFlag=0; 



//int calcTimeOutMs(void);

static void DataRecorder(void *par) 
{
 int cnt, i, j, r, p;
 double FreqUnits[2]={1, 0.001};
 double PeriodUnits[3]={1, 1000.0, 1E+6};
 int Unit;
 int k=0;
 int n=  numOfLChan();//, to= calcTimeOutMs(), xp, xp2;
 char tmp[512];
 //double freq[MAX_CHANNEL];
 DWORD tmp_src[5];
 int err;
 LPCSTR error_string;
 DWORD to;
 int tick1, tick2, tick_tak[25];
 int tt=0;
 int data_size;
 
// FILE *f;    
 
 INT BlockCntr=0; 
 
  for(i=0;i<2;i++)
    BlockReady[i]=0;
 
 // f = fopen("data.txt", "w");     
 
 
 to=IniSet.common.AcqTime+1000;
 
 while(runFlag) 
 { 
   
   tick1=GetTickCount();
   //cnt= LTR51_Recv(&hltr51, rd_buf, NULL, 32*IniSet.point, to);
   
   cnt= LTR_Recv(&(hltr51.Channel), rd_buf, NULL, 32*IniSet.point, to); 
   tick2=GetTickCount();  
   
   if(tt<20)
   {
    tt++;
    tick_tak[tt]=tick2-tick1;
   } 
    
   

   if(cnt<= 0) 
   {
        
    MessagePopup(MSG_ERROR, "Samples are not received!!!");  
    runFlag=0;
    goto __skip_processing;
   }
   else 
   {
    if(cnt != 32*IniSet.point) 
     {
      MessagePopup(MSG_ERROR, "Less samples received, than it was purchased");  
      runFlag=0;
      goto __skip_processing;  
     }
   }
   
   data_size=32*IniSet.point;
   r= LTR51_ProcessData(&hltr51, rd_buf, MNs[BlockCntr], freq, &data_size); 

   if(r) 
   {
    
    error_string=LTR51_GetErrorString(r);
    MessagePopup(MSG_ERROR, error_string);   
    
    runFlag=0;
    goto __skip_processing;
    
   }//__skip_processing;}  
   
  /*fprintf(f,"\nFrequency: %f\n", freq[0]);  
  
  for(i=0; i<IniSet.point; i++)
    fprintf(f, "Point %d: N=%d,  M=%d\n", i, (MNs[BlockCntr][16*i]&0xFFFF0000)>>16, MNs[BlockCntr][16*i]&0xFFFF);  
     */ 
   
  BlockReady[BlockCntr]=1;
  
   BlockCntr++;
   if(BlockCntr>=2)
     BlockCntr=0;

  GetCtrlVal (Pnl_Work, PW(FreqUnit_RNG), &Unit);   

  for(i=0;i<hltr51.LChQnt;i++)
   SetCtrlVal (Pnl_Work, Frequency_Ctrls[i], freq[i]*FreqUnits[Unit]); 
   
  GetCtrlVal (Pnl_Work, PW(PeriodUnit_RNG), &Unit);     
   
  for(i=0;i<hltr51.LChQnt;i++)
   SetCtrlVal (Pnl_Work, Period_Ctrls[i], PeriodUnits[Unit]*(1/freq[i]));  
    
   
    k++;
	SetCtrlVal (Pnl_Work, PW(Process_LED), (int) k%2);
  
   }; //  while(runFlag)   

__skip_processing:

__end_acq:

    
  runFlag= 0;


// fclose(f);
 
 ExitThread(0);
 
};



int configHW(TCONTEXT *tc, TLTR51 *hltr51)
{
 int j, k;
 LPCSTR error_string;
 
 
 readINI(tc->dllpath, tc->mdescr);
 copyIni2Ltr51Struc(hltr51);
  
 return 0;
};

 
int utspStart(TCONTEXT *tc, void *p) 

 {
  DWORD TmpDWord;
  plugStartStruc *X;

  X= (plugStartStruc *)p;
  if(testPlolog(tc)) return 1;  // !!! ??? tmp
  
  

  dataUpdateCBF= X->coreCBF; // (dataUpdateCBF_FPtr)p;
  if(LTR51_Start(&hltr51)) 
   {
     closeModule();
     return 1;  
   }

  runFlag= 1;
  hThread= CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)DataRecorder, 
                        NULL, CREATE_SUSPENDED, (LPDWORD)&TmpDWord);

  ResumeThread(hThread);        // start thread here
  
  return 0;
};

int utspStop(TCONTEXT *tc, void *p) 
 {
  int j;
  int c;
  int err;

  runFlag= 0;
  WaitForMultipleObjects(1, &hThread, TRUE, INFINITE);
  CloseHandle(hThread);
  
  
  if(err=LTR51_Stop(&hltr51)) 
  {
  
  error_string=LTR51_GetErrorString(err);         
  if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string);               
  
     closeModule();
     return 1;    
  };
  
  closeModule();  
   
  return 0;
};

// *******************************************************************************

// -------------------------------------------------------------
static int showWPanel(int ppnl, char *msg)
{
  
 /* int p= LoadPanelEx(ppnl, thePATH, WP, __CVIUserHInst);  
  if(msg!= NULL) {  
    // ... 
  };
  InstallPopup(p); 
  return p;  */
  
  return 0;
};
// -------------------------------------------------------------
static void hideWPanel(int p) {
 DiscardPanel(p);
};
// -------------------------------------------------------------
int utspConfigTe01Ext(TCONTEXT *tc, void *p) {
  return 0;
};

// -------------------------------------------------------------
// -------------------------------------------------------------

// ****************************************************************************
int utspVerifyModule(TCONTEXT *tc) {
 //jumpToCalibrPanel(tc);
 return 0;
};


int CVICALLBACK ExitWork_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 int err=0;
	switch (event)
		{
		case EVENT_COMMIT:
		
		
		 //HidePanel (Pnl_Work);
		DiscardPanel(Pnl_Work);	
		
		
			break;
		}
	return 0;
}


int CVICALLBACK Exit_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 int err=0;
	switch (event)
		{
		case EVENT_COMMIT:
		
	     closeModule();	
	     
	     getCtrlVals();  
		 writeINI(); 
		    DiscardPanel(Pnl);
		    Pnl= -1;
		 
			break;
		}
	return 0;
}


/**********************************************************************
  
         
   
**********************************************************************/   

int CVICALLBACK ClickChannel_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{  
 int checked;
 char tmpstr[255];
 
	switch (event)
		{
		case EVENT_VAL_CHANGED: 
		
  GetCtrlVal (Pnl, P(Channels_LST), &CurrentChannel);
  GetCtrlIndex (Pnl, P(Channels_LST), &CurrentIndex);

  SetCtrlVal (Pnl, P(HighThreshold_NUM), IniSet.chan[CurrentChannel].HighThreshold);  
  SetCtrlVal (Pnl, P(LowThreshold_NUM), IniSet.chan[CurrentChannel].LowThreshold);
  
  SetCtrlVal (Pnl, P(ThresholdRange_SW), IniSet.chan[CurrentChannel].ThresholdRange); 
  SetCtrlVal (Pnl, P(EdgeMode_RNG), IniSet.chan[CurrentChannel].EdgeMode);    
  
 
  IsListItemChecked (Pnl, P(Channels_LST), CurrentIndex, &checked);
  IniSet.chan[CurrentChannel].onoff=checked;
	 
  sprintf(tmpstr," .  : %d", CurrentChannel+1);
  ResetTextBox(Pnl, P(ChanInfo_TBX), tmpstr);
	 
	 
  sprintf(tmpstr,"  : %f ", IniSet.chan[CurrentChannel].HighThreshold);
  InsertTextBoxLine(Pnl, P(ChanInfo_TBX), -1, tmpstr);
	 
  sprintf(tmpstr,"  : %f ", IniSet.chan[CurrentChannel].LowThreshold); 
  InsertTextBoxLine (Pnl, P(ChanInfo_TBX), -1, tmpstr);

  if(IniSet.chan[CurrentChannel].ThresholdRange)
	sprintf(tmpstr,"  :\n    -1,224 ... +1.214 "); 
  else  
	sprintf(tmpstr,"  :\n    -10.19 ... +10,11 "); 
	   
  InsertTextBoxLine (Pnl, P(ChanInfo_TBX), -1, tmpstr);   
	  
  if(IniSet.chan[CurrentChannel].EdgeMode)       
	sprintf(tmpstr," . . :\n    "); 
  else 
	sprintf(tmpstr," . . :\n    "); 
	   
  InsertTextBoxLine (Pnl, P(ChanInfo_TBX), -1, tmpstr);    
  
	break;
	}
	return 0;
 }


/**********************************************************************
  
        
   
**********************************************************************/

int CVICALLBACK SetHighThreshold (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 double HighThresholdVoltage, LowThresholdVoltage;
 int PhysChanNum;
 int Range;
 int i;
 int AllChannels_Flag=0;
 int EdgeMode=0;
 char tmpstr[255];  
 
	switch (event)
		{
		case EVENT_VAL_CHANGED:
		
		GetCtrlVal(Pnl, P(HighThreshold_NUM), &HighThresholdVoltage);
		GetCtrlVal(Pnl, P(LowThreshold_NUM), &LowThresholdVoltage);       
		
		GetCtrlVal(Pnl, P(ThresholdRange_SW), &Range); 
		GetCtrlVal(Pnl, P(AllChannels_CHK), &AllChannels_Flag);  
	
		GetCtrlVal(Pnl, P(EdgeMode_RNG), &EdgeMode);
		
		
		HighThresholdVoltage=eval_correct_threshold(HighThresholdVoltage, Range);
		LowThresholdVoltage=eval_correct_threshold(LowThresholdVoltage, Range); 
		
		/*if(LowThresholdVoltage>=HighThresholdVoltage)
		 {
		  MessagePopup ("!", "       !" );
		  break;
		 }   */
		
		if(AllChannels_Flag)
		 {
		  for(i=0;i<16;i++)
		  {
		   IniSet.chan[i].HighThreshold=HighThresholdVoltage;
		   IniSet.chan[i].LowThreshold=LowThresholdVoltage;
		   IniSet.chan[i].ThresholdRange=Range;  
		   IniSet.chan[i].EdgeMode=EdgeMode;  
		   
		  }
		 } 
		else  
		 {
		  IniSet.chan[CurrentChannel].HighThreshold=HighThresholdVoltage;
		  IniSet.chan[CurrentChannel].LowThreshold=LowThresholdVoltage;   
		  IniSet.chan[CurrentChannel].ThresholdRange=Range; 
		  IniSet.chan[CurrentChannel].EdgeMode=EdgeMode;  
		 } 
		
		SetCtrlVal(Pnl, P(HighThreshold_NUM), HighThresholdVoltage);
		SetCtrlVal(Pnl, P(LowThreshold_NUM), LowThresholdVoltage);     
		
		
  sprintf(tmpstr," .  : %d", CurrentChannel+1);
  ResetTextBox(Pnl, P(ChanInfo_TBX), tmpstr);
	 
	 
  sprintf(tmpstr,"  : %f ", IniSet.chan[CurrentChannel].HighThreshold);
  InsertTextBoxLine(Pnl, P(ChanInfo_TBX), -1, tmpstr);
	 
  sprintf(tmpstr,"  : %f ", IniSet.chan[CurrentChannel].LowThreshold); 
  InsertTextBoxLine (Pnl, P(ChanInfo_TBX), -1, tmpstr);

  if(IniSet.chan[CurrentChannel].ThresholdRange)
	sprintf(tmpstr,"  :\n    -1,224 ... +1.214 "); 
  else  
	sprintf(tmpstr,"  :\n    -10.19 ... +10,11 "); 
	   
  InsertTextBoxLine (Pnl, P(ChanInfo_TBX), -1, tmpstr);   
	  
  if(IniSet.chan[CurrentChannel].EdgeMode)       
	sprintf(tmpstr," . . :\n    "); 
  else 
	sprintf(tmpstr," . . :\n    "); 
	   
  InsertTextBoxLine (Pnl, P(ChanInfo_TBX), -1, tmpstr);    
		
		
		
			break;
			
			
		}
	return 0;
}

/**********************************************************************
  
        
   
**********************************************************************/

int CVICALLBACK SetLowThreshold (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 double HighThresholdVoltage, LowThresholdVoltage;
 int i;
 int PhysChanNum;
 int Range;
 int AllChannels_Flag=0;  
  char tmpstr[255]; 
 
	switch (event)
		{
		case EVENT_COMMIT:
	
		GetCtrlVal(Pnl, P(HighThreshold_NUM), &HighThresholdVoltage);
		GetCtrlVal(Pnl, P(LowThreshold_NUM), &LowThresholdVoltage);       
		
		GetCtrlVal(Pnl, P(ThresholdRange_SW), &Range); 
		GetCtrlVal(Pnl, P(AllChannels_CHK), &AllChannels_Flag);  
		
		HighThresholdVoltage=eval_correct_threshold(HighThresholdVoltage, Range);
		LowThresholdVoltage=eval_correct_threshold(LowThresholdVoltage, Range);
		
	/*	if(LowThresholdVoltage>=HighThresholdVoltage)
		 {
		  MessagePopup ("!", "       !" );
		  break;
		 }	   */
		 
		
		if(AllChannels_Flag)
		 {
		  for(i=0;i<16;i++)
		  {
		   IniSet.chan[i].HighThreshold=HighThresholdVoltage;
		   IniSet.chan[i].LowThreshold=LowThresholdVoltage;
		   IniSet.chan[i].ThresholdRange=Range;   
		   
		  }
		 } 
		else  
		 {
		  IniSet.chan[CurrentChannel].HighThreshold=HighThresholdVoltage;
		  IniSet.chan[CurrentChannel].LowThreshold=LowThresholdVoltage;   
		  IniSet.chan[CurrentChannel].ThresholdRange=Range; 
		 } 
		
		SetCtrlVal(Pnl, P(HighThreshold_NUM), HighThresholdVoltage);
		SetCtrlVal(Pnl, P(LowThreshold_NUM), LowThresholdVoltage);    
		
		
  sprintf(tmpstr," .  : %d", CurrentChannel+1);
  ResetTextBox(Pnl, P(ChanInfo_TBX), tmpstr);
	 
	 
  sprintf(tmpstr,"  : %f ", IniSet.chan[CurrentChannel].HighThreshold);
  InsertTextBoxLine(Pnl, P(ChanInfo_TBX), -1, tmpstr);
	 
  sprintf(tmpstr,"  : %f ", IniSet.chan[CurrentChannel].LowThreshold); 
  InsertTextBoxLine (Pnl, P(ChanInfo_TBX), -1, tmpstr);

  if(IniSet.chan[CurrentChannel].ThresholdRange)
	sprintf(tmpstr,"  :\n    -1,224 ... +1.214 "); 
  else  
	sprintf(tmpstr,"  :\n    -10.19 ... +10,11 "); 
	   
  InsertTextBoxLine (Pnl, P(ChanInfo_TBX), -1, tmpstr);   
	  
  if(IniSet.chan[CurrentChannel].EdgeMode)       
	sprintf(tmpstr," . . :\n    "); 
  else 
	sprintf(tmpstr," . . :\n    "); 
	   
  InsertTextBoxLine (Pnl, P(ChanInfo_TBX), -1, tmpstr);    
		
		
		
		

			break;
		}
	return 0;
}

/**********************************************************************
  
      Base
   
**********************************************************************/

int CVICALLBACK BaseChange_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
	  case EVENT_VAL_CHANGED:
		
	      GetCtrlVal(Pnl, P(Fs_NUM), &IniSet.common.Fs);
		  GetCtrlVal(Pnl, P(Base_NUM), &IniSet.common.Base);
		  
		 // SetCtrlVal(Pnl, P(FreqS_NUM), eval_Fref(IniSet.common.Fs));    
		  SetCtrlVal(Pnl, P(FreqBase_NUM), eval_Fbase(IniSet.common.Fs, IniSet.common.Base));
		  //SetCtrlVal (Pnl, P(AcqTime_NUM), eval_Tw(IniSet.common.Fs, IniSet.common.Base, IniSet.point));       


			break;
		}
	return 0;
}


/**********************************************************************
  
       Fs
   
**********************************************************************/

int CVICALLBACK FsChange_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 
	switch (event)
		{
		case EVENT_VAL_CHANGED:
		
	      GetCtrlVal(Pnl, P(Fs_NUM), &IniSet.common.Fs);
		  GetCtrlVal(Pnl, P(Base_NUM), &IniSet.common.Base);
		  
		  //SetCtrlVal(Pnl, P(FreqS_NUM), eval_Fref(IniSet.common.Fs));    
		  SetCtrlVal(Pnl, P(FreqBase_NUM), eval_Fbase(IniSet.common.Fs, IniSet.common.Base));
		  SetCtrlVal (Pnl, P(AcqTime_NUM), eval_Tw(IniSet.common.Fs, IniSet.common.Base, IniSet.point));       

			break;
		}
	return 0;
}

/*******************************************************************
  
       
    
*******************************************************************/    

int CVICALLBACK Work_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 
 int top, left, height, width;
 int d=25;
 int n;
 int channel;
 int checked;
 char ppath[FNAMELEN+1]; 
 int ChannelsQnt;
 int m;
 int h=0;
 int err;
 int i,j;
 
 
	switch (event)
		{
		case EVENT_COMMIT:

	  getCtrlVals(); 
  
     /* sprintf(ppath, "%s\\%s", theDIR, "pluginuir.uir");
      Pnl_Work= LoadPanelEx (0, ppath, WORK, __CVIUserHInst);
      InstallPopup(Pnl_Work); */ 
  
	 n=numOfLChan();
	 GetNumListItems (Pnl, P(Channels_LST), &ChannelsQnt); 
	 
	 j=0;
	 
	copyIni2Ltr51Struc(&hltr51);  
	err=LTR51_Config(&hltr51);
	
    if(err) 
     {
  
      error_string=LTR51_GetErrorString(err);         
      if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string);               
      return 1;    
     };
     
      sprintf(ppath, "%s\\%s", theDIR, "pluginuir.uir");
      Pnl_Work= LoadPanelEx (0, ppath, WORK, __CVIUserHInst);
      InstallPopup(Pnl_Work);  
     
	
	 for(i=0; i<(hltr51.LChQnt); i++)
	  {
        // ""    
       GetCtrlBoundingRect (Pnl_Work, PW(Channel_NUM), &top, &left, &height, &width);    		
	  
	  
       Channel_Ctrls[i]=DuplicateCtrl(Pnl_Work, PW(Channel_NUM), Pnl_Work,"\0",top+i*25, left); 
       
	   channel=(hltr51.LChTbl[i])&0xF;
	   SetCtrlVal (Pnl_Work, Channel_Ctrls[i], channel+1);  
     
        // ""    
       GetCtrlBoundingRect (Pnl_Work, PW(Freq_NUM), &top, &left, &height, &width);    		
       Frequency_Ctrls[i]=DuplicateCtrl (Pnl_Work, PW(Freq_NUM), Pnl_Work,"\0",top+i*25, left); 
       
         // ""    
       GetCtrlBoundingRect (Pnl_Work, PW(Period_NUM), &top, &left, &height, &width);    		
       Period_Ctrls[i]=DuplicateCtrl (Pnl_Work, PW(Period_NUM), Pnl_Work,"\0",top+i*25, left); 
     
       // ""     
       GetCtrlBoundingRect (Pnl_Work, PW(CorrectHighThr_NUM), &top, &left, &height, &width);    		
       HighThreshold_Ctrls[i]=DuplicateCtrl (Pnl_Work, PW(CorrectHighThr_NUM), Pnl_Work,"\0",top+i*25, left); 
       SetCtrlVal (Pnl_Work, HighThreshold_Ctrls[i], IniSet.chan[channel].HighThreshold);  
     
       // ""     
       GetCtrlBoundingRect (Pnl_Work, PW(CorrectLowThr_NUM), &top, &left, &height, &width);    		
       LowThreshold_Ctrls[i]=DuplicateCtrl (Pnl_Work, PW(CorrectLowThr_NUM), Pnl_Work,"\0",top+i*25, left); 
       SetCtrlVal (Pnl_Work, LowThreshold_Ctrls[i], IniSet.chan[channel].LowThreshold);   
      
       
     
     j++;
     //SetCtrlAttribute (Pnl_Work, PW(CorrectLowThr_NUM), ATTR_VISIBLE, 0); 
       }
     
   SetCtrlAttribute (Pnl_Work, PW(Channel_NUM), ATTR_VISIBLE, 0); 
   SetCtrlAttribute (Pnl_Work, PW(Freq_NUM), ATTR_VISIBLE, 0);   
   SetCtrlAttribute (Pnl_Work, PW(CorrectHighThr_NUM), ATTR_VISIBLE, 0); 
   SetCtrlAttribute (Pnl_Work, PW(CorrectLowThr_NUM), ATTR_VISIBLE, 0); 
   SetCtrlAttribute (Pnl_Work, PW(Period_NUM), ATTR_VISIBLE, 0);  

   
//       ,  ,     
//   

   SetCtrlVal (Pnl_Work, PW(FreqS_NUM), hltr51.Fs);
   SetCtrlVal (Pnl_Work, PW(FreqBase_NUM), hltr51.F_Base);  
   SetCtrlVal (Pnl_Work, PW(Tps_NUM), hltr51.TbaseQnt/*IniSet.point*/); 
   SetCtrlVal (Pnl_Work, PW(Tw_NUM),  hltr51.AcqTime/*eval_Tw(IniSet.common.Fs, IniSet.common.Base, IniSet.point)*/);   
   
	break;
		}
	return 0;
}


// **********     ************
static double eval_Fref(WORD Fs)
{
 double Fref; //      Fs
 
 
 Fref=20E+6/(Fs+1);
 return(Fref);

}


// **********    ************
static double eval_Fbase(double Fs, WORD Base)
{
 double Fbase; //       Base
 
 
 Fbase=Fs/Base;
 return(Fbase);

}

//**********    
static double eval_correct_threshold(double Voltage, int Range)

{
 #define Ku1  (-1.6737)
 #define Ku2  (-0.2010)
 #define Uref (2.048)
 
 int ThresholdCode;
 double CorrectVoltage;
 
  if(Range)
  {
   ThresholdCode=(DWORD) (((128*(Voltage*Ku1+Uref))/Uref)+0.5);
   

   if(ThresholdCode>255)
       ThresholdCode=255;
       
   if(ThresholdCode<0)
       ThresholdCode=0;    
   
  CorrectVoltage=(Uref*(2*ThresholdCode-256))/(Ku1*256);

   
  }
  //    
  else
   {
   ThresholdCode=(DWORD) (((128*(Voltage*Ku2+Uref))/Uref)+0.5);
   

   if(ThresholdCode>255)
       ThresholdCode=255;
       
   if(ThresholdCode<0)
       ThresholdCode=0;    
   
  CorrectVoltage=(Uref*(2*ThresholdCode-256))/(Ku2*256);
   }
  
   return CorrectVoltage;

  }
 
/**************************************************************

   
 
*****************************************************************/


int CVICALLBACK Start_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  DWORD TmpDWord;  
  int err;
  int i;
  FILE *f;
  int BlockCntr=0;
  int TotalBlockCntr=0;
  
  char ppath[FNAMELEN+1]; 
  int Pnl_Stop;
  
  
 // f = fopen("data.txt", "w");
  
	switch (event)
		{
		case EVENT_COMMIT:
		
  
  err=LTR51_Start(&hltr51); 
  if(err) 
   {
    error_string=LTR51_GetErrorString(err);         
    if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string);               
      //closeModule();
    return 1;    
    };

  SetCtrlAttribute (Pnl_Work, PW(ExitWork_BTN), ATTR_DIMMED, 1);
  SetCtrlAttribute (Pnl_Work, PW(Start_BTN), ATTR_DIMMED, 1);    

  runFlag= 1;
  hThread= CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)DataRecorder, 
                        NULL, CREATE_SUSPENDED, (LPDWORD)&TmpDWord);

  ResumeThread(hThread);        // start thread here
  
  
  
   while(runFlag)
    ProcessSystemEvents();
    
   Sleep(500); 
  sprintf(ppath, "%s\\%s", theDIR, "pluginuir.uir");     
  Pnl_Stop= LoadPanelEx (0, ppath, WAIT, __CVIUserHInst);
  SetCtrlVal (Pnl_Stop, WAIT_TEXTMSG, "  ...");
  
  
  InstallPopup(Pnl_Stop);  
    
    
    WaitForMultipleObjects(1, &hThread, TRUE, INFINITE);
    //Sleep(200);
    CloseHandle(hThread);
    
    
  
  err=LTR51_Stop(&hltr51); 
  /*} */
  
  DiscardPanel(Pnl_Stop);
  Pnl_Stop= -1;		    
    
  
   
    SetCtrlAttribute (Pnl_Work, PW(ExitWork_BTN), ATTR_DIMMED, 0);
    SetCtrlAttribute (Pnl_Work, PW(Start_BTN), ATTR_DIMMED, 0);  
     
    if(err) 
     {
  
      error_string=LTR51_GetErrorString(err);         
      if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
      
      //closeModule();
      return 1;    
     };
  
  
  
  
  return 0;
  		
 		break;
		}
	return 0;
}

/**************************************************************

                  
 
*****************************************************************/

int CVICALLBACK Stop_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  int err=0;
  char ppath[FNAMELEN+1]; 
  int Pnl_Stop;
  
	switch (event)
		{
		case EVENT_COMMIT:
		
		
	runFlag=0;	
/*	
  sprintf(ppath, "%s\\%s", theDIR, "pluginuir.uir");     
  Pnl_Stop= LoadPanelEx (0, ppath, WAIT, __CVIUserHInst);
  SetCtrlVal (Pnl_Stop, WAIT_TEXTMSG, "  ...");
  
  
  InstallPopup(Pnl_Stop);  
		
  if(runFlag)
   {
    runFlag= 0;
    WaitForMultipleObjects(1, &hThread, TRUE, INFINITE);
    //Sleep(200);
    CloseHandle(hThread);
    
    
  
  //err=LTR51_Stop(&hltr51); 
  }
  
  DiscardPanel(Pnl_Stop);
  Pnl_Stop= -1;		    
    
  
   
    SetCtrlAttribute (Pnl_Work, PW(ExitWork_BTN), ATTR_DIMMED, 0);
    SetCtrlAttribute (Pnl_Work, PW(Start_BTN), ATTR_DIMMED, 0);  
     
    if(err) 
     {
  
      error_string=LTR51_GetErrorString(err);         
      if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
      
      //closeModule();
      return 1;    
     };
  		   */
		

			break;
		}
	return 0;
}

int CVICALLBACK Channels_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:

			break;
		}
	return 0;
}


//*********  -    ""  

int CVICALLBACK SetPointsQnt_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_VAL_CHANGED:
		
	GetCtrlVal (Pnl, P(PointsQnt_NUM), &IniSet.point);
	SetCtrlVal (Pnl, P(AcqTime_NUM), eval_Tw(IniSet.common.Fs, IniSet.common.Base, IniSet.point));   
		
		
	//evaluate	

			break;
		}
	return 0;
}

//  ""  
static double eval_Tw(WORD Fs, WORD Base, int TpQnt)
 {
  double Tw;
  double tmp1;
  double tmp2;
  
  tmp1=TpQnt*(Fs+1);
  tmp2=Base/20E+6;
  Tw=tmp1*tmp2;
  
  //Tw=TpQnt*(Fs+1)*Base/20E+6;
  return Tw;
 
 
 }


//*********    

int CVICALLBACK ChangeEdgeMode_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 int EdgeMode;
 int AllChannels_Flag=0;
 int i;
 
	switch (event)
		{
		case EVENT_VAL_CHANGED:
		
	GetCtrlVal(Pnl, P(EdgeMode_RNG), &EdgeMode); 
	GetCtrlVal(Pnl, P(AllChannels_CHK), &AllChannels_Flag); 
		  
	if(AllChannels_Flag)
		 {
		  for(i=0;i<16;i++)
		  {
		   IniSet.chan[i].EdgeMode=EdgeMode;  
		   
		  }
		 } 
 	else
	  IniSet.chan[CurrentChannel].EdgeMode=EdgeMode;
	  
			break;
		
		
	 case EVENT_COMMIT:	
	 
	 
	GetCtrlVal(Pnl, P(EdgeMode_RNG), &EdgeMode); 
	GetCtrlVal(Pnl, P(AllChannels_CHK), &AllChannels_Flag); 
		  
	if(AllChannels_Flag)
	 {
	  for(i=0;i<16;i++)
	   {
	    IniSet.chan[i].EdgeMode=EdgeMode;  
	   }
	 }  
	 
	 
	  break;
	}
		
	return 0;
}

//***********   

int CVICALLBACK Close (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
		
		closeModule();	
	     
	     getCtrlVals();  
		 writeINI(); 
		    DiscardPanel(Pnl);
		    Pnl= -1;
		
			break;
		}
	return 0;
}

//**********         

int CVICALLBACK ChangeFreqPrecision_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
 int Precision;
 int i;
 
	switch (event)
		{
		case EVENT_COMMIT:
	
	   GetCtrlVal (Pnl_Work, PW(FreqPrecision_NUM), &Precision);    	
	  
	   
	   for(i=0;i<hltr51.LChQnt;i++)
         SetCtrlAttribute (Pnl_Work, Frequency_Ctrls[i], ATTR_PRECISION, Precision);  

			break;
		}
	return 0;
}


//**********         

int CVICALLBACK ChangePeriodPrecision_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int Precision;
 int i;
 
	switch (event)
		{
		case EVENT_COMMIT:
	
	   GetCtrlVal (Pnl_Work, PW(PeriodPrecision_NUM), &Precision);    	
	  
	   
	   for(i=0;i<hltr51.LChQnt;i++)
         SetCtrlAttribute (Pnl_Work, Period_Ctrls[i], ATTR_PRECISION, Precision);  

			break;
		}
	
	return 0;
}

//***********    

int CVICALLBACK CloseW (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
		
		DiscardPanel(Pnl_Work);

			break;
		}
	return 0;
}

int CVICALLBACK SetAcqTime_NUM (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{

//#define FS (40)
#define F_REF (20000000.0)  
#define BASE_1 (5000)
#define BASE_2 (5000)//(65535)

 int time_ms;
 int SamplesQnt;
 int Base;
 
 double tmp1, tmp2, tmp3;
 
 
	switch (event)
		{
		case EVENT_VAL_CHANGED:
		
  	GetCtrlVal(Pnl, P(AcqTime_NUM), &time_ms);  	
    
  if(time_ms<1000) 
    Base=BASE_1;
  else
    Base=BASE_2;  
     	 
    
     
    
    
    tmp1=time_ms*FS;
    tmp2=1000*Base;
    tmp3=tmp1/tmp2;      
    
    
    SamplesQnt=(int) (tmp3+0.5);   
    
    tmp1=(SamplesQnt*Base)/FS;
  
   
   time_ms=(int) (tmp1*1000.0+0.5); 
   
   SetCtrlVal(Pnl, P(AcqTime_NUM), time_ms); 
   SetCtrlVal(Pnl, P(PointsQnt_NUM), SamplesQnt); 
   
			break;
		}
	return 0;
}

int CVICALLBACK Tmp_CLB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
		
	//SetCtrlVal (PH_Conf, CONF_NUMERICGAUGE, 5);	
		

			break;
		}
	return 0;
}
