#include "uts\\instruments\\te01\\te01api.h"
#include <utility.h>

static TE01 themodule;
int    disconnectTE01(void);

void initTE01(void) {
     TE01Init(&themodule); 
};

int connectTE01(int port) {
 if(themodule.Handle != INVALID_HANDLE_VALUE) disconnectTE01();
 
 port= port + 1;
 if(TE01Open(&themodule, port)) return 1;
 Delay(0.1);

 if(TE01GetConfiguration(&themodule) || TE01ReadMModuleEEPROM(&themodule) ||
    TE01ReadUModuleEEPROM(&themodule) || TE01ReadIModuleEEPROM(&themodule) ||
    TE01ReadAModuleEEPROM(&themodule)) {
    
      disconnectTE01();
      return 1;
 };

 return 0;
}

int disconnectTE01(void) {
 TE01Close(&themodule);
 return 0;
};

 
void *getTE01Handle(void) {
 return (void *)&themodule;
};

