unit ltrapitypes;
interface
uses windows, SysUtils;

const
      COMMENT_LENGTH =256;
      ADC_CALIBRATION_NUMBER =256;
      DAC_CALIBRATION_NUMBER =256;
type
    // char16=array[0..15]of char;
    SERNUMtext=array[0..15]of char;

    TDESCRIPTION_MODULE=packed record
      CompanyName:array[0..15]of char;                     //
      DeviceName:array[0..15]of char;                      //  
      SerialNumber:array[0..15]of char;                    //   
      Revision:byte;                                       //  
      Comment:array[0..COMMENT_LENGTH-1]of char;           //
    end;
//     
    TDESCRIPTION_CPU=packed record
      Active:byte;                                         //     
      Name:array[0..15]of char;                            // 
      ClockRate:double;                                    //
      FirmwareVersion:Cardinal;                            //
      Comment:array[0..COMMENT_LENGTH-1]of char;           //
    end;
//  
    TDESCRIPTION_FPGA=packed record
      Active:byte;                                         //     
      Name:array[0..15]of char;                            // 
      ClockRate:double;                                    //
      FirmwareVersion:Cardinal;                            //
      Comment:array[0..COMMENT_LENGTH-1]of char;           //
    end;
//  
    TDESCRIPTION_ADC=packed record
      Active:byte;                                         //     
      Name:array[0..15]of char;                            // 
      Calibration:array[0..ADC_CALIBRATION_NUMBER-1]of double;//  
      Comment:array[0..COMMENT_LENGTH-1]of char;           //
    end;

    TDESCRIPTION_DAC =packed record
      Active:byte;                                         //     
      Name:array[0..15]of char;                            // 
      Calibration:array[0..ADC_CALIBRATION_NUMBER-1]of double;//  
      Comment:array[0..COMMENT_LENGTH-1]of char;           //
    end;
//  h-
    TDESCRIPTION_MEZZANINE=packed record
      Active:byte;                                         //     
      Name:array[0..15]of char;
      SerialNumber:array[0..15]of char;                    //   
      Revision:Byte;                                       //  
      Calibration:array[0..3]of double;                    //  
      Comment:array[0..COMMENT_LENGTH-1]of char;           // 
    end;
//   
    TDESCRIPTION_DIGITAL_IO=packed record
      Active:byte;                                         //     
      Name:array[0..15]of char;                            //  ???????
      InChannels:word;                                     //  
      OutChannels:word;                                    //  
      Comment:array[0..COMMENT_LENGTH-1]of char;           // 
    end;
//   
    TDESCRIPTION_INTERFACE=packed record
      Active:BYTE;                                         //     
      Name:array[0..15]of char;                            // 
      Comment:array[0..COMMENT_LENGTH-1]of char;           //
    end;
implementation
end.
