unit LTR212REC_THREAD;

interface
uses
  Classes,windows,Graphics,SYNCOBJS,SysUtils,StdCtrls, ltr212api;
const
  POINTS_PER_CHANNEL=1;
type
  LTR212THREAD = class(TThread)
  private
    { Private declarations }
  protected
    procedure Execute; override;
  end;

type
  TOnePoint=record
      CHDATA:array[0..7]of real;
      STARTCOUNT,SECONDCOUNT:integer; 
  end;
  TPage=record
      DATA:array[0..8000]of TOnePoint;
      Writed:byte;//writed flag
      READED:byte;//readed flag
  end;

var
  Edits:array[0..13]of String;
  PAGES:array[0..1]of Tpage;
  MIDDLE_VALUE:TOnePoint;
  NEED_TO_RESET:integer;
  MAX_CH:BYTE;
  NCH:BYTE;
  CAN:Pointer;
  Flag_DO_MESURE:boolean;
  Flag_DO_REC:boolean;
  CS:TCriticalSection;
  LTR212:TLTR212;
  //Registration MODE
  REC_MODE:byte;      // 
  REF_MODE:byte;      //  (0-2.5  1-5)
  CHANNEL_SW:  array[0..7]of boolean;//- 
  CHANNEL_MODE:array[0..7]of byte;//   
  SX,SY,YSS,XSS:real;
  FileToDataWrite:String;
  DoWriteData:String;

  section: tcriticalsection;

implementation
procedure LTR212THREAD.Execute;
var i,err,SIZZE,DataCntr:integer;
    data:array[0..1000]of cardinal;
    Time:array[0..1000]of cardinal;
    voltage:array[0..1000]of real;
    counter,WAITT:integer;
    ED:^TEdit;
    FsT:array[0..2]of integer;
    STOPPS,SECONDS,OLDSTOPPS,OLDSECONDS:integer;
    SpeedCounter,SpeedResult,ResUMax,ResUMin:integer;
begin
  Fst[0]:=7680;
  Fst[1]:=150;
  Fst[2]:=4;
  counter:=0;
  ResUMax:=0;      //LITTLE
  ResUMin:=1000000;//BIG
  Flag_DO_REC:=true;
  WAITT:=Fst[LTR212.AcqMode] div 4;
  // 
  err:=LTR212_Start(@LTR212);
        if err<>0 then
  		  begin
          //
  	  	end;
        SpeedCounter:=0;
        while Flag_DO_MESURE do //,     .
        begin
            // 
            // 
			      SIZZE:=2*POINTS_PER_CHANNEL*NCH;
            DataCntr:=LTR212_Recv(@LTR212, @data, @TIME, SIZZE, 10000);
   			    if(DataCntr<>SIZZE)then  //  
     		    begin
              Flag_DO_MESURE:=false;
     			  end;
		        //         
     		    err:=LTR212_ProcessData(@LTR212, @data, @voltage, @SIZZE, true);
     		    if err<>0 then
            begin
               Flag_DO_MESURE:=false;
     			  end;
            counter:=counter+1;
            SpeedCounter:=SpeedCounter+1;
            if counter>WAITT then
            begin
               counter:=0;
               for i:=0 to NCH-1 do
               begin
                 section.Enter;
                 //(ffGeneral, ffExponent, ffFixed, ffNumber, ffCurrency);
                 Edits[i]:=FloatToStrF(voltage[i],ffFixed,6,6);
                 section.Leave;
               end;
            end;
            STOPPS :=TIME[0] shr 16;
            SECONDS:=TIME[0] - STOPPS shl 16;
            if (OLDSTOPPS<>STOPPS)or(oldseconds<>seconds) then
            begin
              section.Enter;
              SpeedResult:=SpeedCounter;
              SpeedCounter:=0;
              Edits[8]:=inttostr(STOPPS);
              Edits[9]:=inttostr(SECONDS);
              Edits[10]:=inttostr(SpeedResult);
              if NEED_TO_RESET=1 then
              begin
                 ResUMax:=0;      //LITTLE
                 ResUMin:=1000000;//BIG
                 Edits[11]:=inttostr(0);
                 Edits[12]:=inttostr(0);
                 NEED_TO_RESET:=0;
              end;
              if ResUMax<SpeedResult then
              begin
                 ResUMax:=SpeedResult;
                 Edits[11]:=inttostr(ResUMax);
              end;
              if ResUMin>SpeedResult then
              begin
                 ResUMin:=SpeedResult;
                 Edits[12]:=inttostr(ResUMin);
              end;
              section.Leave;
            end;
            OLDSTOPPS:=STOPPS;
            OLDSECONDS:=SECONDS;

            //real data draw
            //
            //
        end;
        // 
        err:=LTR212_Stop(@LTR212); //   
  		  if err<>0 then
  		  begin
    	  end;
  Flag_DO_REC:=false;
end;

end.
