//---------------------------------------------------------------------------

#ifndef LTR34_STREAMH
#define LTR34_STREAMH
//---------------------------------------------------------------------------
#include <Classes.hpp>

#include <C:\\prj\\ltr\\include\\LTR34api.h>
#include <C:\\prj\\ltr\\include\\LTRapi.h>
#include <C:\\prj\\ltr\\include\\LTRapidefine.h>
#include <C:\\prj\\ltr\\include\\LTRapitypes.h>


//      
typedef struct
{
        double StartValue;  // 
        double StopValue;   // 
        double ChangeSpeed; // ,    
        bool  InWork;      //,    .
        byte  MODE;        // 1:1  1:10...
        bool  CH_ON;       //   
        //byte InterType;  // .   .
        //int InterPhase;  // 
}TChannel_Work;

extern  TChannel_Work WORKS[8];    //     .
extern  int WORKS_ON[8];    //  

extern  char    CRATES[CRATE_MAX][SERIAL_NUMBER_SIZE];// -   
extern  int     NOM_CRATES;             //- - 
extern  int     SEL_CRATE;              // - 
extern  int     LTR_ONLINE;
extern  int     MODULES[MODULE_MAX];    // -     .
extern  int     NOM_LTR34;              //-  511
extern  int     SEL_LTR34;              //-   
extern  int     LTR34_ONLINE;
extern  int     LTR34_TOTAL_CH;         //   
extern  TLTR34 LTR34;
extern  TLTR    LTR;

extern bool LTR34STREAM_ON;   //      
extern bool LTRSTREAM_GENERATE;     //  ,   .


//---------------------------------------------------------------------------
class TLTR34_Stream_Thread : public TThread
{            
private:
protected:
        void __fastcall Execute();
public:
        __fastcall TLTR34_Stream_Thread(bool CreateSuspended);
};
//---------------------------------------------------------------------------
#endif
