program Project2;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Windows,
  ltr34api in 'ltr34api.pas';

var
        module:TLTR34;
        Handle: Cardinal;
        gg:string;
        Res:Integer;
        Counter:Integer;
        LTR34_InitTest:function(module1:pTLTR34):Integer;
        Values:array [0..100000] of Double;
begin
  { TODO -oUser -cConsole Main : Insert code here }

  Handle := LoadLibrary('ltr34api.dll');
  if Handle=0 then Writeln('Error Load Dll');
  @LTR34_InitTest:=GetProcAddress(Handle, 'LTR34_Init');
  if @LTR34_InitTest=nil then Writeln('Error Load LTR34_Init');

  Res:=LTR34_Open(@module,module.ltr.saddr,module.ltr.sport,@module.ltr.csn,module.ltr.cc);
  if Res=LTR_OK then
  begin
        Writeln('Module Open Succesfull');
        module.ExternalStart:=false;
        module.FrequencyDivisor:=55;
        module.NumberOfChannel:=0;
        module.AcknowledgeType:=true;
        module.RingMode:=true;

        for Counter := 0 to 100000 do
          Values[Counter]:=Counter;

        Res:=LTR34_SetConfig(@module);
        if Res=LTR_OK then
        begin
                if LTR34_SendData(@module,@Values,100000,10000,false,false)=100000 then
                begin
                        Res:=LTR34_DACStart(@module);
                        if Res=LTR_OK then
                        begin
                                Writeln('Generation Started, Press Any Key To Stop');
                                Read(gg);
                                Res:=LTR34_DACStop(@module);
                                if Res<>LTR_OK then Writeln('Error Stop Generation ',Res)
                                else Writeln('Generation  stopped');

                        end
                        else Writeln('Error Start Generation ',Res);

                end
                else Writeln('Error Send Data ',Res);
        end
        else Writeln('Error Setting Configuration ',Res);
  end
  else Writeln('Error Open module ',Res);

  Writeln('Press any key to exit from application');
  Readln(gg);
  Read(gg);
end.


