// ExampleVC++.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include "ltr\\include\\ltr34api.h"
#include "ltr\\include\\ltrapi.h"
using namespace std;

int _tmain(int argc, _TCHAR* argv[])
{
	int Res=0;

	TLTR * ModuleControl = new TLTR();
	LTR_Init(ModuleControl);

	ModuleControl->cc=0;
	Res=LTR_Open(ModuleControl);
	Res=LTR_SetServerProcessPriority(ModuleControl,HIGH_PRIORITY_CLASS);
	Res=LTR_Close(ModuleControl);

	TLTR34 * module = new TLTR34();

	//  ,   TLTR34   
	Res=LTR34_Open(module,module->ltr.saddr, module->ltr.sport, module->ltr.csn, 1);
	if (Res==LTR_OK)
	{	//        
		module->ExternalStart=false;//   
		module->AcknowledgeType=true; //        -   100 
		module->FrequencyDivisor=55; //   - 222222 
		module->NumberOfChannel=0; //    1 
		module->RingMode=true; //     

		double * Values= new double[10000];

		//      -   
		for (int i=0;i<10000;i++)
		{
			Values[i]=i;
		}
		
		
		
		//    ,  ,    ,
		//    LTR34_Open
		if ((Res=LTR34_SetConfig(module))==LTR_OK)
		{	//  FIFO 
			if (LTR34_SendData(module, Values, 10000, 10000,false,false)==10000)
			{	//  
				if ((Res=LTR34_DACStart(module))==LTR_OK)
				{
					cout<<"Generation Started, enter value and press enter to stop"<<endl;
					char TempValue;					
					cin>>TempValue;
					cout<<"Generation Stoppped"<<endl;
					//  
					if ((Res=LTR34_DACStop(module))==LTR_OK)
					{
					}
					else cout<<"Error Stop DAC "<<Res<<endl;
				}
				else cout<<"Error Start DAC "<<Res<<endl;
			}
			else cout<<"Error Send Data Module "<<Res<<endl;
		}
		else cout<<"Error Set Configuration Module "<<Res<<endl;
	}
	else cout<<"Error Open Module "<<Res<<endl;

	cout<<"enter value and press enter to exit from application";
	cin>>Res;
	return 0;
}

