//---------------------------------------------------------------------------

//   ,    10- 
//       


#pragma hdrstop
 //   


#include "ltr\\include\\ltr43api.h"
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <conio.h>

#define ACQ_BLOCKS_QNT (2) //   ,     
#define TOTAL_BLOCKS_QNT (10) //    
#define POINTS_PER_CHANNEL (256) //        .
#define CHANNELS_QNT (4) //   

TLTR43 hltr43;  //    
HANDLE AcqThreadHnd;   //    

LPCSTR ErrorString;    //      


//        
int oem_printf(const char *s, ...);

//---------------------------------------------------------------------------
int oem_printf(const char *s, ...)
{
 char str[1024];
 va_list list;
 va_start(list, s);
 vsprintf(str, s, list);
 va_end(list);
 CharToOem(str, str);
 return printf(str);
}


#pragma argsused
int main(int argc, char* argv[])
{
DWORD AcqThreadId;
DWORD ThreadSatus;

DWORD OutputWord;
DWORD InputWord;

DWORD OutputArray[5]=
 {
 0x0076D300,
 0x009A3400,
 0x00127600,
 0x00FF7100,
 0x00CA6B00
 };

INT TotalBlockCntr;

INT err;                 //     
INT i;                   //      
CHAR *FirmWare_Version;       //      
CHAR *FirmWare_Date;          //       
CHAR *SerialNum;         //       
CHAR *ModuleName;        //      

int         Channel;
FILE       *DataFile;

/*     .
         . */

 oem_printf("%s", "   \n");
 err=LTR43_Init(&hltr43);

 if(err)
 {
 ErrorString=LTR43_GetErrorString(err);
 oem_printf("%s\n", (CHAR *) ErrorString);
 goto End;
 //return(err);
  }
 else
  oem_printf("LTR43_Init()->OK\n");



//     .      -  
//      ;
//   - 1;
//      - "C:\\prj\\ltr\\LTR-212\\LTR212-ADSP\\ltr212.bio"

err=LTR43_Open(&hltr43, SADDR_DEFAULT, SPORT_DEFAULT, "", CC_MODULE4);
 if(err)
 {
  ErrorString=LTR43_GetErrorString(err);
  oem_printf("%s\n", (CHAR *) ErrorString);
  goto End;
  //return(err);
  }
 else
  oem_printf("LTR43_Open()->OK\n\n");

oem_printf(" : %s\n", hltr43.ModuleInfo.Name);
oem_printf(" : %s\n", hltr43.ModuleInfo.FirmwareVersion);
oem_printf("  : %s\n", hltr43.ModuleInfo.FirmwareDate);
oem_printf("  : %s\n\n", hltr43.ModuleInfo.Serial);

 //        


hltr43.IO_Ports.Port1=0;        //    -
hltr43.IO_Ports.Port2=1;
hltr43.IO_Ports.Port3=1;
hltr43.IO_Ports.Port4=0;

/*       , 10  */
hltr43.StreamReadRate=10000;


/*     */
hltr43.Marks.SecondMark_Mode=1;     //        
hltr43.Marks.StartMark_Mode=2;      //    ""



//     
err=LTR43_Config(&hltr43);
if(err)
 {
 ErrorString=LTR43_GetErrorString(err);
 LTR43_Close(&hltr43);
 oem_printf("%s\n", (CHAR *) ErrorString);
 goto End;
  }
 else
  oem_printf("LTR43_Config()->OK\n\n");


  /*      -.       ,
        , ..  9-24 */

oem_printf("   -  0x00A17400\n");
OutputWord=0x00A17400;

err=LTR43_WritePort(&hltr43, OutputWord);
if(err)
 {
 ErrorString=LTR43_GetErrorString(err);
 LTR43_Close(&hltr43);
 oem_printf("%s\n", (CHAR *) ErrorString);
 goto End;
  }
 else
  oem_printf("LTR43_WritePort()->OK\n\n");

//       -.
//       1-8  25-32, ..    .
//      InputWord   

oem_printf("    -");
err=LTR43_ReadPort(&hltr43, &InputWord);
if(err)
 {
 ErrorString=LTR43_GetErrorString(err);
 LTR43_Close(&hltr43);
 oem_printf("%s\n", (CHAR *) ErrorString);
 goto End;
  }
 else
  oem_printf("LTR43_ReadPort()->OK\n\n");

  oem_printf(" : %\n");

/*     5    - */

err= LTR43_WriteArray(&hltr43,  OutputArray, 1);
if(err)
  {
   ErrorString=LTR43_GetErrorString(err);
   LTR43_Close(&hltr43);
   oem_printf("%s\n", (CHAR *) ErrorString);
   goto End;
  }
else
  oem_printf("LTR43_ReadPort()->OK\n\n");



End:
oem_printf(">>     \n");
    while(!kbhit())
        continue;


        return 0;
}
//---------------------------------------------------------------------------
