#ifndef LtrClientH
#define LtrClientH
#include "common.h"

//---------------------------------------------------------------------------
#define RC_SIZE       (64*1024)
class TControlClientThread : public TThread
{
 private:
    TClient *client;
    BYTE ControlBuffer[EP1K50_SIZE+2];
    DWORD cheader[2];
    WSABUF wsabufcntrl,wsabufcntrlwr;
    WSAOVERLAPPED wsaovcntrl,wsaovcntrlwr;
    
    DWORD RawDataBuffer[RC_SIZE];
 protected:
    void __fastcall Execute();
 public:
    HANDLE init_complete;
    __fastcall TControlClientThread(TClient *_client, bool CreateSuspended);
    __fastcall ~TControlClientThread(void);
    int __fastcall recv(BYTE *buf, DWORD size);
    int __fastcall send(BYTE *buf, DWORD size);
    void __fastcall ack(bool ack_flag);
};
//---------------------------------------------------------------------------
#define CLIENT_RR_N   2
class TReadClientThread : public TThread
{
 private:
    TClient *client;
    DWORD ReadBuffer[CLIENT_RR_N][RC_SIZE];
 protected:
    void __fastcall Execute();
 public:
    HANDLE init_complete;
    bool ReadClientThreadRunning;
    __fastcall TReadClientThread(TClient *_client, bool CreateSuspended);
    __fastcall ~TReadClientThread(void);
};
//---------------------------------------------------------------------------
class TRawReadClientThread : public TThread
{
 private:
    TClient *client;
    DWORD ReadBuffer[CLIENT_RR_N][RC_SIZE];
 protected:
    void __fastcall Execute();
 public:
    HANDLE init_complete;
    bool ReadClientThreadRunning;
    __fastcall TRawReadClientThread(TClient *_client, bool CreateSuspended);
    __fastcall ~TRawReadClientThread(void);
};
//---------------------------------------------------------------------------
class TWriteClientThread : public TThread
{
 private:
    TClient *client;
    WSABUF wsabufw;
    WSAOVERLAPPED wsaovw;
    DWORD WriteBuf[MODULE_SEND_BUF_SIZE];
 protected:
    void __fastcall Execute();
 public:
    HANDLE init_complete;
    bool WriteClientThreadRunning;
    __fastcall TWriteClientThread(TClient *_client, bool CreateSuspended);
    __fastcall ~TWriteClientThread(void);
};

#endif