#ifndef __CHANNEL__
#define __CHANNEL__
#include <Winsock2.h>
#define DATAR_SIZE  (32*1024)
#define DATAW_SIZE  (32*1024)
#define CHANNEL_ERROR_ASYNC_TRANSFER -1

//---------------------------------------------------------------------------
class TChannel {
 private :
    SOCKET socket;
    WSAOVERLAPPED wsaovr, wsaovw;
    WSABUF wsabufr,wsabufw;
    volatile bool ReadSocketInUse;
    volatile bool WriteSocketInUse;
  public :
    int LastError;
    __export TChannel(void);
    __export ~TChannel(void);
    BOOL __export Open(DWORD addr, WORD port);
    BOOL __export Close(void);
    INT __export Recv(BYTE *buf, DWORD size, DWORD timeout);
    INT __export Send(BYTE *buf, DWORD size, DWORD timeout);
};
//---------------------------------------------------------------------------
#endif
