#ifndef __LUSB_COMMONAPI__
#define __LUSB_COMMONAPI__
#include "base.h"
//-----------------------------------------------------------------------------
class TLUSB_COMMON : public virtual ILUSB_COMMON
{
 protected :
    //      USB (vendor request)
    enum
    {
        V_PUT_ARRAY        = 1,
        V_GET_ARRAY        = 2,
    };
 public :
    // /
    TLUSB_COMMON();
    //virtual ~TLUSB_COMMON();
    //  
    virtual bool WINAPI GetArray(DWORD address, BYTE *data, DWORD size);
    virtual bool WINAPI PutArray(DWORD address, BYTE *data, DWORD size);
    //    
    virtual bool WINAPI ReadData (LPBYTE lpBuffer, LPDWORD lpNumberOfBytesToRead , LPDWORD lpNumberOfBytesRead , LPOVERLAPPED lpOverlapped);
    virtual bool WINAPI WriteData(LPBYTE lpBuffer, LPDWORD lpNumberOfBytesToWrite, LPDWORD lpNumberOfBytesWrite, LPOVERLAPPED lpOverlapped);
    //    
    virtual bool WINAPI SyncReadData (LPBYTE lpBuffer, LPDWORD lpNumberOfBytesToRead,  DWORD TimeOut);
    virtual bool WINAPI SyncWriteData(LPBYTE lpBuffer, LPDWORD lpNumberOfBytesToWrite, DWORD TimeOut);

};
//-----------------------------------------------------------------------------
#endif


