#ifndef LtrCrateThreadsH
#define LtrCrateThreadsH
//---------------------------------------------------------------------------
struct CRATE_REQUEST
    {
    DWORD *buf;
    LPOVERLAPPED hOver;
    HANDLE hEvent;
    };
//---------------------------------------------------------------------------
class TReadUSBCrateThread : public TThread
    {
private:
    TCrateUSB *crate;
    DWORD ReadOverlappedBuffer[(CRATE_RR_N+1)*CRATE_RR_SIZE_MAX_DWORD]; // +1 -  raw data
    CRATE_REQUEST rreq[CRATE_RR_N];
protected:
    void __fastcall Execute(void);
public:
    HANDLE init_complete;
    __fastcall TReadUSBCrateThread(TCrateUSB *_crate, bool CreateSuspended);
    __fastcall ~TReadUSBCrateThread(void);
    };
//---------------------------------------------------------------------------
class TWriteUSBCrateThread : public TThread
    {
private:
    TCrateUSB *crate;
    DWORD WriteOverlappedBuffer[CRATE_WR_N*CRATE_WR_SIZE_MAX_DWORD];
    CRATE_REQUEST wreq[CRATE_WR_N];
protected:
    void __fastcall Execute(void);
public:
    HANDLE init_complete;
    __fastcall TWriteUSBCrateThread(TCrateUSB *_crate, bool CreateSuspended);
    __fastcall ~TWriteUSBCrateThread(void);
    };
//---------------------------------------------------------------------------
class TIPCratePingThread : public TThread
    {
private:
    TCrateIP *crate;
    HANDLE hTermEvent;
protected:
    void __fastcall Execute(void);
public:
    __fastcall TIPCratePingThread(TCrateIP *_crate, bool CreateSuspended);
    __fastcall ~TIPCratePingThread(void);
    void __fastcall TerminateByEvent(void);
    };
//---------------------------------------------------------------------------
class TIPCrateDataThread : public TThread
    {
private:
    TCrateIP *crate;
    BYTE SendBuf[CRATE_IP_SEND_BUF_SIZE];
    BYTE RecvBuf[CRATE_IP_RECV_BUF_SIZE];
protected:
    void __fastcall Execute(void);
public:
    HANDLE init_complete;
    __fastcall TIPCrateDataThread(TCrateIP *_crate, bool CreateSuspended);
    __fastcall ~TIPCrateDataThread(void);
    };

#endif
