#ifndef MessageQueueH
#define MessageQueueH

//---------------------------------------------------------------------------
//  0 - 
//---------------------------------------------------------------------------

typedef struct
    {
    DWORD dwMessage;
    DWORD dwParam;
    }
    T_Message;
//#define ZeroMessage NULL

class T_MessageQueue
{
 private:
    HANDLE MessagePostEvent;
    HANDLE MessagePostObject;
    HANDLE MessagePopObject;
    T_Message * Messages;
    __int64 MaxMessages;
    __int64 MessageNumberAdd;   //     ,  -,
                                //        
    __int64 MessagePostCounter;
    __int64 MessagePopCounter;
    DWORD MessagePostPointer;
    DWORD MessagePopPointer;
    bool Initialized;
 public:
    void __fastcall PostMessage(const T_Message &Mes);
    void __fastcall PostMessage(DWORD dwNewMessage, DWORD dwNewParam = 0);
    DWORD __fastcall GetMessageCounter();
    BOOL __fastcall PopMessage(T_Message * Mess);
    BOOL __fastcall PopMessage(T_Message * Mess, DWORD Timeout_ms);
    DWORD __fastcall WaitForMessage(DWORD Timeout_ms);
    DWORD __fastcall WaitForNewMessage(DWORD Timeout_ms);
    //DWORD __fastcall WaitForMessage(T_Message * Mess, DWORD Timeout_ms);

    T_MessageQueue(DWORD NumMessages, DWORD MessageAddCount);
    ~T_MessageQueue(void);
};
//---------------------------------------------------------------------------
#endif
